var AISEOTDK = {
    // "title": "Google Marketing: The Key to Digital Success",
    // "description": "Explore how Google’s marketing tools like Google Ads, Analytics, and AI-driven solutions can help businesses achieve targeted marketing and sustainable growth.",
    // "keywords": ["Google marketing", "Google Ads", "SEO", "Google Analytics", "AI automation"],
    // "excerpt": "Learn how Google’s marketing ecosystem empowers businesses with precise targeting, data-driven decisions, and innovative tools for growth in the digital era.",
    // "outline": [
    //     "Introduction to Google’s role in modern marketing",
    //     "Google Ads: Leveraging targeted ads for customer reach",
    //     "Google Analytics: Making data-driven marketing decisions",
    //     "SEO: Enhancing organic traffic and site visibility",
    //     "Google My Business: Boosting local business presence",
    //     "AI & Automation: Increasing marketing efficiency with smart solutions",
    //     "Google Trends: Capturing market dynamics for better strategy"
    // ]
}

var regeneratePrompt = ''
var layerindex = ''
var finalprompt = ''
var outputcontent = `**新冠病毒 | 秒懂百科** `
var contentoutputId = 'output-content'

// Image info SEO
var allImgsPrompts = ''

window.addEventListener("DOMContentLoaded", function () {

    setInterval(() => {
        if (document.querySelector("#ai-input")) {
            let inputprompt = document.querySelector("#ai-input").value
            inputprompt = `Title\\Topic\\Keywords\\Content: ${inputprompt};<br>${finalprompt}`
            const finalpromptext = document.querySelector("#finalpromptext")
            if (finalprompt) {
                document.querySelector("#finalpromptext").innerHTML = inputprompt
            }
        }
    }, 2000);



    layui.use(function () {
        var layer = layui.layer;
        var util = layui.util;
        var table = layui.table;
        var $ = layui.$;
        var element = layui.element;
        var form = layui.form;
        var db = new PromptDatabase();

        var aiseosettingLayerindex = null
        var MorepromptLayer = null
        var SEOTDKSettingLayerindex = null
        var SEOImageSettingLayerindex = null
        var SEOTDKSettingParam = null
        var GenerateIndependentlyLayerindex = null
        var freeimageLayerindex = null
        

        const mtabchange = ((layid, title, content, handle) => {
            if (document.querySelector(`[lay-id=\"${layid}\"]`)) {
                element.tabDelete(handle, layid);
            }
            element.tabAdd(handle, {
                title: title,
                content: content,
                id: layid, // 实际使用一般是规定好的id，这里以毫秒数模拟
                change: true // 是否添加完毕后即自动切换
            })
            element.tabChange(handle, layid);
        })

        const openaichat = (() => {

            db.checkPromptCount().then(result => {
                console.log('Prompt count result:', result); // Logs 0 if less than 10, otherwise the actual count
                if (result == 0) {
                    layer.msg('Please Activate your account first')
                    layer.msg('Loading the AI prompts,please wait!')
                    SyncPromptsFromContentaiseo(db)
                }
            });
            layer.open({
                title: 'AI - assistant',
                maxmin: true,
                type: 1,
                offset: 'r',
                anim: 'slideRight', // 从左往右
                area: ['330px', '100%'],
                shade: 0,
                shadeClose: true,
                id: 'ID-ai-helper',
                content: `<div style="padding: 2px;">

                         <div class="layui-tab" lay-filter="chat-handle" lay-allowclose="true">
                        <ul class="layui-tab-title">
                            <li class="layui-this" lay-id="11">Chat_0</li>
                        </ul>
                        <div id="markedown" class="layui-tab-content">
                            <div class="layui-tab-item layui-show">
                            <div class="output-content-css" id="output-content"></div>
                            </div>
                        </div>
                        </div>

                        <textarea id="ai-input" class="layui-textarea" placeholder="input..."></textarea>
                        <div id="minsetting">
                        <button title="AI API Params" lay-on="advancedParameters" type="button" class="layui-btn layui-bg-cyan layui-btn-xs">
                        <i class="layui-icon layui-icon-util"></i> Params
                        </button>
                        <button title="Zoom in edit" lay-on="zoomineditais" type="button" class="layui-btn layui-bg-cyan layui-btn-xs">
                        <i class="layui-icon layui-icon-add-circle"></i> Zoom
                        </button>
                        <button title="Image Generator" lay-on="imagegenerator" type="button" class="layui-btn layui-bg-cyan layui-btn-xs">
                        <i class="layui-icon layui-icon-picture"></i> Image
                        </button>
                        <button title="Video Screenshot" lay-on="VideoScreenshot" type="button" class="layui-btn layui-bg-cyan layui-btn-xs">
                        <i class="layui-icon layui-icon-picture"></i> Video
                        </button>
                        <button title="AI SEO Setting" lay-on="aiseosetting" type="button" class="layui-btn layui-bg-cyan layui-btn-xs">
                        <i class="layui-icon layui-icon-util"></i> SEO
                        </button>
                        <button title="Article Generator" lay-on="articleGenerator" id="articleGenerator" type="button" class="layui-btn layui-bg-cyan layui-btn-xs">
                        <i class="layui-icon layui-icon-file"></i> Article
                        </button>
                        <button title="echart" lay-on="echartfunc" id="echartfunc" type="button" class="layui-btn layui-bg-cyan layui-btn-xs">
                        <i class="layui-icon layui-icon-chart"></i> Echart
                        </button>
                         </div>
                         <button lay-on="generate-c" id="generate-doc" class="layui-btn layui-btn-xs layui-bg-cyan" style="margin-top: 10px;">Generate</button>
                         <button title="Save the currently active dialogue" lay-on="savechat" id="save-doc" class="layui-btn layui-btn-xs layui-bg-cyan" style="margin-top: 10px;">Save</button>
                         <button title="building a new chat" lay-on="newchat" id="newchat" class="layui-btn layui-btn-xs layui-bg-cyan" style="margin-top: 10px;">New</button>
                         <button lay-on="openquickprompt" id="openquickprompt" class="layui-btn layui-btn-xs layui-bg-cyan" style="margin-top: 10px;">Quick Prompt</button>
                         <label class="verticalcss" title="Continuous Dialogue,But it will consume more tokens">Chat</label>
                         <input class="verticalcss" title="Continuous Dialogue,But it will consume more tokens" type="checkbox" name="continuousdialogue" lay-text="Continuous Dialogue">
                         <div title="mini prompt,quickly integrate with input content" id="toolinputcontainer">    
                         <div id="toolinput" class="layui-form-item radio-1">

                        </div>
                        <span lay-on="Moreprompt" id="morepromptaia"  class="layui-badge layui-bg-cyan">More</span>
                         </div>
                         <div class="">
                            <select id="FormatSelect" lay-search="">
                            <option value="none">None</option>
                            </select>
                            <button id="PromptApply" lay-on="PromptApply" type="button" class="layui-btn layui-bg-cyan layui-btn-sm">Apply</button>
                        </div>
                        
                     </div>`,
                success: function (layero, index) {

                    var form = layui.form;
                    form.render();

                    let addRadioComponentToFront = ((containerId, name, value, label) => {
                        const newComponent = `
                            <input type="radio" name="${name}" value="${value}" title="${label}" onchange="updateSelect(this.value)">
                            <label for="${value}">${label}</label>
                        `;
                        $(`#${containerId}`).prepend(newComponent);
                    })
                    const options = [
                        { name: 'r3', value: 'none', label: 'none' },
                        { name: 'r3', value: 'format', label: 'format' },
                        { name: 'r3', value: 'snippet', label: 'snippet' },
                    ];
                    let aitoolsvalue_ = localStorage.getItem('aiminitools') ?? "quickSEM;WritingContent;SEO"
                    let aitoolsvalue = aitoolsvalue_.split(";");
                    aitoolsvalue.forEach(ele => {
                        options.unshift({ name: 'r3', value: ele, label: ele })
                    });
                    options.reverse()
                    const options1 = options.slice(0, 6)
                    options1.reverse()
                    options1.forEach(option => {
                        addRadioComponentToFront('toolinput', option.name, option.value, option.label);
                    });

                },

            });
        })

        element.on('tab(chat-handle)', function (data) {
            // console.log(this); // 当前 tab 标题所在的原始 DOM 元素
            // console.log(data.index); // 得到当前 tab 项的所在下标
            // console.log(data.elem); // 得到当前的 tab 容器
            // console.log(data.id); // 得到当前的 tab ID(2.9.11+)

            var activeTab = $('#markedown .layui-tab-item.layui-show');
            var contentId = activeTab.find('.output-content-css').attr('id');
            contentoutputId = contentId

        });

        util.on('lay-on', {
            'copyimg': function () {

                // 将内容写入剪贴板
                navigator.clipboard.writeText('<p>This is pasted content!</p>')
                    .then(() => {
                        console.log('内容已写入剪贴板');
                    })
                    .catch(err => {
                        console.error('剪贴板写入失败: ', err);
                    });

                // 从剪贴板读取并插入到 Gutenberg 编辑器
                navigator.clipboard.readText()
                    .then(text => {
                        // 假设读取的内容是 HTML，可以将它插入到 Gutenberg 编辑器
                        wp.data.dispatch('core/block-editor').insertBlocks(
                            wp.blocks.createBlock('core/paragraph', { content: text })
                        );
                    })
                    .catch(err => {
                        console.error('从剪贴板读取失败: ', err);
                    });

            },
            'aiseosetting': function () {

                if (aiseosettingLayerindex) {
                    layer.msg('Layer is already open!', { icon: 5 });
                    return;
                }
                const SEOsettingDOM = `<div style="padding: 32px;"><div class="layui-btn-container">
                                    <button lay-on="SEOTDKSetting" type="button" class="tb layui-btn">SEO TDK Setting</button>
                                    <button lay-on="SEOImageSetting" type="button" class="tb layui-btn layui-bg-blue">SEO Image Setting</button><br>
                                    <button lay-on="COPYarticlebody" type="button" class="tb layui-btn layui-btn-sm layui-bg-blue">Copy article body</button>
                                    <button lay-on="replaceotimage" type="button" class="tb layui-btn layui-btn-sm layui-bg-blue">Replace Open_graph and twitter_card image</button>
                                    </div></div>`

                // 在此处输入 layer 的任意代码
                aiseosettingLayerindex = layer.open({
                    type: 1, // page 层类型
                    area: ['500px', '300px'],
                    title: 'SEO Settings',
                    shade: 0, // 遮罩透明度
                    shadeClose: false, // 点击遮罩区域，关闭弹层
                    maxmin: true, // 允许全屏最小化
                    anim: 0, // 0-6 的动画形式，-1 不开启
                    content: SEOsettingDOM,
                    btn: ['Close'],
                    yes: function (index, layero) {
                        // 关闭弹出层时清除 index
                        layer.close(index);
                        aiseosettingLayerindex = null;
                    },
                    // 监听弹出层关闭事件，不管是点击背景，点击关闭按钮，还是通过 API 关闭
                    end: function () {
                        aiseosettingLayerindex = null;
                    }
                });

                wp.domReady(() => {

                    const getText = (() => {
                        // 获取当前文章的标题
                        const title = wp.data.select('core/editor').getEditedPostAttribute('title');
                        // 获取当前文章的内容
                        const content = wp.data.select('core/editor').getEditedPostAttribute('content');

                        // 将内容从 HTML 格式转为纯文本
                        const pureContent = content.replace(/<[^>]*>/g, ''); // 去掉所有 HTML 标签
                        const pureTitle = title.replace(/<[^>]*>/g, ''); // 如果标题中有 HTML 标签，也可以去掉

                        const cleanContent = pureContent.replace(/^\s*[\r\n]/gm, '').trim(); // 删除空行，并去除前后空格
                        // 打印纯文本标题和内容
                        console.log('纯文本标题:', pureTitle);
                        console.log('纯文本内容:', cleanContent);

                        localStorage.setItem('SEOTDKarticle', `${pureTitle};${cleanContent}`);
                    })
                    getText()

                });

            },
            'SEOTDKSetting': function () {

                if (SEOTDKSettingLayerindex) {
                    layer.msg('Layer is already open!', { icon: 5 });
                    return;
                }

                const SEOsettingDOM = `<div style="padding: 32px;">
                                    <div class="layui-tab" lay-filter="SEOTDKSetting-handle" lay-allowclose="true">
                                        <ul class="layui-tab-title">
                                            <li class="layui-this" lay-id="11">Setting</li>
                                        </ul>
                                        <div class="layui-tab-content">
                                            <div class="layui-tab-item layui-show"><button lay-on="SEOTDKSetting2" type="button" class="layui-btn">Submit</button><div id="SEOTDKSetting"></div></div>
                                        </div>
                                        </div>
                                    </div>`

                // 在此处输入 layer 的任意代码
                SEOTDKSettingLayerindex = layer.open({
                    type: 1, // page 层类型
                    area: ['800px', '600px'],
                    title: 'SEO TDK Settings',
                    shade: 0, // 遮罩透明度
                    shadeClose: false, // 点击遮罩区域，关闭弹层
                    maxmin: true, // 允许全屏最小化
                    anim: 0, // 0-6 的动画形式，-1 不开启
                    content: SEOsettingDOM,
                    btn: ['Close'],
                    yes: function (index, layero) {
                        // 关闭弹出层时清除 index
                        layer.close(index);
                        SEOTDKSettingLayerindex = null;
                    },
                    // 监听弹出层关闭事件，不管是点击背景，点击关闭按钮，还是通过 API 关闭
                    end: function () {
                        SEOTDKSettingLayerindex = null;
                    },
                    success: async function (layero, index) {
                        let settingarr = []
                        let promptsOption = await db.getAllPromptByTag('SEOGenerateTDK')
                        mlog(promptsOption)
                        let promptnames = ""
                        if (promptsOption.length != 0) {
                            promptsOption.forEach(ele => {
                                promptnames = promptnames + ele.name + ','
                            });
                        }
                        settingarr.push({
                            'title': 'AI Generating Prompt',
                            'content': `#${promptnames}#`
                        })
                        settingarr.push({
                            'title': 'How many return results',
                            'content': 1
                        })

                        let containerID = 'SEOTDKSetting'
                        settingarr = JSON.stringify(settingarr)

                        promptDomGenerator(settingarr, containerID)
                    }
                });
            },
            'SEOTDKSetting2': function () {
                SEOTDKSettingParam = getAllValueInput('SEOTDKSetting')
                //转化成字典
                SEOTDKSettingParam = SEOTDKSettingParam.reduce((acc, item) => {
                    acc[item.title] = item.content;
                    return acc;
                }, {});

                localStorage.setItem('returncounts', SEOTDKSettingParam['How many return results']);
                let promptnotes = 'Note that the content of the return field cannot be modified and must be mimicked when customizing any prompts'

                let layid = '2'
                let content = `<div class="promptnotes">${promptnotes}</div><button lay-on="SEOTDKSetting3" class="layui-btn layui-btn-warm">Submit</button><div id="AISEOPromptSetting"></div>`
                let title = '2.AI SEO Prompt Setting'
                let handle = 'SEOTDKSetting-handle'
                mtabchange(layid, title, content, handle)

                db.getPromptByName(SEOTDKSettingParam['AI Generating Prompt']).then((res) => {

                    let containerID = 'AISEOPromptSetting'
                    promptDomGenerator(res.prompt, containerID)
                })
            },
            'SEOTDKSetting3': async function () {
                var finalaiSEOPrompts = getAllValueInput('AISEOPromptSetting')
                finalaiSEOPrompts = promptGenerator(finalaiSEOPrompts)

                let layid = '3'
                let content = `<button lay-on="SEOTDKGenerator" class="layui-btn layui-btn-warm">Update SEOTDK</button>
                <button lay-on="replaceotimage" class="layui-btn layui-btn-warm">Replace Open_graph and twitter_card image and link</button>
                <div style="margin: 10px 0;"><label class="switch-slide"><input type="checkbox" id="titletdkcheckbox" hidden /><label for="titletdkcheckbox" class="switch-slide-label">title</label></label>
                <label class="switch-slide"><input type="checkbox" id="destdkcheckbox" hidden checked /><label for="destdkcheckbox" class="switch-slide-label">description</label></label>
                <label class="switch-slide"><input type="checkbox" id="kwtdkcheckbox" hidden checked /><label for="kwtdkcheckbox" class="switch-slide-label">keywords</label></label>
                <label class="switch-slide"><input type="checkbox" id="excepttdkcheckbox" hidden checked /><label for="excepttdkcheckbox" class="switch-slide-label">except</label></label>
                <label class="switch-slide"><input type="checkbox" id="opengraphtdkcheckbox" hidden checked /><label for="opengraphtdkcheckbox" class="switch-slide-label">open_graph</label></label>
                <label class="switch-slide"><input type="checkbox" id="twtdkcheckbox" hidden checked /><label for="twtdkcheckbox" class="switch-slide-label">twitter_card</label></label></div>
                <div style="margin: 10px 0;" id="tdkcontentcontainer"></div>`
                let title = '3.AI SEO TDK Update SEOTDK'
                let handle = 'SEOTDKSetting-handle'
                mtabchange(layid, title, content, handle)

                let SEOTDKarticle = localStorage.getItem('SEOTDKarticle');

                finalaiSEOPrompts = `${finalaiSEOPrompts}contents: ${SEOTDKarticle}`

                let rcounts = parseInt(localStorage.getItem('returncounts'))

                let articlecontent = null
                let result = await mergePromptSend(finalaiSEOPrompts, save = '00', returncounts = rcounts, jsonformat = '11')
                articlecontent = result['dataresult']
                // articlecontent = localStorage.getItem("tdk")

                if (typeof articlecontent == 'string') {
                    articlecontent = [articlecontent]
                }

                const $container = $('#tdkcontentcontainer');
                try {
                    articlecontent.forEach((text, index) => {

                        // let text1 = extractJson(text)
                        let text1 = text
                        const radioHtml = `
                       <div class="radio-option-aiseo">
                       <input type="radio" name="replytdk" data-json="${encodeURIComponent(JSON.stringify(JSON.parse(text1)))}" value="tdkid${index}">
                       <pre id="tdkid${index}" class="json-view-aiseo" contenteditable="true">${JSON.stringify(JSON.parse(text1), null, 2)}</pre>
                       </div>
                        `;
                        $container.append(radioHtml);
                    });
                } catch (error) {
                    layer.msg(articlecontent, {
                        time: 10000
                    })
                }
                return

            },
            'SEOTDKGenerator': function () {
                const titlecheck = document.getElementById('titletdkcheckbox').checked;
                const destdkcheckbox = document.getElementById('destdkcheckbox').checked;
                const kwtdkcheckbox = document.getElementById('kwtdkcheckbox').checked;
                const excepttdkcheckbox = document.getElementById('excepttdkcheckbox').checked;
                const opengraphtdkcheckbox = document.getElementById('opengraphtdkcheckbox').checked;
                const twtdkcheckbox = document.getElementById('twtdkcheckbox').checked;
                // mlog(checkbox)
                // alert('title')
                // return

                const selected = document.querySelector('input[name="replytdk"]:checked');
                if (!selected) {
                    alert('Please select an option first');
                    return;
                }

                const choice_id = document.querySelector('input[name="replytdk"]:checked').value;
                const json = JSON.parse(document.getElementById(choice_id).innerText);


                if (json && typeof json === 'object') {
                    AISEOTDK = json;
                } else {
                    alert('No value selected')
                    return;
                }
                //json key一律变成小写
                AISEOTDK = normalizeKeys(AISEOTDK)
                if (titlecheck) {
                    wp.data.dispatch('core/editor').editPost({
                        title: AISEOTDK['title']
                    });
                }
                if (excepttdkcheckbox) {
                    wp.data.dispatch('core/editor').editPost({
                        excerpt: AISEOTDK['excerpt']
                    });
                }
                if (destdkcheckbox) {
                    document.getElementById('content_ai_seo_description').value = AISEOTDK['description'] ?? ''
                }
                if (kwtdkcheckbox) {
                    document.getElementById('content_ai_seo_keywords').value = AISEOTDK['keywords'] ?? ''
                }
                if (opengraphtdkcheckbox) {
                    document.getElementById('content_ai_seo_open_graph').value = processOpengraph(JSON.stringify(AISEOTDK['open_graph'])) ?? ''
                } if (twtdkcheckbox) {
                    document.getElementById('content_ai_seo_twitter_card').value = processOpengraph(JSON.stringify(AISEOTDK['twitter_card'])) ?? ''
                }

                // 检测 Yoast SEO 或 Rank Math 插件，并更新相应的 SEO 字段
                if (typeof yoast !== 'undefined' && yoast !== null) {
                    console.log('当前使用的是 Yoast SEO 插件');
                    wp.data.dispatch('core/editor').editPost({
                        meta: {
                            '_yoast_wpseo_metadesc': AISEOTDK['description'],
                            '_yoast_wpseo_keywords': AISEOTDK['keywords']
                        }
                    });
                } else if (typeof rankMath !== 'undefined' && rankMath !== null) {
                    console.log('当前使用的是 Rank Math 插件');
                    wp.data.dispatch('core/editor').editPost({
                        meta: {
                            '_rank_math_description': AISEOTDK['description'],
                            '_rank_math_focus_keyword': AISEOTDK['keywords']
                        }
                    });
                } else {
                    console.log('未检测到 Yoast SEO 或 Rank Math 插件');
                }
                layer.msg('Done')
            },
            'SEOImageSetting': function () {
                if (SEOImageSettingLayerindex) {
                    layer.msg('Layer is already open!', { icon: 5 });
                    return;
                }
                const SEOImgDOM = `<div style="padding: 32px;">
                                    <div class="layui-tab" lay-filter="SEOImg-handle" lay-allowclose="true">
                                        <ul class="layui-tab-title">
                                            <li class="layui-this" lay-id="11">Setting</li>
                                        </ul>
                                        <div class="layui-tab-content">
                                            <div class="layui-tab-item layui-show">
                                            <button id="bulkgeneratorImginfo" class="layui-btn bulkgeneratorImginfo">Generate Imgs Info Bulk</button>
                                            <select id="bulkgeneratorImginfoPromptSelect">
                                            <option value="">Select Prompt For Bulk</option>
                                            </select>
                                            <button id="bulkgeneratorImginfosetting" class="layui-btn layui-btn-sm">Prompt Setting</button>
                                            <div id="bulkgeneratorImginfopromptcontainer"></div>
                                            <button id="updateAllImgAlt" class="layui-btn">Update and insert all images datas</button>
                                            <table id="SEOImgContainer">
                                                <thead>
                                                    <tr>
                                                        <th>Image</th>
                                                        <th>Client ID</th>
                                                        <th>Description</th>  <!-- 新增的描述列 -->
                                                        <th>Action</th>
                                                    </tr>
                                                </thead>
                                                <tbody></tbody>
                                            </table>
                                            <!-- 添加按钮用于获取整个表格的数据 -->
                                            <button id="bulkgeneratorImginfo" class="layui-btn bulkgeneratorImginfo">Generate Imgs Info Bulk</button>
                                            </div>
                                        </div>
                                        </div>
                                    </div>`

                // 在此处输入 layer 的任意代码
                SEOImageSettingLayerindex = layer.open({
                    type: 1, // page 层类型
                    area: ['100%', '100%'],
                    title: 'SEO Imgs datas Tables',
                    shade: 0, // 遮罩透明度
                    shadeClose: false, // 点击遮罩区域，关闭弹层
                    maxmin: true, // 允许全屏最小化
                    anim: 0, // 0-6 的动画形式，-1 不开启
                    content: SEOImgDOM,
                    btn: ['Close'],
                    yes: function (index, layero) {
                        // 关闭弹出层时清除 index
                        layer.close(index);
                        SEOImageSettingLayerindex = null;
                    },
                    // 监听弹出层关闭事件，不管是点击背景，点击关闭按钮，还是通过 API 关闭
                    end: function () {
                        SEOImageSettingLayerindex = null;
                    },
                    success: async function (layero, index) {

                        let selectElement = document.getElementById('bulkgeneratorImginfoPromptSelect');
                        let tag = 'SEOGenerateImgInfo'
                        db.getAllPromptByTag(tag).then(res => {
                            console.log(res)
                            // 调用函数填充选项
                            populateOptionsFromArrayAss(res, selectElement);
                            selectElement.addEventListener("change", async (event) => {

                            })
                        })
                    }
                });
                const imagecontrol = (() => {
                    wp.domReady(() => {
                        // 获取所有的图片块
                        const blocks = wp.data.select('core/block-editor').getBlocks();
                        const imageBlocks = blocks.filter(block => block.name === 'core/image');

                        // 获取表格的 tbody 部分
                        const tableBody = document.querySelector('#SEOImgContainer tbody');

                        // 遍历所有图片块并生成表格行
                        imageBlocks.forEach(block => {
                            const imageUrl = block.attributes.url;
                            const clientId = block.clientId;

                            // 创建一个表格行
                            const row = document.createElement('tr');
                            row.id = clientId + '-row';

                            // 创建图片单元格
                            const imgCell = document.createElement('td');
                            const imgElement = document.createElement('img');
                            imgElement.src = imageUrl;
                            imgElement.alt = "Image";
                            imgCell.appendChild(imgElement);

                            // 创建 Client ID 单元格
                            const clientIdCell = document.createElement('td');
                            clientIdCell.textContent = clientId;
                            clientIdCell.id = clientId + '-td';

                            // 创建 Description 单元格 (使用 textarea)
                            const descriptionCell = document.createElement('td');
                            const descriptionTextarea = document.createElement('textarea');
                            const showImgInfo = document.createElement('div');
                            showImgInfo.id = clientId + '-img';
                            descriptionTextarea.placeholder = 'Enter keywords or brief description here'; // 提示文本
                            descriptionTextarea.value = ''; // 初始值为空，可以根据需求设定默认值
                            descriptionCell.appendChild(descriptionTextarea);
                            descriptionCell.appendChild(showImgInfo);

                            // 创建按钮单元格
                            const buttonCell = document.createElement('td');
                            const button = document.createElement('button');

                            button.textContent = 'Generate Independently';

                            // 设置按钮点击事件
                            button.addEventListener('click', () => {
                                console.log('Image URL:', imageUrl);
                                console.log('Client ID:', clientId);
                                console.log('Description:', descriptionTextarea.value); // 获取用户输入的描述

                                if (GenerateIndependentlyLayerindex) {
                                    layer.msg('Layer is already open!', { icon: 5 });
                                    return;
                                }

                                const SEOImgDOM = `<div style="padding: 32px;">
                                    <div class="layui-tab" lay-filter="SEOImgx-handle" lay-allowclose="true">
                                        <ul class="layui-tab-title">
                                            <li class="layui-this" lay-id="11">Setting</li>
                                        </ul>
                                        <div class="layui-tab-content">
                                            <div class="layui-tab-item layui-show">
                                            <div class="layui-btn layui-btn-primary layui-border">Image Description: </div>
                                            <textarea id="imagedes" name="imagedes" class="layui-textarea">${descriptionTextarea.value}</textarea>
                                            <table title="click to edit" lay-filter="IDtablepromptimgbar" class="layui-hide" id="ID-table-prompt-img"></table>
                                            <button id="generatorImginfo" class="layui-btn">Generate</button>
                                            <select id="GenerateIndependentlyImginfoPromptSelect">
                                            <option value="">Select Prompt</option>
                                            </select>
                                            <button id="SEOimgInfoPromptpart2" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Prompt part</button>
                                            <button id="SEOimgInfoEmptyPart2" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Empty Part</button>
                                            <div id="GenerateIndependentlypromptcontainer"></div>
                                           
                                            </div>
                                        </div>
                                        </div>
                                    </div>`

                                // 在此处输入 layer 的任意代码
                                GenerateIndependentlyLayerindex = layer.open({
                                    type: 1, // page 层类型
                                    area: ['50%', '50%'],
                                    title: 'Generate Independently',
                                    shade: 0, // 遮罩透明度
                                    shadeClose: false, // 点击遮罩区域，关闭弹层
                                    maxmin: true, // 允许全屏最小化
                                    anim: 0, // 0-6 的动画形式，-1 不开启
                                    content: SEOImgDOM,
                                    btn: ['Close'],
                                    yes: function (index, layero) {
                                        // 关闭弹出层时清除 index
                                        layer.close(index);
                                        GenerateIndependentlyLayerindex = null;
                                    },
                                    // 监听弹出层关闭事件，不管是点击背景，点击关闭按钮，还是通过 API 关闭
                                    end: function () {
                                        GenerateIndependentlyLayerindex = null;
                                    },
                                    success: async function (layero, index) {

                                        let selectElement = document.getElementById('GenerateIndependentlyImginfoPromptSelect');
                                        let tag = 'SEOGenerateImgInfo'

                                        // generatorImginfo
                                        $('#generatorImginfo').on('click', async function () {
                                            let imagedes = document.querySelector("#imagedes").value
                                            let id = clientId
                                            let GenerateIndependentlyprompt = getAllValueInput('GenerateIndependentlypromptcontainer')
                                            GenerateIndependentlyprompt = promptGenerator(GenerateIndependentlyprompt)
                                            let finalPrompt = `${GenerateIndependentlyprompt}My image: ${imagedes};<br>`
                                            let singleImage = await mergePromptSend(prompt = finalPrompt, save = '00', returncounts = 1, jsonformat = '11')
                                            // mlog(singleImage['dataresult'])
                                            if (typeof singleImage['dataresult'] === "string") {
                                                var finalImageData = [singleImage['dataresult']]
                                            }
                                            var tdata = []
                                            finalImageData.forEach((ele, key) => {
                                                let i = JSON.parse(ele)
                                                let m = {
                                                    "id": id,
                                                    "alt": i['AltText'],
                                                    "title": i["Title"],
                                                    "caption": i["Caption"],
                                                    "description": i["Description"],
                                                }
                                                tdata.unshift(m)

                                            });
                                            var inst = table.render({
                                                toolbar: '#toolbar', // 启用工具条
                                                elem: '#ID-table-prompt-img',
                                                cols: [
                                                    [ //标题栏
                                                        {
                                                            title: 'Action',
                                                            width: 180,
                                                            toolbar: '#table-operations-imgprompt'
                                                        },
                                                        {
                                                            field: 'id',
                                                            width: 180,
                                                            title: 'id',
                                                        },
                                                        {
                                                            field: 'alt',
                                                            width: 220,
                                                            edit: 'text',
                                                            title: 'alt',
                                                        },
                                                        {
                                                            field: 'title',
                                                            width: 220,
                                                            edit: 'text',
                                                            title: 'title',
                                                        },
                                                        {
                                                            field: 'caption',
                                                            width: 220,
                                                            edit: 'text',
                                                            title: 'caption',
                                                        },
                                                        {
                                                            field: 'description',
                                                            width: 220,
                                                            edit: 'text',
                                                            title: 'description',
                                                        },
                                                    ]
                                                ],
                                                data: tdata,
                                                page: true, // 是否显示分页
                                                limit: 5 // 每页默认显示的数量
                                            });

                                            table.on('tool(IDtablepromptimgbar)', function (obj) {
                                                var data = obj.data; // 当前行的数据
                                                var event = obj.event; // lay-event 的值
                                                if (event === 'applyimginfo') {

                                                    updateImageBlockAttributes(data['id'], {
                                                        alt: data['alt'],
                                                        title: data['title'],
                                                        caption: data['caption'],
                                                        description: data['description']
                                                    });
                                                    // document.getElementById(data['id'] +"-td").innerHTML = `alt: ${data['alt']},<br>
                                                    //     title: ${data['title']},<br>
                                                    //     caption: ${data['caption']},<br>
                                                    //     description: ${data['description']}`
                                                    alert('Done')
                                                }


                                            });
                                        })

                                        db.getAllPromptByTag(tag).then(res => {
                                            console.log(res)
                                            // 调用函数填充选项
                                            populateOptionsFromArrayAss(res, selectElement);
                                            selectElement.addEventListener("change", async (event) => {
                                                const promptname = event.target.value;
                                                db.getPromptByName(promptname).then((res) => {
                                                    // let prompt = JSON.parse(res['prompt'])
                                                    let containerID = 'GenerateIndependentlypromptcontainer'
                                                    promptDomGenerator(res['prompt'], containerID, res['others'])
                                                })

                                                $('#SEOimgInfoEmptyPart2').on('click', function () {
                                                    addcomponet({
                                                        'title': 'label',
                                                        'content': 'content'
                                                    }, 'GenerateIndependentlypromptcontainer')
                                                })
                                                $('#SEOimgInfoPromptpart2').on('click', function () {
                                                    AIassistantquickpromptpartfunction('GenerateIndependentlypromptcontainer', 'r')
                                                })
                                            })
                                        })
                                    }
                                });



                            });
                            buttonCell.appendChild(button);

                            // 将所有单元格添加到表格行中
                            row.appendChild(imgCell);
                            row.appendChild(clientIdCell);
                            row.appendChild(descriptionCell);
                            row.appendChild(buttonCell);

                            // 将行添加到表格主体中
                            tableBody.appendChild(row);
                        });

                        // 获取整个表格的数据
                        function getTableData() {
                            const rows = document.querySelectorAll('#SEOImgContainer tbody tr');
                            const tableData = [];

                            // 遍历每一行
                            rows.forEach(row => {
                                // const imageUrl = row.querySelector('td img').src; // 获取图片 URL
                                const clientId = row.querySelector('td:nth-child(2)').textContent; // 获取 Client ID
                                const description = row.querySelector('td textarea').value; // 获取描述文本框的值

                                // 将数据存储在对象中
                                tableData.push({
                                    // imageUrl: imageUrl,
                                    clientId: clientId,
                                    description: description
                                });
                            });

                            return tableData;
                        }


                        $('#updateAllImgAlt').on('click', async function () {
                            try {
                                const allimgs = document.querySelectorAll('.json-view-aiseo');
                                allimgs.forEach(ele => {
                                    let imgalt = JSON.parse(ele.innerText)
                                    //json key一律变成小写
                                    imgalt = normalizeKeys(imgalt)
                                    if (imgalt['altText'] == undefined) {
                                        layer.msg("Data error", { time: 5000, })
                                    }
                                    updateImageBlockAttributes(imgalt['imgid'], {
                                        alt: imgalt['altText'] ?? "",
                                        title: imgalt['title'] ?? "",
                                        caption: imgalt['caption'] ?? "",
                                        description: imgalt['description'] ?? ""
                                    });

                                });

                                layer.msg("Done", { time: 5000, })
                            } catch (error) {
                                alert('error: ' + error)

                            }


                            // let demo = `{
                            //     "AltText": "一个穿着黄色衣服的女孩独自坐在长椅上，周围是模糊的背景，表情略显寂寞。",
                            //     "Title": "黄色寂寞女孩",
                            //     "Caption": "在喧嚣的世界里，她独自一人，黄色的身影显得格外醒目。",
                            //     "Description": "这张图片展示了一个穿着黄色衣服的女孩，她独自坐在公园的长椅上，周围的环境被模糊处理，突出了她的孤独感。她的表情略带忧郁，黄色的衣服在暗淡的背景中显得格外醒目，仿佛在诉说着内心的寂寞。整个画面传达出一种宁静而忧伤的氛围，让人不禁思考她的故事。"
                            //     }`


                        })

                        $('.bulkgeneratorImginfo').on('click', async function () {
                            const imgdatas = getTableData();
                            if (allImgsPrompts == '') {
                                alert('SEO Images Info AI prompt is empty')
                                setFocusAndHighlightAss('bulkgeneratorIminfosetting')
                                return
                            }
                            // mlog(imgdatas)
                            // mlog(allImgsPrompts, 'allImgsPrompts')

                            async function doGetAltTask(imgdata) {
                                if (imgdata.description == '') {
                                    layer.msg('image description can not be empty')
                                    return
                                }
                                let prompt = `${allImgsPrompts}Image keywords: ${imgdata.description}`

                                let result = null
                                // let result_ = await mergePromptSend(prompt)
                                let result_ = await mergePromptSend(prompt, save = '00', returncounts = 1, jsonformat = '11')
                                result = result_['dataresult']
                                // result = JSON.parse(extractJson(result))
                                result = JSON.parse(result)
                                result['imgId'] = imgdata.clientId

                                const $container = $("#" + imgdata.clientId + "-td");

                                const radioHtml = `
                                        <label class="radio-option-aiseo">
                                        <pre class="json-view-aiseo" contenteditable="true" >${JSON.stringify(result, null, 2)}</pre>
                                        </label>
                                            `;
                                $container.append(radioHtml);

                                // document.getElementById(imgdata.clientId +"-td").innerHTML=result
                                // result = JSON.parse(result)
                                // //json key一律变成小写
                                // AISEOTDK = normalizeKeys(result)

                                // mlog(prompt, 'sss989')
                                // mlog(result, 'result989')
                            }

                            for (const imgdata of imgdatas) {

                                await doGetAltTask(imgdata);      // 等待任务完成
                                await sleep(1000);
                                // break     // 然后延时 1 秒再继续下一个

                            }
                        });
                        document.getElementById('bulkgeneratorImginfosetting').addEventListener('click', () => {
                            let bulkimgprompt = document.getElementById('bulkgeneratorImginfoPromptSelect').value;
                            if (bulkimgprompt == '') {
                                alert('please select a prompt')
                                setFocusAndHighlightAss('bulkgeneratorImginfoPromptSelect')
                                return
                            }
                            layer.open({
                                title: "Setting",
                                type: 1,
                                offset: 'l',
                                anim: 'slideRight', // 从右往左
                                content: `<div id="containerSEOimgInfo" class="containerbutton"><button id="SEOimgInfopromptconfirm" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Confirm</button><button id="SEOimgInfoPromptpart" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Prompt part</button><button id="SEOimgInfoEmptyPart" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Empty Part</button></div><div id="bulkimgpromptcontainer"></div>`,
                                area: ['480px', '100%'], // 初始宽高
                                maxmin: true,
                                shade: 0.1,
                                // shadeClose: true,
                                success: function (layero, index) {
                                    db.getPromptByName(bulkimgprompt).then((res) => {
                                        promptDomGenerator(res['prompt'], 'bulkimgpromptcontainer')
                                    })

                                    $('#SEOimgInfopromptconfirm').on('click', function () {
                                        let createContentInput = getAllValueInput('bulkimgpromptcontainer')
                                        allImgsPrompts = promptGenerator(createContentInput)
                                        document.querySelector("#bulkgeneratorImginfopromptcontainer").innerHTML = `<h3>Prompt: </h3>${allImgsPrompts}`
                                        layer.close(index);
                                    })
                                    $('#SEOimgInfoEmptyPart').on('click', function () {
                                        addcomponet({
                                            'title': 'label',
                                            'content': 'content'
                                        }, 'bulkimgpromptcontainer')
                                    })
                                    $('#SEOimgInfoPromptpart').on('click', function () {
                                        AIassistantquickpromptpartfunction('bulkimgpromptcontainer', 'r')
                                    })
                                }
                            });

                        });
                    });
                })
                imagecontrol()
            },
            'COPYarticlebody': function (othis) {
                wp.domReady(() => {

                    const copyPostTitleAndContent = (() => {
                        // 获取文章标题
                        //   const postTitle = wp.data.select("core/editor").getEditedPostAttribute("title");
                        // 获取文章内容（纯文本）
                        const postContent = wp.data.select("core/editor").getEditedPostAttribute("content");

                        // 拼接复制内容
                        //   const fullText = `标题：${postTitle}\n\n内容：\n${postContent}`;

                        // 复制到剪贴板
                        navigator.clipboard.writeText(postContent)
                            .then(() => atip("copied", othis))
                            .catch(err => {
                                console.error("failed", err);
                                atip("failed", othis);
                            });
                    })
                    copyPostTitleAndContent()
                })
            },
            'replaceotimage': async function (othis) {
                try {
                    const postId = wp.data.select('core/editor').getCurrentPostId();
                    let og = document.getElementById('content_ai_seo_open_graph').value
                    let twitter_card = document.getElementById('content_ai_seo_twitter_card').value
                    let img = await getFeaturedImageURL(postId)

                    document.getElementById('content_ai_seo_open_graph').value = og
                        document.getElementById('content_ai_seo_twitter_card').value = twitter_card
                    // mlog(img)
                    if (img != null) {
                        og = og.replace(
                            /"image":\s*"([^"]+)"/,
                            `"image": "${img}"`
                        );
                        og = processOpengraph(og)
                        twitter_card = twitter_card.replace(
                            /"image":\s*"([^"]+)"/,
                            `"image": "${img}"`
                        );
                        twitter_card = processOpengraph(twitter_card)
                        
                        alert('Done')
                    } else {
                        alert('Not set the feature image')
                    }
                } catch (error) {
                    alert(`error:${error}`)
                }


            },
            'ai-assistant-btn': function () {
                openaichat()
            },
            'aichats': function () {
                openaichat()
            },
            'aicontentseo-assistant': function () {
                openaichat()
            },
            'openquickprompt': function () {
                let prompts = `[
                    {
                        "title": "title",
                        "content": "Success in SEO Rank"
                    },
                    {
                        "title": "requirement",
                        "content": "3000 words, title touches, including abstract, keywords, short seo description, FAQ, tips"
                    },
                    {
                        "title": "Language",
                        "content": "English"
                    }
                ]`
                let containerID = 'containerID';
                layer.open({
                    type: 1, // page 层类型
                    area: ['500px', '600px'],
                    title: 'Prompt',
                    shade: 0, // 遮罩透明度
                    maxmin: true, // 允许全屏最小化
                    anim: 0, // 0-6 的动画形式，-1 不开启
                    content: '<div id="applyprompt" style="padding: 32px;"><button lay-on="submitprompt" class="layui-btn-sm layui-bg-cyan">Submit</button><button lay-on="quickprompt" class="layui-btn-sm layui-bg-cyan">Quick Prompt Part</button><button lay-on="addprompt" class="layui-btn-sm layui-bg-cyan">Add Part</button><button lay-on="deleteall" class="layui-btn-sm layui-bg-cyan">Delete All Part</button><div id="containerID" style="padding: 2px;"></div></div>',
                    success: function (layero, index) {
                        promptDomGenerator(prompts, containerID, 'title')
                    }
                });
            },
            'savechat': function () {
                alert('savechat,to be continue')

            },
            'newchat': function () {
                // 新增一个 tab 项
                var tabCount = $('.layui-tab[lay-filter="chat-handle"] .layui-tab-title li').length;
                var c_label = (Math.random() * 1000 | 0); // 标记 - 用于演示
                var label = 'Chat' + tabCount // 标记 - 用于演示
                let id = new Date().getTime()
                element.tabAdd('chat-handle', {
                    title: label,
                    content: ` <div class="output-content-css" id="output-content-${c_label}"></div>`,
                    id: id, // 实际使用一般是规定好的id，这里以毫秒数模拟
                    change: true // 是否添加完毕后即自动切换
                })
                element.tabChange('chat-handle', id);
            },
            'generate-c': async function (othis) {
                const input = $('#ai-input').val();
                if (!input.trim()) {
                    layer.msg('Please Input Content！', { icon: 0 });
                    return;
                }

                let selectElementvalue = document.getElementById('FormatSelect').value;
                let res = await db.getPromptByName(selectElementvalue)
                let p = ''
                let allow = await db.getTagsByCategory('tools')
                // let allow = ['format', 'snippet']
                if (res != undefined && allow.includes(res['tag'])) {
                    p = JSON.parse(res['prompt'])
                    p = promptGenerator(p)
                    p = `My Requirement: ${input};${p}`
                } else {
                    p = `My Requirement: ${input};`
                }
                regeneratePrompt = p

                var message = [{
                    "role": "system",
                    "content": "You are a helpful assistant"

                }]
                //连续对话的能力
                let isChecked = document.querySelector('input[name="continuousdialogue"]').checked;
                if (isChecked == true) {
                    const answer_elements = document.querySelectorAll(`#${contentoutputId} .copytarget`);
                    const quuestion_elements = document.querySelectorAll(`#${contentoutputId} .qtarget`);
                    if (answer_elements) {
                        // const textContent = Array.from(answer_elements).map(el => el.textContent.trim()).join("\n");
                        // mlog(textContent, '6767sumary')

                        answer_elements.forEach((element, index) => {
                            // mlog(element)
                            // mlog(quuestion_elements[index])
                            message.push({ "role": "user", "content": quuestion_elements[index].textContent.trim() })
                            message.push({ "role": "assistant", "content": element.textContent.trim() },)
                        });
                    }
                }

                message.push({ "role": "user", "content": p })
                //保留最近的对话
                message = trimChatHistory(message)


                //如果tab id是999，则说明是生成图像
                var activeTabId = $('#ID-ai-helper .layui-tab-title .layui-this').attr('lay-id');

                if (activeTabId == '999') {

                    let imageparams = getAllValueInput('containerImageparams')
                    imageparams = promptGenerator(imageparams)

                    // 去除多余的 `<br>` 并拆分成键值对
                    const objimageparams = Object.fromEntries(
                        imageparams.split(";<br>").filter(Boolean).map(item => {
                            const [key, value] = item.split(":");
                            return [key.trim(), isNaN(value) ? value.trim() : Number(value.trim())];
                        })
                    );
                    mlog(p)
                    mlog(imageparams)
                    objimageparams['prompt'] = p

                    let result = await requestAiImg(objimageparams, 'request_ai_img')
                    mlog(result)
                    var userQuestion = p;
                    var imageUrl = result['dataresult'];
                    function showimgInfo(userQuestion, imageUrl) {
                        

                        var $question = $('<p></p>')
                            .addClass('user-question')
                            .text('🧠 User asked: ' + userQuestion);

                        var $img = $('<img>')
                            .addClass('generated-image')
                            .attr('src', imageUrl)
                            .attr('alt', 'AI generated image');

                        $('#output-content-images-container').append($question).append($img);
                    }

                    showimgInfo(userQuestion, imageUrl)


                } else {
                    // return
                    mlog(message, 'sendmeg')
                    let airesponse = await finalAIRequestContinus(message)
                    // mlog(airesponse)
                    showcontent(input, airesponse['dataresult'])
                }

            },
            'Insert': function (othis) {
                // const parentDiv = othis.parentNode.parentNode
                const parentDiv = othis.parent().parent()
                const copycontent = parentDiv[0].querySelector(".copytarget").outerHTML

                wp.domReady(() => {
                    const blocks = wp.blocks.rawHandler({ HTML: copycontent });
                    wp.data.dispatch('core/block-editor').insertBlocks(blocks);
                })
                return
                navigator.clipboard.writeText(copycontent)
                    .then(() => {
                        atip("copied", othis)
                    })
                    .catch(err => {
                        atip("copy failed", othis)
                    });
            },
            'copy': function (othis) {
                // const parentDiv = othis.parentNode.parentNode
                const parentDiv = othis.parent().parent()
                const copycontent = parentDiv[0].querySelector(".copytarget").outerHTML

                navigator.clipboard.writeText(copycontent)
                    .then(() => {
                        atip("copied", othis)
                    })
                    .catch(err => {
                        atip("copy failed", othis)
                    });
            },
            'regenerate': async function (othis) {
                if (regeneratePrompt == '') {
                    alert('prompt is empty')
                    return
                }
                let airesponse = await finalAIRequest(regeneratePrompt, save = '00', returncounts = 1, jsonformat = '00')
                showcontent(regeneratePrompt, 'outputcontent')


            },
            'Moreprompt': function (othis) {
                if (MorepromptLayer) {
                    layer.msg('Layer is already open!', { icon: 5 });
                    return;
                }
                MorepromptLayer = layer.open({
                    type: 1, // page 层类型
                    area: ['500px', '600px'],
                    title: 'More',
                    shade: 0, // 遮罩透明度
                    maxmin: true, // 允许全屏最小化
                    anim: 0, // 0-6 的动画形式，-1 不开启
                    content: `<div id="mprompts_radio">
    <div id="searchprompt" style="padding: 16px;">
        <div><span class="layui-badge layui-bg-cyan">SearchPrompt : </span></div>
        <div class="layui-input-group">
            <input id="searchpromptinput2" type="text" placeholder="by name" class="layui-input">
            <div lay-on="searchprompt2" class="layui-input-split layui-input-suffix" style="cursor: pointer;">
                <i class="layui-icon layui-icon-search"></i>
            </div>
            
        </div>
        <div class="layui-input-group">
            <input id="searchpromptinputag2" type="text" placeholder="by tag" class="layui-input">
            <div lay-on="searchpromptag2" class="layui-input-split layui-input-suffix" style="cursor: pointer;">
                <i class="layui-icon layui-icon-search"></i>
            </div>
           
        </div>
        <div class="layui-input-group">
            <input id="searchpromptinputcate2" type="text" placeholder="by category" class="layui-input">
            <div lay-on="searchpromptcate2" class="layui-input-split layui-input-suffix" style="cursor: pointer;">
                <i class="layui-icon layui-icon-search"></i>
            </div>
           
        </div>
    </div>
    <div id="minitoolprompts" style="padding: 16px;">
        <div><span class="layui-badge layui-bg-cyan">Mini Prompts : </span></div>
    </div>
    <div id="rfprompts" style="padding: 16px;">
        <div><span class="layui-badge layui-bg-cyan">Recently & Favorite Prompts : </span></div>
    </div>
    <div id="cprompts" style="padding: 16px;">
        <div><span class="layui-badge layui-bg-cyan">Sort By Category : </span></div>
    </div>

    <div style="padding-left: 16px;" ><span class="layui-badge layui-bg-cyan">Sort By Tag : </span></div>
    <div id="tprompts" style="padding: 16px;">
        
    </div>
</div>`,
                    success: function (layero, index) {
                        const gcode = ((id, options) => {
                            const container = document.getElementById(id);
                            // 遍历数组，生成每一项的 radio 和 label
                            options.forEach((option, index) => {
                                // 创建 radio input 元素
                                const radioInput = document.createElement('input');
                                radioInput.type = 'radio';
                                radioInput.name = 'r3';
                                radioInput.value = option;
                                radioInput.title = option;
                                radioInput.onchange = function () {
                                    const button = document.getElementById("PromptApply");
                                    button.style.display = "inline-block";

                                    const selectElement = document.getElementById('FormatSelect');
                                    selectElement.innerHTML = ''
                                    if (id == "tprompts") {
                                        db.getAllPromptByTag(this.value).then(res => {
                                            console.log(res)
                                            // 调用函数填充选项
                                            populateOptionsFromArrayAss(res, selectElement);
                                            selectElement.addEventListener("change", async (event) => {
                                                const selectedValue = event.target.value;
                                                console.log(selectedValue)
                                            })
                                        })
                                    } else if (id == 'cprompts') {
                                        db.getTagsByCategory(this.value).then((res) => {
                                            document.querySelector("#tprompts").innerHTML = ''
                                            gcode('tprompts', res)

                                        })
                                    }
                                    else if (id == 'rfprompts') {
                                        let rfprompts = new LocalStorageCache(this.value, 20); // 缓存数组最大长度为 10
                                        let res = rfprompts.getAll()

                                        populateOptionsFromArrayAss(res, selectElement);
                                        selectElement.addEventListener("change", async (event) => {
                                            const selectedValue = event.target.value;
                                            console.log(selectedValue)
                                        })
                                    }
                                    else if (id == 'minitoolprompts') {
                                        button.style.display = "none";
                                        db.getAllPromptByTag(this.value).then(res => {
                                            console.log(res)
                                            // 调用函数填充选项
                                            populateOptionsFromArrayAss(res, selectElement);
                                            selectElement.addEventListener("change", async (event) => {
                                                const selectedValue = event.target.value;
                                                console.log(selectedValue)
                                            })
                                        })
                                    }
                                };

                                // 创建 label 元素
                                const label = document.createElement('label');
                                label.setAttribute('for', option.toLowerCase()); // 设置 for 属性与 input 的 value 对应
                                label.textContent = option; // 设置 label 显示的文本

                                // 将 radio input 和 label 添加到容器中
                                container.appendChild(radioInput);
                                container.appendChild(label);
                                // container.appendChild(document.createElement('br')); // 添加换行
                            });
                        })

                        db.getAllCategory().then((res) => {
                            gcode('cprompts', res)

                        })
                        db.getAllTag().then((res) => {
                            res.reverse()
                            let tags = res.slice(0, 30)
                            gcode('tprompts', tags)

                        })
                        db.getTagsByCategory('tools').then((res) => {
                            gcode('minitoolprompts', res)

                        })
                        let rfprompt = ['recent_prompt_history', 'favorite_prompt']
                        gcode('rfprompts', rfprompt)
                    },
                    end: function () {
                        MorepromptLayer = null;
                    },

                });



            },
            searchprompt2: async function (othis) {
                let searchpromptinput = document.querySelector("#searchpromptinput2").value
                let res = await db.searchPrompt(searchpromptinput)
                const selectElement = document.getElementById('FormatSelect');
                selectElement.innerHTML = ''
                atip('atip', selectElement)
                // 调用函数填充选项
                populateOptionsFromArrayAss(res, selectElement);

            },
            searchpromptag2: async function (othis) {
                let searchpromptinput = document.querySelector("#searchpromptinputag2").value
                let res = await db.searchPromptag(searchpromptinput)
                const selectElement = document.getElementById('FormatSelect');
                selectElement.innerHTML = ''
                atip('atip', selectElement)
                // 调用函数填充选项
                populateOptionsFromArrayAss(res, selectElement);

            },
            searchpromptcate2: async function (othis) {
                let searchpromptinput = document.querySelector("#searchpromptinputcate2").value
                let res = await db.searchPromptcate(searchpromptinput)
                const selectElement = document.getElementById('FormatSelect');
                selectElement.innerHTML = ''
                atip('atip', selectElement)
                // 调用函数填充选项
                populateOptionsFromArrayAss(res, selectElement);

            },
            'submitprompt': async function (othis) {
                atip('Start', othis)
                let createContentPrompt = ''
                let createContentInput = getAllValueInput('containerID')
                createContentPrompt = promptGenerator(createContentInput)
                regeneratePrompt = createContentPrompt

                var message = [{
                    "content": "You are a helpful assistant",
                    "role": "system"
                }]

                //连续对话的能力
                let isChecked = document.querySelector('input[name="continuousdialogue"]').checked;
                if (isChecked == true) {
                    const answer_elements = document.querySelectorAll(`#${contentoutputId} .copytarget`);
                    const quuestion_elements = document.querySelectorAll(`#${contentoutputId} .qtarget`);
                    if (answer_elements) {
                        answer_elements.forEach((element, index) => {
                            message.push({ "role": "user", "content": quuestion_elements[index].textContent.trim() })
                            message.push({ "role": "assistant", "content": element.textContent.trim() },)
                        });
                    }
                }

                message.push({ "role": "user", "content": createContentPrompt })
                //保留最近的对话
                message = trimChatHistory(message)

                let airesponse = await finalAIRequest(message, save = '00', returncounts = 1, jsonformat = '00')
                showcontent(createContentPrompt, airesponse['dataresult'])


            },
            'deleteall': function (othis) {
                const list = document.getElementById("containerID");
                while (list.hasChildNodes()) {
                    list.removeChild(list.firstChild);
                }
            },
            'addprompt': function (othis) {
                addcomponet({
                    'title': 'label',
                    'content': 'content'
                }, 'containerID')
            },
            'deletecomponent': function (othis) {
                let id = othis[0].getAttribute("container");
                document.getElementById(id).remove()
            },
            'quickprompt': function (othis) {
                AIassistantquickpromptpartfunction('containerID')
            },
            'advancedParameters': function (othis) {
                layer.open({
                    type: 1, // page 层类型
                    area: ['500px', '600px'],
                    title: 'Advanced Parameters',
                    shade: 0, // 遮罩透明度
                    maxmin: true, // 允许全屏最小化
                    anim: 0, // 0-6 的动画形式，-1 不开启
                    content: '<div id="aiparams" style="padding:32px;"></div><div id="deepseekparams" style="padding:32px;"></div><div id="claudeparams" style="padding:32px;"></div>'
                })

                let params = new LocalStorageCache('ai_params', 20);
                let found_params_openai = params.find(item => item.id === 'chatgpt');
                if (found_params_openai == undefined) {
                    params.add(openai_params);
                    found_params_openai = openai_params;
                }
                injectStyles()
                let containerid = 'openaiForm'
                generateAIParamsForm(found_params_openai, containerid)

                //deepseek
                let found_params_deepseek = params.find(item => item.id === 'deepseek');
                if (found_params_deepseek == undefined) {
                    params.add(deepseek_params);
                    found_params_deepseek = deepseek_params;
                }
                // injectStyles()
                let deepseekcontainerid = 'deepseekForm'
                generateAIParamsForm(found_params_deepseek, deepseekcontainerid)

                //cluade
                let found_params_claude = params.find(item => item.id === 'claude');
                if (found_params_claude == undefined) {
                    params.add(claude_params);
                    found_params_claude = claude_params;
                }
                // injectStyles()
                let claudecontainerid = 'claudeForm'
                generateAIParamsForm(found_params_claude, claudecontainerid)

            },
            'submit_params': function (othis) {
                let submitypt = othis[0].parentElement.getAttribute("id")

                if (submitypt == 'openaiForm') {
                    let formid = '#openaiForm'
                    saveformAIparams(formid)
                }
                else if (submitypt == 'deepseekForm') {
                    let formid = '#deepseekForm'
                    saveformAIparams(formid)
                }
                else if (submitypt == 'claudeForm') {
                    let formid = '#claudeForm'
                    saveformAIparams(formid)
                }
                atip('success', othis)
            },
            'rest_params': function (othis) {
                const params = new LocalStorageCache('ai_params', 20);
                if (othis[0].parentElement.getAttribute("id") == "openaiForm") {
                    params.remove(item => item.id === 'chatgpt');
                }
                else if (othis[0].parentElement.getAttribute("id") == "deepseekForm") {
                    params.remove(item => item.id === 'deepseek');
                }
                else if (othis[0].parentElement.getAttribute("id") == "claudeForm") {
                    params.remove(item => item.id === 'claude');
                }
                atip('success', othis)
            },
            'zoomineditais': function (othis) {
                var oldValue = document.querySelector("#ai-input").value;
                // 获取原始 textarea 的值

                // 打开弹窗
                layer.open({
                    type: 1, // 页面层
                    title: 'edit',
                    area: ['500px', '500px'], // 宽高
                    content: '<textarea id="popupTextarea" class="layui-textarea" style="width:100%; height:80%;">' + oldValue + '</textarea>',
                    shade: 0,
                    maxmin: true,
                    btn: ['Save', 'Cancel'],
                    yes: function (index) {
                        // 获取弹窗内的 textarea 内容
                        var newValue = document.getElementById('popupTextarea').value;

                        // 将新值赋回原 textarea
                        document.querySelector("#ai-input").value = newValue;

                        // 关闭弹窗
                        layer.close(index);
                    }
                });
            },
            'actionfreeimage': function (othis) {

                if (freeimageLayerindex) {
                    layer.msg('Layer is already open!', { icon: 5 });
                    return;
                }


                let allimgs = othis[0].getAttribute('data')
               freeimageLayerindex= layer.open({
                    type: 1, // page 层类型
                    area: ['600px', '600px'],
                    title: 'Info',
                    shade: 0, // 遮罩透明度
                    maxmin: true, // 允许全屏最小化
                    anim: 0, // 0-6 的动画形式，-1 不开启
                    content: `<div style="margin:10px;" id="containerafi"><button id="aficopy" type="button" class="layui-btn layui-btn-warm layui-btn-radius margin-afi">copy link</button><button id="setFeaturePicture" type="button" class="layui-btn layui-btn-warm layui-btn-radius margin-afi">Set featured image</button><button id="inertPost" type="button" class="layui-btn layui-btn-warm layui-btn-radius margin-afi">Insert to post</button><div id="afidatacontainer" class="margin-afi"><span id="afiWH" class="margin-afi"></span></div><div class="margin-afi" id="afiImgContainer"></div></div>`,
                   yes: function (index, layero) {
                       layer.close(index);
                       freeimageLayerindex = null;
                   },
                   end: function () {
                       freeimageLayerindex = null;
                   },
                   success: function (layero, index) {

                        function generateSelectOptions(jsonObj) {


                            // 2. 获取父容器
                            let container = document.getElementById("afidatacontainer");

                            // 3. 创建一个 <select> 元素
                            let selectElement = document.createElement("select");
                            selectElement.id = "afiselect"

                            // 4. 遍历 JSON 对象的每个属性并生成 <option> 元素
                            for (let key in jsonObj) {
                                if (jsonObj.hasOwnProperty(key)) {
                                    // 创建一个 <option> 元素
                                    let optionElement = document.createElement("option");

                                    // 设置 <option> 的值和值的内容
                                    optionElement.value = jsonObj[key];
                                    optionElement.textContent = key;  // 用键名作为 option 的文本内容

                                    // 将 <option> 元素添加到 <select> 中
                                    selectElement.appendChild(optionElement);
                                    selectElement.addEventListener("change", async (event) => {
                                        // 使用 jQuery 生成 img 标签并插入容器
                                        const selectedValue = event.target.value;
                                        $("#afiImgContainer").html(`
                                            <img id="dynamicImg" src="${selectedValue}" alt="Image" 
                                            style="width: 100%; border-radius: 10px; box-shadow: 0 4px 8px rgba(0,0,0,0.2);" />
                                        `);
                                        $("#dynamicImg").on('load', function () {
                                            let naturalWidth = this.naturalWidth;
                                            let naturalHeight = this.naturalHeight;
                                            $("#afiWH").html(`Width:${naturalWidth};Height:${naturalHeight}`)
                                        })
                                    })

                                }
                            }

                            // 5. 将生成的 <select> 元素插入到父容器中
                            container.appendChild(selectElement);
                        }
                        // 1. 将 JSON 字符串解析为 JavaScript 对象
                        let allimgs_ = JSON.parse(allimgs);
                        generateSelectOptions(allimgs_)

                        //加载开场图片
                        let selectElement = document.getElementById("afiselect");
                        selectElement.value = allimgs_['regular']; // 设置选中值
                        selectElement.dispatchEvent(new Event('change')); // 手动触发 change 事件

                        //
                        let btaficopy = document.getElementById("aficopy")
                        let btinertPost = document.getElementById("inertPost")
                        let btsetFeaturePicture = document.getElementById("setFeaturePicture")
                        const img = document.getElementById("dynamicImg");
                        // 获取 img 的 src 属性
                        const srcValue = img.getAttribute("src");
                        btaficopy.addEventListener("click", function () {

                            // 调用 Clipboard API
                            navigator.clipboard.writeText(srcValue)
                                .then(() => {
                                    layer.msg("successful");
                                })
                                .catch(err => {
                                    layer.msg("failed:" + err);
                                });
                        });
                        btinertPost.addEventListener("click", function () {
                            let imageUrl = srcValue
                            // 2. 创建图片块
                            wp.data.dispatch('core/editor').insertBlocks(
                                wp.blocks.createBlock('core/image', {
                                    url: imageUrl,         // 图片URL
                                    alt: '',          // 图片ALT属性
                                    // caption: "自动插入的图片",  // 图片说明（可选）
                                    align: "center"        // 图片对齐方式 (left, center, right)
                                })
                            );

                            // 立即获取最新的块
                            const allBlocks = wp.data.select('core/editor').getBlocks();
                            const latestBlock = allBlocks[allBlocks.length - 1]; // 获取最新插入的块

                            setTimeout(() => {
                                if (latestBlock) {
                                    // 自动选中最新插入的图片块
                                    wp.data.dispatch('core/editor').selectBlock(latestBlock.clientId);
                                    console.log("✅ 图片已插入并选中");
                                } else {
                                    console.warn("⚠️ 未找到最新插入的块");
                                }
                            }, 2000)
                            setTimeout(() => {
                                // 根据按钮的 ARIA 标签或类名定位按钮
                                const uploadButton = document.querySelector('button[aria-label="Upload to Media Library"]');

                                if (uploadButton) {
                                    console.log("✅ 找到按钮，正在自动触发...");
                                    // 模拟点击事件
                                    uploadButton.click();
                                } else {
                                    console.warn("⚠️ 未找到 'Upload to Media Library' 按钮");
                                }
                            }, 4000);
                        });

                        btsetFeaturePicture.addEventListener("click", function () {
                            // 上传图片到 WordPress 媒体库
                            async function uploadImageAndSetFeatured(imageUrl, fileName = 'image.jpg') {
                                try {
                                    layer.msg("start");
                                    // 1. 获取图片 Blob
                                    const response = await fetch(imageUrl);
                                    const blob = await response.blob();

                                    // 2. 创建 FormData
                                    const formData = new FormData();
                                    formData.append('file', blob, fileName);

                                    // 3. 上传图片到 WordPress 媒体库
                                    const uploadResponse = await fetch(`${contentAISEOAdmin.root}wp/v2/media`, {
                                        method: 'POST',
                                        headers: {
                                            'X-WP-Nonce': contentAISEOAdmin.nonce,
                                        },
                                        body: formData,
                                    });

                                    if (!uploadResponse.ok) {
                                        alert("upload failed")
                                        throw new Error(`上传失败: ${uploadResponse.status}`);
                                    }
                                    const image = await uploadResponse.json();
                                    console.log("✅ 上传成功:", image);

                                    // 4. 获取当前文章 ID
                                    const postId = wp.data.select('core/editor').getCurrentPostId();
                                    if (!postId) {
                                        alert("no post found")
                                        throw new Error("未找到文章 ID");
                                    }

                                    // 5. 设置为 Featured Image
                                    const postResponse = await fetch(`${contentAISEOAdmin.root}wp/v2/posts/${postId}`, {
                                        method: 'POST',
                                        headers: {
                                            'Content-Type': 'application/json',
                                            'X-WP-Nonce': wpApiSettings.nonce,
                                        },
                                        body: JSON.stringify({
                                            featured_media: image.id,
                                        }),
                                    });

                                    if (!postResponse.ok) {
                                        alert("set featured image failed")
                                        throw new Error(`设置特色图片失败: ${postResponse.status}`);
                                    }
                                    console.log("🎉 特色图片已设置");

                                } catch (error) {
                                    console.error("❌ 出错了:", error.message);
                                }
                                layer.msg('successful set featured image!')
                            }

                            // 执行
                            let imageUrl = srcValue
                            uploadImageAndSetFeatured(imageUrl);

                        })
                    }

                });
            },
            'imagegenerator': function (othis) {

                layer.alert('imageGenerator', {
                    btn: ['Chatgpt', 'freeImages'],
                    btnAlign: 'c', // 按钮居中显示
                    shade: 0,
                    btn1: function () {
                        // layer.msg('按钮一的回调');
                        aiGenerateImg()
                    },
                    btn2: function () {
                        freeImages()
                    },
                    btn3: function () {
                        layer.msg('按钮三的回调');
                    }
                });

                setTimeout(function () {
                    document.querySelectorAll('.layui-layer').forEach(el => {
                        el.style.boxShadow = 'none';
                    });
                }, 0);


                const freeImages = (() => {
                    let dom = `<div id="containerImageGenerator" style="padding: 2px;">
                                <div class="layui-form">
                                    <div class="layui-form-item">
                                        <div class="layui-input-group">
                                        <div class="layui-input-prefix">
                                            Search
                                        </div>
                                        <input id="searchInput" type="text" placeholder="" class="layui-input">
                                        <div id="searchBtn" class="layui-input-split layui-input-suffix" style="cursor: pointer;">
                                            <i class="layui-icon layui-icon-search"></i>
                                        </div>
                                        </div>
                                    </div>
                                    <hr style="margin: 2px 0;">
                                </div>
                                <select id="orientationSelect">
                                    <option value="landscape">Landscape</option>
                                    <option value="portrait">Portrait</option>
                                    <option value="squarish">Squarish</option>
                                </select>
                                <div id="image-container"></div>
                                <button class="layui-btn layui-btn-normal layui-btn-radius" id="nextPageBtn" style="margin-top: 20px; display: none;">Next Page</button>
                              </div>`
                    let freeImages = layer.open({
                        type: 1,
                        area: ['600px', '600px'],
                        title: 'Free Images',
                        shade: 0,
                        shadeClose: false,
                        maxmin: true,
                        anim: 0,
                        content: dom,
                        btn: ['Close'],
                        yes: function (index, layero) {
                            layer.close(index);
                            // aiseosettingLayerindex = null;
                        },
                        end: function () {

                        },
                        success: function (layero, index) {
                            // const ACCESS_KEY = "xvwN462F-JewCPkhZGJDBXQcymPybvRgLVj7Um5AAys"; // 替换为你的 Access Key
                            const ACCESS_KEY = contentAISEOAdmin.unsplash; // 替换为你的 Access Key

                            if (ACCESS_KEY == '') {
                                alert('unsplash API key is empty')
                            }
                            // 使用闭包函数
                            const searchImages = (function () {
                                let currentPage = 1;         // 当前页码
                                let currentQuery = "";       // 当前搜索关键词
                                let currentOrientation = "";

                                // 内部函数 - 处理实际请求
                                async function fetchImages() {
                                    if (!currentQuery) return;


                                    const url = `https://api.unsplash.com/search/photos?query=${currentQuery}&page=${currentPage}&per_page=29&orientation_=${currentOrientation}&client_id=${ACCESS_KEY}`;

                                    try {
                                        const response = await fetch(url);
                                        if (!response.ok) throw new Error('Network response was not ok');

                                        const data = await response.json();
                                        displayImages(data.results);

                                        // 控制"下一页"按钮是否可见
                                        if (data.total_pages > currentPage) {
                                            document.getElementById("nextPageBtn").style.display = "block";
                                        } else {
                                            document.getElementById("nextPageBtn").style.display = "none";
                                        }
                                    } catch (error) {
                                        console.error("Error fetching images:", error);
                                        layer.msg(`Error fetching images:${error}`)
                                    }
                                }

                                // 内部函数 - 显示图片
                                function displayImages(images) {
                                    const imgContainer = document.getElementById("image-container");
                                    if (currentPage === 1) imgContainer.innerHTML = ""; // 仅第一页清空

                                    if (images.length === 0) {
                                        imgContainer.innerHTML = "<p>No images found.</p>";
                                        return;
                                    }

                                    images.forEach((img, index) => {
                                        let allimgs = JSON.stringify(img.urls)
                                        let id = `freeimageunsplash${index}`
                                        let bid = `buttonfreeimageunsplash${index}`
                                        imgContainer.innerHTML += `
                                            <div id="${id}" style="display:inline-block; margin:10px;">
                                                <img picname="${img.user.name}" class="image-container" src="${img.urls.small}" alt="${img.alt_description}" data=${allimgs} style="width:200px; height:auto; border-radius:10px;">
                                                <button lay-on="actionfreeimage" id="${bid}" data=${allimgs} picname="${img.user.name}" class="hover-button">Action</button>
                                            </div>
                                        `;

                                    });
                                }

                                // 暴露的函数 - 启动搜索
                                return {
                                    startSearch: function (query, orientation_) {
                                        currentQuery = query;
                                        currentPage = 1;
                                        currentOrientation = orientation_;
                                        fetchImages(); // 加载第一页
                                    },
                                    loadNextPage: function () {
                                        currentPage++;
                                        fetchImages(); // 加载下一页
                                    }
                                };
                            })();

                            // 事件监听
                            document.getElementById("searchBtn").addEventListener("click", function () {
                                const query = document.getElementById("searchInput").value.trim();
                                const orientation_ = document.getElementById("orientationSelect").value;
                                if (query) {
                                    searchImages.startSearch(query, orientation_); // 开始新搜索
                                }
                            });

                            document.getElementById("nextPageBtn").addEventListener("click", function () {
                                searchImages.loadNextPage(); // 加载下一页
                            });
                        }
                    });
                })

                const aiGenerateImg = (() => {
                    if (contentAISEOAdmin.ai_choice != 'chatgpt') {
                        alert('Now the tool only support chatgpt API to generate image')
                        return
                    }

                    let paramsImagDOM = '<div id="containerImageparams" style="padding: 2px;"></div>'
                    paramsImagLayerindex = layer.open({
                        type: 1,
                        area: ['200px', '600px'],
                        title: 'AI Image Generator Params',
                        shade: 0,
                        shadeClose: false,
                        maxmin: true,
                        anim: 0,
                        content: paramsImagDOM,
                        btn: ['Close'],
                        yes: function (index, layero) {
                            layer.close(index);
                            // aiseosettingLayerindex = null;
                        },
                        end: function () {

                        },
                        success: function (layero, index) {
                            // 在弹窗生成后，找到关闭按钮并监听事件
                            // let closeBtn = layero.find('.layui-layer-close');

                            if (contentAISEOAdmin.ai_choice == 'chatgpt') {
                                db.getPromptByName('chatgptImgParams').then((res) => {

                                    promptDomGenerator(res.prompt, 'containerImageparams')

                                    setTimeout(() => {
                                        let createContentInput = getAllValueInput('containerImageparams')
                                        let promptext = promptGenerator(createContentInput)

                                        var activeTabId = $('.layui-tab-title .layui-this').attr('lay-id');
                                        console.log("当前激活的 Tab ID:", activeTabId);

                                    }, 2000);

                                })
                            }
                            else if (contentAISEOAdmin.ai_choice == 'deepseek') {
                                db.getPromptByName('chatgptImgParams').then((res) => {


                                })
                            }
                            else if (contentAISEOAdmin.ai_choice == 'claude') {
                                db.getPromptByName('chatgptImgParams').then((res) => {


                                })
                            }

                        }
                    });


                    if (document.querySelector("#output-content-images-container") == null) {
                        // 新增一个 tab 项
                        var tabCount = $('.layui-tab[lay-filter="chat-handle"] .layui-tab-title li').length;
                        var c_label = (Math.random() * 1000 | 0); // 标记 - 用于演示
                        var label = 'Image Generator' // 标记 - 用于演示
                        // let tabid = 'output-content-images-tab'
                        let tabid = '999'
                        element.tabAdd('chat-handle', {
                            title: label,
                            content: ` <div class="output-content-css" id="output-content-images-container"></div>`,
                            id: tabid, // 实际使用一般是规定好的id，这里以毫秒数模拟
                            change: true // 是否添加完毕后即自动切换
                        })
                        element.tabChange('chat-handle', tabid);
                    } else {
                        // let tabid = "#output-content-images-tab"
                        let tabid = "999"
                        element.tabChange('chat-handle', tabid);
                    }
                })

            },
            'VideoScreenshot': function (othis) {
                var domain = window.location.hostname;
                layer.open({
                    title: 'Screenshot & Record',
                    type: 2,
                    area: ['680px', '520px'],
                    content: `https://${domain}/wp-admin/admin.php?page=content-ai-seo-videocai`,
                    fixed: false, // 不固定
                    maxmin: true,
                    shade: 0,
                    // shadeClose: true,
                    btn: ['Cancel'],
                    btnAlign: 'c',
                    // yes: function (index, layero) {
                    //     // 获取 iframe 的窗口对象
                    //     var iframeWin = window[layero.find('iframe')[0]['name']];
                    //     var elemMark = iframeWin.$('#mark'); // 获得 iframe 中某个输入框元素
                    //     var value = elemMark.val();

                    //     if ($.trim(value) === '') return elemMark.focus();
                    //     // 显示获得的值
                    //     layer.msg('获得 iframe 中的输入框标记值：' + value);
                    // }
                });
                // https://mtool.icu/wp-admin/admin.php?page=content-ai-seo-videocai
            },
            'PromptApply': function (othis) {

                const selectedValue = $('#FormatSelect').val();
                console.log(selectedValue)
                db.getPromptByName(selectedValue).then((res) => {
                    if (res) {
                        let prompts = res.prompt
                        let containerID = 'containerID';
                        layer.open({
                            type: 1, // page 层类型
                            area: ['500px', '600px'],
                            title: 'Prompt',
                            shade: 0, // 遮罩透明度
                            maxmin: true, // 允许全屏最小化
                            anim: 0, // 0-6 的动画形式，-1 不开启
                            content: '<div id="applyprompt" style="padding: 32px;"><button lay-on="submitprompt" class="layui-btn-sm layui-bg-cyan">Submit</button><button lay-on="quickprompt" class="layui-btn-sm layui-bg-cyan">Quick Prompt Part</button><button lay-on="addprompt" class="layui-btn-sm layui-bg-cyan">Add Part</button><button lay-on="deleteall" class="layui-btn-sm layui-bg-cyan">Delete All Part</button><div id="containerID" style="padding: 2px;"></div></div>',
                            success: function (layero, index) {
                                promptDomGenerator(prompts, containerID)
                            }
                        });
                    }
                })
            },

        })
    })
})

setInterval(() => {
    document.querySelectorAll('#output-content-images-container img.generated-image').forEach((img) => {
        if (img.nextElementSibling && img.nextElementSibling.classList.contains('download-btn')) return;

        // const cleanUrl = img.src.replace(/&#038;/g, '&');
        const cleanUrl = img.src

        const btn = document.createElement('a');
        btn.textContent = '⬇️ Download Image';
        btn.href = cleanUrl;
        btn.download = 'ai-image.png';           // 提示浏览器下载
        btn.target = '_blank';                  // 避免页面跳转
        btn.className = 'download-btn';
        btn.style.display = 'inline-block';
        btn.style.marginTop = '6px';
        btn.style.color = '#0073aa';
        btn.style.textDecoration = 'none';

        img.parentNode.insertBefore(btn, img.nextSibling);
    });
}, 1000);


function updateSelect(sort) {
    const db = new PromptDatabase();
    // if (sort == "format") {
    const button = document.getElementById("PromptApply");
    button.style.display = "none";

    const selectElement = document.getElementById('FormatSelect');
    selectElement.innerHTML = ''
    db.getAllPromptByTag(sort).then(res => {
        console.log(res)
        // 调用函数填充选项
        populateOptionsFromArrayAss(res, selectElement);
        selectElement.addEventListener("change", async (event) => {

            const selectedValue = event.target.value;
            // atip(selectedValue, selectElement)
            db.getPromptByName(selectedValue).then((res) => {

                layer.close(layerindex);
                delay(2200).then(() => {
                    let p = JSON.parse(res.prompt)
                    finalprompt = promptGenerator(p).replace('\n', '<br>')
                    layerindex = layer.open({
                        title: "Final Prompt",
                        type: 1,
                        offset: 'lb', // 详细可参考 offset 属性
                        id: 'ID-finalprompt-layer-offset', // 防止重复弹出
                        content: '<div id="finalpromptext" style="padding: 16px;">' + finalprompt + '</div>',
                        area: ['360px', '160px'],
                        shade: 0, // 不显示遮罩
                        yes: function () {
                            layer.closeAll();
                        }
                    });
                })

            })
        })
    })

    // }

}




const showcontent = ((input, outputcontent_) => {
    let $ = layui.$;
    question = `<div class="qtarget layui-panel"><h3>${input}</h3></div>`
    let outhtml = mdToHtml(outputcontent_)
    let toolsbar = `<div id="content_tools" class="layui-btn-group">
            <span lay-on="copy" class="layui-badge layui-bg-green">Copy</span>
            <span lay-on="regenerate" class="layui-badge layui-bg-green">Regenerate</span>
            <span title="Insert to article" lay-on="Insert" class="layui-badge layui-bg-green">Insert</span>
 </div>`
    $(`#${contentoutputId}`).append('<div>' + question + '<div class="copytarget">' + outhtml + '</div>' + toolsbar + '</div>');
    scrollToEnd(contentoutputId)
})


window.addEventListener('message', function (event) {
    // 校验来自同一源的消息
    if (event.origin !== window.location.origin) return;

    if (event.data.type === 'base64Images') {
        const base64Images = event.data.data;

        // 这里可以进一步处理 Base64 图片，例如插入到 Gutenberg 编辑器
        // base64Images.forEach(base64Image => {
        //     // 使用 base64Image 插入图片，或将其显示在页面上
        //     console.log('接收到的 Base64 图片:', base64Image);
        // });

        base64Images.forEach(base64Image => {

            insertImageAtCursorOrEnd(base64Image)

            // wp.data.dispatch('core/block-editor').insertBlocks(
                // wp.blocks.createBlock('core/image', {
                    // url: base64Image, // 使用 Base64 图片作为源
                    // alt: '示例图片',                 // 替代文本
                    // caption: '这是图片的描述',      // 图片标题/描述
                    // linkDestination: 'none',        // 不链接
                    // linkClass: 'custom-class',      // 自定义类名
                    // scale: 1,                       // 图像缩放比例
                    // width: '100%',                  // 图像宽度
                    // height: 'auto',                 // 图像高度
                    // title: '图像标题'

                // })

            // );
        });

    }
});

function insertImageAtCursorOrEnd(image) {
    const selectedBlockId = wp.data.select('core/block-editor').getBlockSelectionStart();
    const blocks = wp.data.select('core/block-editor').getBlocks();
    let insertIndex = blocks.length; // 默认插在最后

    if (selectedBlockId) {
        const selectedIndex = blocks.findIndex(block => block.clientId === selectedBlockId);
        if (selectedIndex !== -1) {
            insertIndex = selectedIndex + 1;
        }
    }

    // const newBlock = wp.blocks.createBlock('core/html', {
    //     content: content
    // });
    const newBlock = wp.blocks.createBlock('core/image', {
        url: image, // 使用 Base64 图片作为源
        // alt: '示例图片',                 // 替代文本
        // caption: '这是图片的描述',      // 图片标题/描述
        // linkDestination: 'none',        // 不链接
        // linkClass: 'custom-class',      // 自定义类名
        // scale: 1,                       // 图像缩放比例
        // width: '100%',                  // 图像宽度
        // height: 'auto',                 // 图像高度
        // title: '图像标题'

    })

    wp.data.dispatch('core/block-editor').insertBlocks(newBlock, insertIndex);
}


// 监听来自 iframe 的消息
window.addEventListener('message', function (event) {
    // 确保消息来自可信源
    if (event.origin !== window.location.origin) return;

    // 处理来自 iframe 的消息
    if (event.data.type === 'insertVideo') {
        const base64Video = event.data.data;

        // 将 Base64 字符串转换为 Blob
        convertBase64ToBlob(base64Video).then(blob => {
            // 上传视频到 WordPress 并获取视频 URL
            uploadVideoToWordPress(blob).then(videoUrl => {
                // 上传成功后，将视频插入到 WordPress 编辑器
                insertVideoToEditor(videoUrl);
            }).catch(error => {
                console.error('视频上传失败:', error);
            });
        }).catch(error => {
            console.error('视频转换失败:', error);
        });
    }
});

// 将 Base64 字符串转换为 Blob 对象
function convertBase64ToBlob(base64) {
    return new Promise((resolve, reject) => {
        const byteCharacters = atob(base64.split(',')[1]);
        const byteArrays = [];

        for (let offset = 0; offset < byteCharacters.length; offset += 1024) {
            const slice = byteCharacters.slice(offset, offset + 1024);
            const byteNumbers = new Array(slice.length);
            for (let i = 0; i < slice.length; i++) {
                byteNumbers[i] = slice.charCodeAt(i);
            }
            const byteArray = new Uint8Array(byteNumbers);
            byteArrays.push(byteArray);
        }

        resolve(new Blob(byteArrays, { type: 'video/mp4' })); // 假设为 MP4 格式
    });
}

// 上传视频到 WordPress 并返回视频 URL
function uploadVideoToWordPress(videoBlob) {
    const formData = new FormData();
    formData.append('file', videoBlob, 'video.mp4');  // 上传文件时指定文件名和类型

    // WordPress REST API 路径，假设您已启用媒体上传 API
    const apiUrl = `${window.location.origin}/wp-json/wp/v2/media`;

    return fetch(apiUrl, {
        method: 'POST',
        headers: {
            'X-WP-Nonce': wpApiSettings.nonce // 必须添加 nonce 验证,登陆验证
        },
        body: formData,
    })
        .then(response => response.json())  // 返回 JSON 数据
        .then(data => {
            if (data.source_url) {
                return data.source_url;  // 返回上传后的视频 URL
            } else {

                throw new Error('视频上传失败');
            }
        })
        .catch(error => {
            console.error('上传视频出错:', error);
            throw error;
        });
}

// 将视频插入到 WordPress 编辑器
function insertVideoToEditor(videoUrl) {
    // 确保视频 URL 可用
    if (!videoUrl) {
        console.error('无效的视频 URL');
        return;
    }

    // 使用 wp.blocks.createBlock 创建一个视频块
    const block = wp.blocks.createBlock('core/video', {
        src: videoUrl,  // 设置视频的 URL
        autoplay: false,   // 默认不自动播放，你可以根据需要设置
        controls: true,    // 显示控制条
        loop: false,       // 默认不循环
        muted: false,      // 默认不静音
        playsInline: true, // 支持行内播放
        poster: '',        // 可以设置封面图（Base64 或 URL）
        preload: 'auto',   // 预加载选项：auto、metadata、none
        caption: '',       // 视频标题或描述
    });

    // 将视频块插入到当前光标位置
    const blockEditor = wp.data.dispatch('core/block-editor');
    if (blockEditor) {
        blockEditor.insertBlock(block);
    }
}



/**
 * 更新图片块的属性
 * 
 * @param {string} clientId - 图片块的唯一标识符
 * @param {Object} attributes - 需要更新的属性对象
 * @param {string} attributes.alt - 图片的 alt 属性
 * @param {string} attributes.title - 图片的 title 属性
 * @param {string} attributes.caption - 图片的 caption 属性
 * @param {string} attributes.description - 图片的 description 属性
 */
function updateImageBlockAttributes(clientId, { alt, title, caption, description }) {
    const { dispatch } = wp.data;

    // 更新图片块的属性
    dispatch('core/block-editor').updateBlockAttributes(clientId, {
        alt: alt || '',
        title: title || '',
        caption: caption || '',
        description: description || ''
    });

    console.log(`Updated image block (ID: ${clientId}) attributes:`);
    console.log(`Alt: ${alt}, Title: ${title}, Caption: ${caption}, Description: ${description}`);
}

/**
 * 获取当前选中的图片块并更新其属性
 * 
 * @param {Object} attributes - 需要更新的属性对象
 */
function updateSelectedImageBlockAttributes(attributes) {
    const { select } = wp.data;

    // 获取当前选中的块
    const selectedBlock = select('core/block-editor').getSelectedBlock();

    if (selectedBlock && selectedBlock.name === 'core/image') {
        updateImageBlockAttributes(selectedBlock.clientId, attributes);
    } else {
        console.log('Please select an image block first.');
    }
}
/**
 * 示例使用 - 修改图片的 alt、title、caption 和 description
 */
// updateSelectedImageBlockAttributes({
//     alt: 'Updated Alt Text',
//     title: 'Updated Title Text',
//     caption: 'Updated Caption Text',
//     description: 'Updated Description Text'
// });











