// document.addEventListener("DOMContentLoaded", function () {
//     // 创建按钮
//     var button = document.createElement("button");
//     button.id = "aicontentseo-admin-button";
//     button.innerText = "AI Assistant";
//     button.setAttribute("lay-on", "aicontentseo-assistant");

//     // 设置按钮样式
//     button.style.position = "fixed";
//     button.style.bottom = "20px";
//     button.style.right = "20px";
//     button.style.padding = "10px 20px";
//     button.style.background = "#0073aa";
//     button.style.color = "#fff";
//     button.style.border = "none";
//     button.style.borderRadius = "5px";
//     button.style.cursor = "pointer";
//     button.style.boxShadow = "0 2px 5px rgba(0,0,0,0.2)";
//     button.style.zIndex = "9999";

//     // 监听点击事件
//     // button.addEventListener("click", function () {
//     //     alert("AI Assistant！");
//     //     // 这里可以添加 AJAX 请求或其他操作
//     // });

//     // 将按钮添加到 body
//     document.body.appendChild(button);
// });


document.addEventListener("DOMContentLoaded", function () {
    // 创建按钮
    var button = document.createElement("button");
    button.id = "aicontentseo-admin-button";
    button.innerText = "AI Assistant";
    button.setAttribute("lay-on", "aicontentseo-assistant");

    // 设置按钮样式
    button.style.position = "fixed";
    button.style.bottom = "20px";
    button.style.left = "50%";
    button.style.transform = "translateX(-50%)";
    button.style.padding = "10px 20px";
    button.style.background = "#0073aa";
    button.style.color = "#fff";
    button.style.border = "none";
    button.style.borderRadius = "5px";
    button.style.cursor = "pointer";
    button.style.boxShadow = "0 2px 5px rgba(0,0,0,0.2)";

    // 🚨 最关键：超级 z-index，并加 important 防止覆盖
    button.style.zIndex = '2147483647';  // 最大安全值

    // 确保 pointerEvents 正常
    button.style.pointerEvents = "auto";

    // 追加 !important 样式（即使其他 CSS 覆盖也不怕）
    button.style.setProperty('z-index', '2147483647', 'important');
    button.style.setProperty('position', 'fixed', 'important');

    // 将按钮添加到 body
    document.body.appendChild(button);
});

