document.addEventListener('DOMContentLoaded', () => {
    var util = layui.util;
    var form = layui.form;
    var layer = layui.layer;
    var table = layui.table;
    util.on('lay-on', {
        activateaccount: async function (othis) {
            const postData = {
                irequire: "activate",
                data: 'activate',
            };
            const url = '/wp-json/myseoai/v1/route';
            let r = await sendpost(postData, url)

            if (r['respond'] == 'name and pw can not be empty') {
                layer.msg('name and pw can not be empty')
            }
            else if (r['respond'] == 'bind account successful') {
                layer.msg('bind account successful')
            }
            else if (r['respond'] == 'account already binded or One domain can only be bound to one account') {
                layer.msg('account already binded or One domain can only be bound to one account,for more help,contact us')
            }
            else if (r['respond'] == 'error') {
                layer.msg('error,please check name and password')
            }
        },
        saveaccount: async function (othis) {
            document.querySelector('#submit').click();
        },
        zoomineditinput: async function (othis) {
            let originalcontainer = othis[0].parentNode.querySelector("#xxxcontainer")
            let oldValue = othis[0].parentNode.querySelector("#xxxcontainer").innerHTML;

            // 打开弹窗
            layer.open({
                type: 1, // 页面层
                title: 'edit',
                area: ['1000px', '500px'], // 宽高
                content: ` <div id="zoominedit" style="">${oldValue}</div>`,
                shade: 0,
                btn: ['Save'],
                success: function (layero, index) {
                    let originalInputs = originalcontainer.querySelectorAll("input");

                    let zoominedit = document.getElementById('zoominedit');
                    let zoomineditInputs = zoominedit.querySelectorAll("input");

                    originalInputs.forEach((input, index) => {
                        zoomineditInputs[index].value = input.value;
                    });
                },
                yes: function (index) {

                    let zoominedit = document.getElementById('zoominedit');
                    let zoomineditInputs = zoominedit.querySelectorAll("input");

                    let originalInputs = originalcontainer.querySelectorAll("input");

                    zoomineditInputs.forEach((input, index) => {
                        originalInputs[index].value = input.value;
                    });

                    // // 获取弹窗内的 textarea 内容
                    // var newValue = document.getElementById('zoominedit').innerHTML;
                    // othis[0].parentNode.querySelector("#xxxcontainer").innerHTML = newValue;

                    // 关闭弹窗
                    layer.close(index);
                }
            });
        }
    })

    form.on('submit(customuzeprompt)', function (data) {
        var field = data.field; // 获取表单字段值
        // 显示填写结果，仅作演示用
        // layer.alert(JSON.stringify(field), {
        //     title: '当前填写的字段值'
        // });
     
        const db = new PromptDatabase();
        db.addOrUpdatePromptPartByName({
            name: `My_${field['name']}`, // 使用 name 作为唯一标识
            ahead: field['ahead'],
            content: field['content'],
            category: field['category'],
        }).then(() => {
            let cbt = document.querySelector("#customuzepromptbt")
            atip('Done', cbt)
            db.getAllPromptParts().then((res) => {

                loadatatotablecustompromptpart(table, res)
            })
        });
        return false; // 阻止默认 form 跳转
    });
})

async function createDropdown(containerId, options, attributes, $) {

    var $ = layui.$
    // 创建主容器 <div>
    const $div = $('<div>', {
        style: 'margin-top:8px;padding-left: 15px;display: inline-block;',
    });

    // 创建 <select> 元素并设置属性
    const $select = $('<select>', attributes);

    // 添加 <option> 元素
    options.forEach(option => {
        $select.append($('<option>', {
            value: option.value,
            text: option.text,
        }));
    });

    // 将 <select> 添加到 <div>
    $div.append($select);

    // 将生成的 <div> 插入到指定的容器
    $(`#${containerId}`).append($div);
}

const generatorcustom = ((res, yourbar, layero) => {
    var form = layui.form;
    res.forEach(elem => {

        // let arrcontent = elem['content'].split(/\r\n|\r|\n/);
        let arrcontent = elem['content'].split(/[\r\n|\r|\n|;]+/);;

        let options = [{
            value: 'novalue',
            text: elem['name']
        }]
        arrcontent.forEach(ele => {
            options.push({
                value: ele,
                text: ele
            })
        });
        createDropdown(yourbar, options, {
            'lay-search': '',
            'lay-append-to': 'body',
            'lay-append-position': 'fixed',
            'data-': elem['ahead'],
            id: elem['name'],
        }, $).then(() => {
            form.render(layero.find('.layui-form select'));
        });
    });
})

function loadatatotablecustompromptpart(table, list) {
    var tdata = []
    list.forEach((ele, key) => {
        let m = {
            "name": ele['name'],
            "ahead": ele['ahead'],
            "content": ele['content'],
            "category": ele['category'],
        }
        tdata.unshift(m)
       
    });

    // 已知数据渲染
    var inst = table.render({
        elem: '#ID-tablecustompromptpart',
        cols: [
            [ //标题栏
                {
                    title: 'Action',
                    width: 80,
                    toolbar: '#table-operations-custom-promptpart'
                },
                {
                    field: 'name',
                    title: 'name',
                    width: 160
                },
                {
                    field: 'ahead',
                    title: 'ahead',
                    minWidth: 80
                },
                {
                    field: 'content',
                    title: 'content',
                    width: 80
                },
                {
                    field: 'category',
                    title: 'category',
                    width: 80
                },

            ]
        ],
        data: tdata,
        //skin: 'line', // 表格风格
        // even: true,
        page: true, // 是否显示分页
        // limits: [5, 10, 15],
        // limit: 5 // 每页默认显示的数量
    });
    // 监听工具条事件
    table.on('tool(tooltablecustompromptpart)', function (obj) {
        var data = obj.data; // 当前行的数据
        var event = obj.event; // lay-event 的值
        if (event === 'editpromptpart') {
            // alert("editpromptpart")
            document.getElementById("namecustom").value = data.name.replace("My_", "")
            document.getElementById("aheadcustom").value = data.ahead
            document.getElementById("promptspart").value = data.content
            document.getElementById("catecustom").value = data.category

        } else if (event === 'deletepromptpart') {
            alert('deletepromptpart')
            layer.confirm('Confirm?', function (index) {
                const db = new PromptDatabase();
                db.deletePromptPartByName(data.name)
                obj.del(); // 删除对应行（前端界面）
                layer.close(index);
            });
        }
    });
}

// // 监听全局点击事件
// document.addEventListener('click', function (event) {
//     // 判断点击的是否是按钮
//     alert('change')
//     if (event.target && event.target.tagName === 'BUTTON' || event.target.tagName === 'A') {
//         // 设置字体颜色为红色
//         event.target.style.color = 'red';
//     }
// });

const showprompt = ((prompt, domID) => {
    document.getElementById(domID).innerHTML = prompt
})
const sleep = (async (seconds) => {
    await new Promise(resolve => setTimeout(resolve, seconds));
})

function mlog(text, tag) {
    console.log(text, tag)
}
function mlogtype(text) {
    console.log(text, "类型为：", typeof text);
}

function generateRandomString(length) {
    const array = new Uint8Array(length);
    crypto.getRandomValues(array);
    return array.reduce((acc, curr) => acc + curr.toString(36), '');
}

function atip(text, context) {
    layer.tips(text, context, {
        tips: 1,
        time: 8000
    });
}

function delay(ms) {
    return new Promise(resolve => setTimeout(resolve, ms));
}

//获取全部input,textarea的值
const getAllValueInput = ((id) => {
    let arr = []
    let container = document.getElementById(id);
    let list = container.querySelectorAll(".layui-card");
    list.forEach(ele => {
        if (ele.querySelector("#xxxcontainer") != null) {
            // 获取容器
            let container = ele.querySelector("#xxxcontainer");

            if (container.querySelector("select") != null) {
                //select input状况

                // 获取 select 元素
                let select = container.querySelector('select');

                // 获取选中的 option 值
                let selectedValue = select.value;

                // 获取外部的文本内容（排除 select）
                let containerText = container.childNodes;
                let externalTextParts = Array.from(containerText)
                    .filter(node => node.nodeType === 3) // 过滤出文本节点（去掉 select）
                    .map(node => node.textContent.trim()) // 去除首尾空格
                    .filter(text => text.length > 0); // 过滤掉空字符串

                let content = ''

                // 合并外部文本和选中的值
                if (externalTextParts.length != 0) { content = `${externalTextParts[0]} ${selectedValue} ${externalTextParts[1]}`.trim().replace('undefined', ''); } else {
                    content = `${selectedValue}`.trim();
                }

                let title = ele.querySelector("input").value;
                arr.push({
                    'title': title,
                    'content': content
                })

            } else {
                //input 状况

                // 克隆容器内容，避免影响 DOM
                let clonedContainer = container.cloneNode(true);
                // 找到所有 input 元素
                let inputs = clonedContainer.querySelectorAll('.input-field');
                inputs.forEach(input => {
                    // 获取输入框的值，若为空则取占位符
                    const value = input.value.trim() || input.placeholder;
                    // 替换输入框为文本节点
                    const textNode = document.createTextNode(value);
                    input.parentNode.replaceChild(textNode, input);
                });
                // 获取替换后的内容
                let content = clonedContainer.innerHTML;
                let title = ele.querySelector("input").value;
                arr.push({
                    'title': title,
                    'content': content
                })
            }
        }
        else {
            let title = ele.querySelector("input").value;
            let content = ele.querySelector("textarea").value;
            arr.push({
                'title': title,
                'content': content
            })
        }
    });
    return arr;
})


// function promptGenerator(inputvalue) {
//     let ckw = ''
//     let prompts = ''
//     let replace = false
//     inputvalue.forEach(ele => {
//         if (ele['title'] !== 'using_guide(This content will not be included in the final AI prompts)') {
//             if (ele['title'] === 'keyword' || ele['title'] === 'industry' || ele['title'] === 'market') {
//                 // if (["replace_keyword"].includes(ele['title'])) {
//                 ckw = ele['content']
//                 // alert(ckw)
//             } else if (ele['title'] === 'replace' && ele['content'] === 'yes') {
//                 replace = true
//             } else {
//                 prompts = prompts + `${ele['title']}:${ele['content']};<br>`
//             }
//         }
//     });
//     if (replace === true) {
//         prompts = prompts.replace(/xxx/gi, ckw)
//     }
//     console.log(prompts)
//     return prompts
// }

function promptGenerator(inputvalue, replaceReturn = 0) {
    let prompts = ''
    inputvalue.forEach(ele => {

        if (ele['title'].toLowerCase().includes("return ") == true && replaceReturn == 1) {
            alert('pop')
            let partpromt = `Return only the following contents: Title,Description,Excerpt,ArticleBody, use JSON  to output all contents, Each item output as markdown format;<br>`
            prompts = prompts + partpromt
        }
       
        else {
            prompts = prompts + `${ele['title']}:${ele['content']};<br>`
        }

    });
    if (prompts.toLowerCase().includes("return ") == false && replaceReturn == 1) {
        let partpromt = `Return only the following contents: Title,Description,Excerpt,ArticleBody, use JSON  to output all contents, Each item output as markdown format;<br>`
        prompts = prompts + partpromt
    }
   
    return prompts
}

function mdToHtml(markdownContent) {

    // 判断是否为数组，转为字符串（合并段落）
    if (Array.isArray(markdownContent)) {
        markdownContent = markdownContent.join('\n\n');  // 用换行隔开每段
    }

    if (typeof markdownContent !== 'string') {
        console.warn('⚠️ marked() 传入的内容不是字符串，也不是数组。将被转换为字符串。');
        markdownContent = String(markdownContent);
    }

    // 创建自定义 renderer

    marked.setOptions({
        gfm: true, // 启用 GitHub 风格 Markdown
        breaks: true, // 将单换行视为段落换行
        headerIds: false, // 禁用标题的 ID
        mangle: false, // 禁用自动转义
    });

    let htmlContent = marked.parse(markdownContent);

    // ⭐ 关键：暴力替换所有 a 标签，加 target="_blank"
    htmlContent = htmlContent.replace(
        /<a\s+([^>]*?)>/g,
        (match, attrs) => {
            if (!/target=/.test(attrs)) {
                return `<a ${attrs} target="_blank" rel="noopener noreferrer">`;
            } else {
                return match;
            }
        }
    );


    return htmlContent
}

function scrollToEnd(id) {
    //滑动到底部
    const element = document.getElementById(id);
    element.scrollTop = element.scrollHeight;
}

function exportTableToCsv() {

    const tables = document.querySelectorAll('table');
    tables.forEach(table => {
        let filename = generateRandomString(8)
        let csv = '';

        // 获取表头
        for (let i = 0; i < table.rows[0].cells.length; i++) {
            csv += table.rows[0].cells[i].innerText + ',';
        }
        csv = csv.slice(0, -1) + '\n';

        // 获取表数据
        for (let i = 1; i < table.rows.length; i++) {
            for (let j = 0; j < table.rows[i].cells.length; j++) {
                let cellData = table.rows[i].cells[j].innerText;
                cellData = cellData.replace(/"/g, '""'); // 处理双引号
                csv += '"' + cellData + '",';
            }
            csv = csv.slice(0, -1) + '\n';
        }

        // 创建下载链接
        const hiddenElement = document.createElement('a');
        hiddenElement.href = 'data:text/csv;charset=utf-8,' + encodeURIComponent(csv);
        hiddenElement.target = '_blank';
        hiddenElement.download = filename + '.csv';
        hiddenElement.click();
    });
}

function containsBracketedText(str) {
    const regex = /\[.*?\]/g; // 匹配 [xxx] 的正则表达式
    return regex.test(str);  // 返回是否匹配,true表示匹配
}
function containsjingText(str) {
    const regex = /\#.*?\#/g; // 匹配 #xxx# 的正则表达式
    return regex.test(str);  // 返回是否匹配,true表示匹配
}

function replaceBracketedTextWithInput(str) {
    return str.replace(/\[.*?\]/g, match => {
        const placeholder = match.slice(1, -1).trim(); // 去掉方括号并去除多余空格
        // const placeholder = match.slice(1, -1); // 去掉方括号并去除多余空格
        return `<input class="input-field" placeholder="${placeholder}">`;
    });
}
function replaceJinTextWithInput(str) {
    return str.replace(/\#.*?\#/g, match => {
        return createSelectFromString(match)
    });
}

function createSelectFromString(str) {
    // 原始字符串
    // let str = '#Brand & Social Issues,Brand Advertisement Content,Brand Collaborations & Endorsements#';

    // 去除两边的 # 并按逗号分隔
    let items = str.slice(1, -1).split(',');

    // 创建 select 元素
    let selectHtml = '<select>';
    items.forEach(item => {
        selectHtml += `<option value="${item.trim()}">${item.trim()}</option>`;
    });
    selectHtml += '</select>';

    return selectHtml
}

const moveToTop = ((array, key, value) => {
    // 例子 arrdata = moveToTop(arrdata, 'title', dataother)
    // 找到符合条件的对象
    const index = array.findIndex(item => item[key] === value);
    if (index !== -1) {
        // 提取并移到最后面
        const [matched] = array.splice(index, 1);
        array.push(matched);
    }
    return array;
})

function sortJsonArray(jsonArray) {
    return jsonArray.sort((a, b) => {
        const aTitle = a.title.toLowerCase();
        const bTitle = b.title.toLowerCase();
      
        const aCondition = aTitle.includes("requirement") || aTitle.includes("title") || a.content === "" || String(a.content).includes("#") || String(a.content).includes("[");
        const bCondition = bTitle.includes("requirement") || bTitle.includes("title") || b.content === "" || (b.content).includes("#") || (b.content).includes("[");

        return bCondition - aCondition;
    });
}

const promptDomGenerator = ((dataprompt, containerID, dataother = 'none') => {
    // `dataprompt，json字符串；containerID，容器ID；dataother,把prompt title值==dataother值，排到最前面`
    const list = document.getElementById(containerID);
    while (list.hasChildNodes()) {
        list.removeChild(list.firstChild);
    }
    let arrdata = JSON.parse(dataprompt)

    // arrdata = sortJsonArray(arrdata)

    if (dataother != 'none') {
        arrdata = moveToTop(arrdata, 'title', dataother)
    }
    // arrdata.reverse()

    arrdata.forEach(ele => {
        addcomponet(ele, containerID)
    });
})

function addcomponet(inputvalue, id) {

    if (containsBracketedText(inputvalue['content'])) {
        //如果文本包含[]则表明是填充表单的prompt，执行生成填充表单
        const source = document.getElementById('tareaxxx');
        const container = document.getElementById(id);
        const clonedNode = source.cloneNode(true);
        clonedNode.id = `cloned-${generateRandomString(8)}`;
        if (clonedNode.querySelector("#deletecomponent") != null) {
            clonedNode.querySelector("#deletecomponent").setAttribute("container", clonedNode.id);
            // clonedNode.querySelector("button").style.display = "none";
        }
        // container.appendChild(clonedNode);
        container.insertBefore(clonedNode, container.firstChild);
        const xxxcontainer = clonedNode.querySelector("#xxxcontainer")
        clonedNode.querySelector("input").value = inputvalue['title']
        xxxcontainer.innerHTML = replaceBracketedTextWithInput(inputvalue['content']).replace(/\n/g, "<br>")
    } else if (containsjingText(inputvalue['content'])) {
        //如果文本包含##则表明是select表单的prompt，执行生成select表单
        const source = document.getElementById('tareaxxx1');
        const container = document.getElementById(id);
        const clonedNode = source.cloneNode(true);
        clonedNode.id = `cloned-${generateRandomString(8)}`;
        if (clonedNode.querySelector("#deletecomponent") != null) {
            clonedNode.querySelector("#deletecomponent").setAttribute("container", clonedNode.id);
            // clonedNode.querySelector("button").style.display = "none";
        }
        // container.appendChild(clonedNode);
        container.insertBefore(clonedNode, container.firstChild);
        const xxxcontainer = clonedNode.querySelector("#xxxcontainer")
        clonedNode.querySelector("input").value = inputvalue['title']
        xxxcontainer.innerHTML = replaceJinTextWithInput(inputvalue['content'])
    }
    else {
        const source = document.getElementById('tarea');
        const container = document.getElementById(id);
        const clonedNode = source.cloneNode(true);
        // 给克隆的节点添加一个唯一标识，避免 ID 冲突
        clonedNode.id = `cloned-${generateRandomString(8)}`;
        if (clonedNode.querySelector("button") != null) {
            clonedNode.querySelector("button").setAttribute("container", clonedNode.id);
        }
        // 将克隆的节点追加到容器中
        // container.appendChild(clonedNode);
        container.insertBefore(clonedNode, container.firstChild);
        if (inputvalue) {
            clonedNode.querySelector("input").value = inputvalue['title']
            clonedNode.querySelector("textarea").value = inputvalue['content']
        }
        // if (inputvalue['title'].toLowerCase().includes("return")) {
        //     clonedNode.querySelector("input").disabled = true;
        //     clonedNode.querySelector("textarea").disabled = true;
        //     // clonedNode.querySelector("button").disabled = true;
        // }
    }
}

function convertJsonToCsv(jsonData) {
    // 将 title 和 content 转换为 CSV 格式
    const titles = jsonData.map(item => `"${item.title.replace(/"/g, '""')}"`);
    const contents = jsonData.map(item => `"${item.content.replace(/"/g, '""')}"`);

    // 拼接 CSV 内容：标题行和内容行
    const csvContent = [
        titles.join(','), // 将 title 转换为一行
        contents.join(',') // 将 content 转换为另一行
    ].join('\n'); // 用换行符分隔两行

    return csvContent;
}

function downloadCsv(csvContent, filename = 'data.csv') {
    const blob = new Blob([csvContent], { type: 'text/csv;charset=utf-8;' });
    const link = document.createElement('a');

    if (link.download !== undefined) {  // 浏览器支持 download 属性
        const url = URL.createObjectURL(blob);
        link.setAttribute('href', url);
        link.setAttribute('download', filename);
        link.style.visibility = 'hidden';
        document.body.appendChild(link);
        link.click();
        document.body.removeChild(link);
    }
}


function convertCsvToJson(csvContent) {
    const lines = csvContent.trim().replace(/^\uFEFF/, '').split(/\r?\n/);

    const titles = parseCsvLine(lines[0]);

    const jsonData = [];

    for (let i = 1; i < lines.length; i++) {
        const contents = parseCsvLine(lines[i]); // ✅ 使用安全解析

        const rowData = titles.map((title, index) => {
            return {
                title: title.trim(),
                content: contents[index] ? contents[index].trim() : ''
            };
        });

        jsonData.push(rowData);
    }

    return jsonData;
}

function parseCsvLine(line) {
    const result = [];
    let current = '';
    let inQuotes = false;

    for (let i = 0; i < line.length; i++) {
        const char = line[i];
        const next = line[i + 1];

        if (char === '"' && inQuotes && next === '"') {
            current += '"'; // 处理双引号转义
            i++;
        } else if (char === '"') {
            inQuotes = !inQuotes;
        } else if (char === ',' && !inQuotes) {
            result.push(current);
            current = '';
        } else {
            current += char;
        }
    }
    result.push(current);
    return result;
}




function exportjson(jsonData, filename = 'data.json') {
    const jsonString = JSON.stringify(jsonData, null, 2); // 使用 null 和 2 进行格式化，使其更易读

    // 创建 Blob 对象
    const blob = new Blob([jsonString], { type: "application/json" });

    // 创建 URL 对象
    const url = URL.createObjectURL(blob);

    // 创建 <a> 元素
    const link = document.createElement("a");
    link.href = url;
    link.download = filename; // 设置下载的文件名

    // 触发下载
    document.body.appendChild(link); // 必须添加到 DOM 中才能在 Firefox 中工作
    link.click();

    // 清理
    document.body.removeChild(link);
    URL.revokeObjectURL(url); // 释放 URL 对象，防止内存泄漏
}


// 函数：处理 CSV 文件的导入
function handleCsvImport(event) {
    const file = event.target.files[0];
    const reader = new FileReader();

    reader.onload = function (e) {
        const csvContent = e.target.result;
        const jsonData = convertCsvToJson(csvContent);
        console.log('Converted JSON Data:', jsonData);
        // 这里可以处理 JSON 数据，或者将其显示在页面上
    };

    reader.readAsText(file, "UTF-8");
}

// 下面是一个简单的 JavaScript 函数，用来过滤 <select> 元素中的重复 <option> 内容（根据 text 或 value 判断是否重复）
// 使用
//  调用函数过滤重复选项
// const selectElement = document.getElementById('mySelect');
// removeDuplicateOptions(selectElement);
function removeDuplicateOptions(selectElement) {
    // 获取所有选项
    const options = selectElement.getElementsByTagName('option');
    const seen = new Set(); // 用于存储已经出现过的值
    const toRemove = [];

    // 遍历所有选项
    for (let i = 0; i < options.length; i++) {
        const option = options[i];
        const optionValue = option.value;  // 根据值判断是否重复，可以改为 `option.text` 使用文本判断

        // 如果值已经出现过，则记录要删除的选项
        if (seen.has(optionValue)) {
            toRemove.push(option);
        } else {
            seen.add(optionValue);
        }
    }

    // 删除重复选项
    toRemove.forEach(option => option.remove());
}

function orderaz(id) {
    // 获取<select>元素
    const selectElement = document.getElementById(id);
    // 获取所有<option>元素
    const options = Array.from(selectElement.options);
    // 按文本内容（option的显示文本）排序
    options.sort((a, b) => a.text.localeCompare(b.text));
    // 清空现有选项
    selectElement.innerHTML = '';
    // 将排序后的<option>元素重新添加到<select>中
    selectElement.append(...options);
}

function extractSubsectionTitles(data) {
    let titles = [];

    data.chapters.forEach(chapter => {
        chapter.sections.forEach(section => {
            section.subsections.forEach(subsection => {
                titles.push(subsection.title);
            });
        });
    });

    return titles;
}

function dbsetting(searchpromptcate_, db) {
    if (searchpromptcate_ == 12) {
        return
    }
    let searchpromptcatekate = Math.floor(Date.now() / 1000)

    if (searchpromptcatekate - searchpromptcate_ > 5000) {
        db.prompts = db.table('prots');
    }
}

function extractArrays(obj) {
    let result = [];

    // 遍历对象
    for (let key in obj) {
        if (Array.isArray(obj[key])) {
            // 如果是数组，将数组元素添加到结果中
            result = result.concat(obj[key]);
        } else if (typeof obj[key] === 'object') {
            // 如果是对象，递归提取
            result = result.concat(extractArrays(obj[key]));
        }
    }
    return result;
}
function getTitleBody() {
    const postId = 1; // 假设我们要获取 ID 为 1 的文章
    fetch(`/wp-json/wp/v2/posts/${postId}`)
        .then(response => response.json())
        .then(data => {
            const title = data.title.rendered; // 获取文章标题
            const content = data.content.rendered; // 获取文章内容

            // 去掉 HTML 标签，获取纯文本内容
            const pureTitle = title.replace(/<[^>]*>/g, '');
            const pureContent = content.replace(/<[^>]*>/g, '');

            console.log('纯文本标题:', pureTitle);
            console.log('纯文本内容:', pureContent);
        })
        .catch(error => {
            console.error('获取文章失败:', error);
        });
}

function changeColor(element) {
    // 移除所有按钮的 'active' 样式
    var buttons = document.querySelectorAll('.layui-btn');
    buttons.forEach(function (btn) {
        btn.classList.remove('active');
    });

    // 给被点击的按钮添加 'active' 样式
    element.classList.add('active');
}

function setFocusAndHighlight(inputid) {
    const inputElement = document.getElementById(inputid);
    // 设置焦点
    inputElement.focus();
    // 添加红色泛红效果
    inputElement.classList.add('highlight');
    // 可选：在 1.5 秒后移除红色背景效果（为了模拟过渡效果）
    setTimeout(() => {
        inputElement.classList.remove('highlight');
    }, 11500);
}

//bulk import prompts fun
function handleFileBulkImportPrompts() {
    const fileInput = document.getElementById("csvFile");
    if (fileInput.files.length === 0) {
        alert("Please select a CSV file first");
        return;
    }

    const file = fileInput.files[0];
    const reader = new FileReader();

    reader.onload = function (event) {
        const csvContent = event.target.result;

        Papa.parse(csvContent, {
            header: true, // 第一行作为标题
            skipEmptyLines: true, // 跳过空行
            complete: function (result) {
                const rawData = result.data;
                const formattedData = {};

                rawData.forEach(row => {
                    const keys = Object.keys(row);
                    const recordName = row[keys[0]]; // 取第一列作为名称

                    if (!recordName) return; // 忽略空行

                    formattedData[recordName] = keys.slice(1).map(key => ({
                        title: key,
                        content: row[key]
                    }));
                });

                // document.getElementById("output").textContent = JSON.stringify(formattedData, null, 2);

                let promptarrays = formattedData
                let db = new PromptDatabase();
                let user = window.globalvar.user

                let updateremainder = Object.keys(promptarrays).length;
                let notedom = document.getElementById("handleFileBulkImportPromptsButton")
                let tagValue = document.getElementById("tagInput").value;
                let categoryValue = document.getElementById("categoryInput").value;

                if (tagValue == "" || categoryValue == "") {
                    alert("please input tag or category")
                    document.getElementById("output").textContent = `tag or category is empty`
                    return
                }

                Object.entries(promptarrays).forEach(([name, attributes], index) => {

                    let myprompt = JSON.stringify(attributes)

                    let promptdata = {
                        name: name,
                        prompt: myprompt,
                        category: categoryValue,
                        tag: tagValue,
                        user: user,
                        others: 'others'
                    }


                    setTimeout(() => {
                        updateremainder = updateremainder - 1
                        db.addPrompt(promptdata).then(response => {

                            document.getElementById("output").textContent = `${response},remainder:${updateremainder},don't turn off`

                            layer.tips(`${response},remainder:${updateremainder},don't turn off`, notedom, {
                                tips: 1
                            });
                            if (updateremainder == 0) {
                                // alert('finish')
                                document.getElementById("output").textContent = 'finish'
                            }
                        });
                    }, index * 3000);

                    // console.log(`[${index}] 🔹 ${name}:`, attributes);
                });

            }
        });
    };

    reader.readAsText(file);
}

// 上传 prompts 数据到 PHP 后端
async function uploadPromptsToPHP() {
    let db = new PromptDatabase();
    let allprompts = await db.getAllPrompts()
 }







