function isset(v) {
    //判断变量是否定义
    if (typeof v !== 'undefined') {
        // console.log("r is defined:", r);
        return true
    } else {
        // console.log("r is not defined.");
        return false
    }
}


const SyncPromptsFromContentaiseo = (async (db) => {
    const postData = {
        irequire: "prompt_table",
        subr: "syncaiseo"
    };
    const url = '/wp-json/myseoai/v1/route';
    let r = await sendpost(postData, url)
    if (r['respond'] == '200') {

        let prompts = r['dataresult']['data']
        prompts.forEach(ele => {
            db.addPrompt(ele)
        });
        alert('completely import the AI prompts, please refresh page')
        // location.reload(true);
    } else {
        atip('download prompts error', othis)
    }
})

const getaiparams = ((aitype) => {
    let params = new LocalStorageCache('ai_params', 20);
    let found = params.find(item => item.id === aitype);
    let ai_params_ = ''
    if (found != undefined) {
        ai_params_ = found;
        //找不到就使用默认参数
    } else {
        if (aitype == "chatgpt") {
            ai_params_ = openai_params;
        }
        else if (aitype == "deepseek") {
            ai_params_ = deepseek_params;
        }
        else if (aitype == "claude") {
            ai_params_ = claude_params;
        }
    }
    return ai_params_
})

const requestOpenai = (async (params, irequire = "request_openai", save) => {
    var ai_choice = params.id
    delete params.id

    // params = {
    //     "model": "gpt-4o-mini",
    //     "max_tokens": 4096,
    //     "temperature": 0.7,
    //     "top_p": 1,
    //     "n": 1,
    //     "stop": null,
    //     "logprobs": null,
    //     "presence_penalty": 0,
    //     "frequency_penalty": 0,
    //     "user": "user_identifier",
    //     // "prompt":"history of today"
    //     "messages": [
    //         {
    //             "role": "user",
    //             "content": "add title of wp"
    //         }
    //     ]
    // }
    // 最简模型,奇葩模型用最简
    const isMinimalModel = (
        params.model.includes('o3-') ||
        params.model.includes('o1-')

    );
    if (isMinimalModel) {
        params = {
            "model": params.model,
            "messages": params.messages.filter(m => m.role === 'user')
        }
    }

    const postData = {
        irequire: irequire,
        params: params,
        ai: ai_choice,
        save: save
    };
    const url = '/wp-json/myseoai/v1/route';
    let result = await sendpost(postData, url)
    return result
})

const requestAiImg = (async (params, irequire = "request_ai_img") => {
    var ai_choice = contentAISEOAdmin.ai_choice

    if (ai_choice != 'chatgpt') {
        alert('Now only support chatgpt image generator')
        return
    }
    const postData = {
        irequire: irequire,
        params: params,
        ai: ai_choice
    };

    const url = '/wp-json/myseoai/v1/route';
    let result = await sendpost(postData, url)
    return result
})

const openai_params_mini = {
    id: 'chatgpt',
    model: 'gpt-4.1-mini', // 使用的模型，例如 text-davinci-003 #选项
}


const openai_params = {
    id: 'chatgpt',
    model: 'gpt-4.1-mini', // 使用的模型，例如 text-davinci-003 #选项
    max_tokens: 8192, // 生成文本的最大长度 #text
    temperature: 0.7, // 生成的随机性，0.0-1.0，越低越确定#text
    top_p: 1, // 采用核采样，控制生成的多样性 #text
    n: 1, // 生成的响应数量 #text
    stop: null, // 停止的字符串，可以是字符串或数组 #text
    // stream: false, // 是否流式输出结果 #text
    logprobs: null, // 显示每个标记的日志概率 #text
    presence_penalty: 0, // 控制生成中重复的减少程度 (-2.0到2.0) #text
    frequency_penalty: 0, // 控制生成中高频词汇的惩罚 (-2.0到2.0) #text

    user: 'user_identifier' // 用于区分用户的标识符（可选）
};

const openai_params_image = {
    model: "dall-e-2", // DALL·E 3 生成图片
    prompt: "A futuristic city with flying cars and neon lights", // 图片描述
    n: 1, // 生成的图片数量（最多 10）
    size: "1024x1024", // 可选尺寸：1024x1024, 1792x1024, 1024x1792
    quality: "standard", // 可选：standard 或 hd
    style: "vivid", // vivid（鲜艳）或 natural（自然）
    response_format: "url" // 返回 URL
};


const deepseek_params = {
    // messages: [
    //     {
    //         content: "You are a helpful assistant",
    //         role: "system"
    //     },
    //     {
    //         content: "Hi",
    //         role: "user"
    //     }
    // ],
    id: 'deepseek',
    model: "deepseek-chat",
    frequency_penalty: 0,
    max_tokens: 8192,
    presence_penalty: 0,
    // response_format: {
    //     type: "text"
    // },
    stop: null,
    // stream: false,
    // stream_options: null,
    temperature: 1,
    top_p: 1,
    tools: [],
    tool_choice: "none",
    // logprobs: false,
    // top_logprobs: null
};

const claude_params = {
    id: 'claude',
    model: "Claude-3.5-Haiku",
    max_tokens: 1024,
    temperature: 0.7,
    // messages: [
    //     { role: "user", content: userInput }
    // ],
    // stop_sequences: [],
    top_p: 1,
    top_k: 50,
    stream: false
};

const generateAIParamsForm = (params, containerid) => {
    const form = document.createElement('form');
    form.setAttribute('id', containerid);

    // Submit button
    const submitButton = document.createElement('span');
    submitButton.setAttribute('type', 'submit');
    submitButton.setAttribute('lay-on', 'submit_params');
    submitButton.textContent = 'Submit';
    form.appendChild(submitButton);

    const restButton = document.createElement('span');
    restButton.setAttribute('lay-on', 'rest_params');
    restButton.textContent = 'Rest Params';
    form.appendChild(restButton);

    for (const key in params) {
        const value = params[key];

        const label = document.createElement('label');
        label.setAttribute('for', key);
        label.textContent = key;

        let input;

        if (key === 'model') {
            // Dropdown for the "model" field
            input = document.createElement('select');
            input.setAttribute('name', key);
            input.setAttribute('id', key);

            // Example model options
            if (containerid == "openaiForm") {
                // var models = ["gpt-4o-mini", "o3-mini", "o1-mini", "gpt-4o", "gpt-4o-mini-search-preview", "gpt-4o-search-preview", "chatgpt-4o-latest", "gpt-3.5-turbo", "davinci-002", "babbage-002"];
                var models = [
                    "gpt-4.1",
                    "gpt-4.1-mini",
                    "gpt-4.1-nano",
                    "gpt-4.1-nano-2025-04-14",
                    "gpt-4.1-mini-2025-04-14",
                    "gpt-4.1-2025-04-14",
                    "o3",
                    "o1-mini",
                    "o1-mini-2024-09-12",
                    "o1-preview",
                    "o1-preview-2024-09-12",
                    "o3-2025-04-16",
                    "gpt-4o",
                    "gpt-4o-mini",
                    "gpt-4o-audio-preview",
                    "gpt-4o-search-preview",
                    "gpt-4o-search-preview-2025-03-11",
                    "gpt-4o-mini-search-preview-2025-03-11",
                    "gpt-4o-mini-search-preview",
                    "gpt-4o-mini-audio-preview-2024-12-17",
                    "gpt-4o-mini-audio-preview",
                    "gpt-4o-mini-2024-07-18",
                    "gpt-4o-audio-preview-2024-12-17",
                    "gpt-4o-audio-preview-2024-10-01",
                    "gpt-4o-2024-11-20",
                    "gpt-4o-2024-08-06",
                    "gpt-4o-2024-05-13",
                    "gpt-4.5-preview-2025-02-27",
                    "gpt-4.5-preview",
                    "gpt-4-turbo-preview",
                    "gpt-4-turbo-2024-04-09",
                    "gpt-4-turbo",
                    "gpt-4-1106-preview",
                    "gpt-4-0613",
                    "gpt-4-0125-preview",
                    "gpt-4",
                    "gpt-3.5-turbo-16k",
                    "gpt-3.5-turbo-1106",
                    "gpt-3.5-turbo-0125",
                    "gpt-3.5-turbo",
                    "chatgpt-4o-latest"
                ];
                models.unshift(value)
            }
            else if (containerid == "deepseekForm") {
                var models = ['deepseek-chat', 'deepseek-reasoner'];
                models.unshift(value)
            }
            else if (containerid == "claudeForm") {
                var models = ['Claude-3.7-Sonnet', 'Claude-3.5-Haiku'];
                models.unshift(value)
            }
            models.forEach((model) => {
                const option = document.createElement('option');
                option.value = model;
                option.textContent = model;
                if (model === value) option.selected = true;
                input.appendChild(option);
            });
        } else {
            // Input field for other parameters
            input = document.createElement('input');
            input.setAttribute('type', value === true || value === false ? 'checkbox' : 'text');
            input.setAttribute('name', key);
            input.setAttribute('id', key);

            if (value !== null) {
                input.value = value;
                if (typeof value === 'boolean') {
                    input.checked = value;
                }
            }
        }
        form.appendChild(label);
        form.appendChild(input);
        form.appendChild(document.createElement('br'));
    }

    document.body.appendChild(form);
    document.querySelector("#aiparams").appendChild(form);

    const idInput = form.querySelector("#id");
if (idInput) {
    idInput.disabled = true;
}
};

const saveformAIparams = (formid) => {
    if (formid == "#openaiForm") {
        const params = new LocalStorageCache('ai_params', 20);
        const form = document.querySelector(formid)
        let model = form.querySelector('#model').value
        params.update(item => item.id === 'chatgpt', { model: model });
        let max_tokens = parseInt(form.querySelector('#max_tokens').value)
        params.update(item => item.id === 'chatgpt', { max_tokens: max_tokens });
        let temperature = parseFloat(form.querySelector('#temperature').value)
        params.update(item => item.id === 'chatgpt', { temperature: temperature });
        let top_p = parseFloat(form.querySelector('#top_p').value)
        params.update(item => item.id === 'chatgpt', { top_p: top_p });
        let n = parseInt(form.querySelector('#n').value)
        params.update(item => item.id === 'chatgpt', { n: n });
        let stop = form.querySelector('#stop').value
        params.update(item => item.id === 'chatgpt', { stop: stop });
        let logprobs = form.querySelector('#logprobs').value
        params.update(item => item.id === 'chatgpt', { logprobs: logprobs });
        let presence_penalty = parseInt(form.querySelector('#presence_penalty').value)
        params.update(item => item.id === 'chatgpt', { presence_penalty: presence_penalty });
        let frequency_penalty = parseInt(form.querySelector('#frequency_penalty').value)
        params.update(item => item.id === 'chatgpt', { frequency_penalty: frequency_penalty });
        let user = form.querySelector('#user').value
        params.update(item => item.id === 'chatgpt', { user: user });
    }
    else if (formid == "#deepseekForm") {
        const params = new LocalStorageCache('ai_params', 20);
        const form = document.querySelector(formid)
        let model = form.querySelector('#model').value
        params.update(item => item.id === 'deepseek', { model: model });
        let frequency_penalty = parseInt(form.querySelector('#frequency_penalty').value)
        params.update(item => item.id === 'deepseek', { frequency_penalty: frequency_penalty });

        let max_tokens = parseInt(form.querySelector('#max_tokens').value)
        params.update(item => item.id === 'deepseek', { max_tokens: max_tokens });

        let presence_penalty = parseInt(form.querySelector('#presence_penalty').value)
        params.update(item => item.id === 'deepseek', { presence_penalty: presence_penalty });

        let stop = form.querySelector('#stop').value
        params.update(item => item.id === 'deepseek', { stop: stop });

        // let stream = form.querySelector('#stream').value
        // params.update(item => item.id === 'deepseek', { stream: stream });

        // let stream_options = form.querySelector('#stream_options').value
        // params.update(item => item.id === 'deepseek', { stream_options: stream_options });

        let temperature = parseFloat(form.querySelector('#temperature').value)
        params.update(item => item.id === 'deepseek', { temperature: temperature });

        let top_p = parseFloat(form.querySelector('#top_p').value)
        params.update(item => item.id === 'deepseek', { top_p: top_p });

        let toolsText = form.querySelector('#tools').value
        let tools;

        // 先判断一下，如果是空字符串，就给个空数组，否则尝试 JSON 解析
        if (!toolsText) {
            tools = [];
        } else {
            try {
                tools = JSON.parse(toolsText);
                // 再次确保它是数组，不是的话也给成 []
                if (!Array.isArray(tools)) {
                    tools = [];
                }
            } catch (e) {
                // 解析失败也默认成 []
                tools = [];
            }
        }
        params.update(item => item.id === 'deepseek', { tools: tools });

        // let logprobs = form.querySelector('#logprobs').value
        // params.update(item => item.id === 'deepseek', { logprobs: logprobs });

        // let top_logprobs = form.querySelector('#top_logprobs').value
        // params.update(item => item.id === 'deepseek', { top_logprobs: top_logprobs });
    }
    else if (formid == "#claudeForm") {
        const params = new LocalStorageCache('ai_params', 20);
        const form = document.querySelector(formid)
        let model = form.querySelector('#model').value
        params.update(item => item.id === 'claude', { model: model });
        let max_tokens = form.querySelector('#max_tokens').value
        params.update(item => item.id === 'claude', { max_tokens: max_tokens });
        let stop_sequences = form.querySelector('#stop_sequences').value
        params.update(item => item.id === 'claude', { stop_sequences: stop_sequences });
        let top_p = form.querySelector('#top_p').value
        params.update(item => item.id === 'claude', { top_p: top_p });
        let top_k = form.querySelector('#top_k').value
        params.update(item => item.id === 'claude', { top_k: top_k });
        let stream = form.querySelector('#top_p').value
        params.update(item => item.id === 'claude', { stream: stream });
    }

}

function fixTypesforChatgptParams(obj) {
    for (const key in obj) {
        const value = obj[key];

        if (typeof value === "string") {
            // 尝试转换为数字（整数或小数）
            if (!isNaN(value)) {
                obj[key] = value.includes(".") ? parseFloat(value) : parseInt(value);
            } else if (value === "") {
                obj[key] = null;
            }
        }

        // 如果是嵌套对象或数组，递归处理
        if (typeof obj[key] === "object" && obj[key] !== null) {
            fixTypes(obj[key]);
        }
    }

    return obj;
}

const injectStyles = () => {
    const style = document.createElement('style');
    style.textContent = `
        #openaiForm {
            max-width: 500px;
            margin: 20px auto;
            padding: 20px;
            border: 1px solid #ddd;
            border-radius: 8px;
            box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
            background-color: #f9f9f9;
        }
        #openaiForm label {
            margin-top: 16px;
            display: block;
            font-weight: bold;
            margin-bottom: 5px;
        }
        #openaiForm input, #openaiForm select {
            width: 100%;
            padding: 8px;
            margin-bottom: 15px;
            border: 1px solid #ccc;
            border-radius: 4px;
            font-size: 14px;
        }
        #openaiForm span {
            margin-right: 5px;
            margin-bottom: 15px;
            width: 100%;
            padding: 10px;
            font-size: 16px;
            color: #fff;
            background-color: #007bff;
            border: none;
            border-radius: 4px;
            cursor: pointer;
        }
        #openaiForm span:hover {
            background-color: #0056b3;
        }
         #deepseekForm {
            max-width: 500px;
            margin: 20px auto;
            padding: 20px;
            border: 1px solid #ddd;
            border-radius: 8px;
            box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
            background-color: #f9f9f9;
        }
        #deepseekForm label {
            margin-top: 16px;
            display: block;
            font-weight: bold;
            margin-bottom: 5px;
        }
        #deepseekForm input, #deepseekForm select {
            width: 100%;
            padding: 8px;
            margin-bottom: 15px;
            border: 1px solid #ccc;
            border-radius: 4px;
            font-size: 14px;
        }
        #deepseekForm span {
            margin-right: 5px;
            margin-bottom: 15px;
            width: 100%;
            padding: 10px;
            font-size: 16px;
            color: #fff;
            background-color: #007bff;
            border: none;
            border-radius: 4px;
            cursor: pointer;
        }
        #deepseekForm span:hover {
            background-color: #0056b3;
        }
        #claudeForm {
            max-width: 500px;
            margin: 20px auto;
            padding: 20px;
            border: 1px solid #ddd;
            border-radius: 8px;
            box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
            background-color: #f9f9f9;
        }
        #claudeForm label {
            margin-top: 16px;
            display: block;
            font-weight: bold;
            margin-bottom: 5px;
        }
        #claudeForm input, #claudeForm select {
            width: 100%;
            padding: 8px;
            margin-bottom: 15px;
            border: 1px solid #ccc;
            border-radius: 4px;
            font-size: 14px;
        }
        #claudeForm span {
            margin-right: 5px;
            margin-bottom: 15px;
            width: 100%;
            padding: 10px;
            font-size: 16px;
            color: #fff;
            background-color: #007bff;
            border: none;
            border-radius: 4px;
            cursor: pointer;
        }
        #claudeForm span:hover {
            background-color: #0056b3;
        }
    `;
    document.head.appendChild(style);
};

async function mergePromptSend(prompt, save = '00', returncounts = 1, jsonformat = '00') {
    //save:是否在服务里面保存，默认00为不保存
    if (save != '00') {
        //替换掉包含return的不标准返回格式
        prompt = prompt.replace(/<br>[^<]*?return[^<]*?;<br>/i, '<br>');;
        //添加标准的文章创造的内容返回格式
        prompt = prompt + 'Return only the following contents:Title,Description,Excerpt,Keywords,Open_graph,Twitter_card,ArticleBody, use JSON  to output all contents, Each item output as markdown format;<br>'
    }
    var message = [{
        "role": "system",
        "content": "You are a helpful assistant"
    }]
    message.push({ "role": "user", "content": prompt })
    let airesponse = await finalAIRequest(message, save, returncounts, jsonformat)
    return airesponse
}

async function mergePromptSendContinue(prompt, more = '000', jsonformat = '00', save = '00') {
    //连续对话，重新生成模式

    if (save != '00') {
        //替换掉包含return的不标准返回格式
        prompt = prompt.replace(/<br>[^<]*?return[^<]*?;<br>/i, '<br>');;
        //添加标准的文章创造的内容返回格式
        prompt = prompt + 'Return only the following contents:Title,Description,Excerpt,Keywords,Open_graph,Twitter_card,ArticleBody, use JSON  to output all contents, Each item output as markdown format;<br>'
    }

    var message = [{
        "role": "system",
        "content": "You are a helpful assistant"
    }]
    if (more != '000') {
        //不等于000,则表明需要连续对话
        let historychat_id = more
        var historychat = document.getElementById(historychat_id).innerText == '' ? '[]' : document.getElementById(historychat_id).innerText
        historychat = JSON.parse(historychat)

        historychat.forEach(ele => {
            message.push(ele)
        });
    }
    message.push({ "role": "user", "content": prompt })

    let airesponse = await finalAIRequest(message, save, returncounts = 1, jsonformat)
    return airesponse
}

async function mergePromptBookTocSendContinue(prompt, more = '000', jsonformat = '00', jsonschema = '00') {
    //连续对话，重新生成模式,生成固定的书目录

    var message = [{
        "role": "system",
        content: "You are an assistant that helps generate structured outlines for books."
    }]
    if (jsonschema != '00') {
        message.push({ "role": "user", "content": jsonschema })
    }
    if (more != '000') {
        //不等于000,则表明需要连续对话
        let historychat_id = more
        var historychat = document.getElementById(historychat_id).innerText == '' ? '[]' : document.getElementById(historychat_id).innerText
        historychat = JSON.parse(historychat)

        historychat.forEach(ele => {
            message.push(ele)
        });
    }
    message.push({ "role": "user", "content": prompt })
    
    let airesponse = await finalAIRequest(message, save = '00', returncounts = 1, jsonformat)
    return airesponse
}


const finalAIRequest = (async (p, save, returncounts, jsonformat) => {
    let AIresponse = null
    let ai_params_ = null
    let ai_choice = contentAISEOAdmin.ai_choice
    if (ai_choice == 'chatgpt') {
        // let ai_params_x_ = fixTypesforChatgptParams(getaiparams('chatgpt'))
        // ai_params_ = ai_params_x_
        // ai_params_['messages'] = p

        // if (parseInt(returncounts) > 1) {
        //     ai_params_['n'] = parseInt(returncounts)
        //     ai_params_['top_p'] = 0.8
        // }
        // if (jsonformat == '00') {

        // } else {
        //     ai_params_["response_format"] = {
        //         "type": "json_object"
        //     }
        // }

        let ai_params_x_ = fixTypesforChatgptParams(getaiparams('chatgpt'));
        ai_params_ = ai_params_x_;
        ai_params_['messages'] = p;

        // 判断是否为 search-preview 模型
        const isSearchPreview = ai_params_['model'] && ai_params_['model'].includes('search-preview');

        if (isSearchPreview) {
            // 仅保留 id, model, messages 三个字段
            ai_params_ = {
                id: ai_params_x_['id'],
                model: ai_params_x_['model'],
                messages: p
            };
        } else {
            // 非 search-preview 模型，处理其他参数逻辑
            if (parseInt(returncounts) > 1) {
                ai_params_['n'] = parseInt(returncounts);
                ai_params_['top_p'] = 0.8;
            }

            if (jsonformat !== '00') {
                ai_params_["response_format"] = {
                    type: "json_object"
                };
            }
        }

    }
    else if (ai_choice == 'deepseek') {
        ai_params_ = getaiparams('deepseek')

        if (jsonformat == '00') {
            ai_params_["response_format"] = {
                "type": "text"
            }
        } else {
            ai_params_["response_format"] = {
                "type": "json_object"
            }
        }
        ai_params_["messages"] = p

    }
    else if (ai_choice == 'claude') {

        ai_params_ = getaiparams('claude')

        let messages = [
            { role: "user", content: p }
        ]
        ai_params_["messages"] = messages

    }
    AIresponse = await requestOpenai(ai_params_, 'request_openai', save)
    return AIresponse
})
//连续对话
const finalAIRequestContinus = (async (message) => {
    let AIresponse = null
    let ai_choice = contentAISEOAdmin.ai_choice
    if (ai_choice == 'chatgpt') {
        let ai_params_ = fixTypesforChatgptParams(getaiparams('chatgpt'))
        const isSearchPreview = ai_params_['model'] && ai_params_['model'].includes('search-preview');
        if (isSearchPreview) {
            // 仅保留 id, model, messages 三个字段
            ai_params_ = {
                id: ai_params_['id'],
                model: ai_params_['model'],
                messages: message
            };
        } else {
            ai_params_['messages'] = message
        }
        AIresponse = await requestOpenai(ai_params_, 'request_openai')
    }
    else if (ai_choice == 'deepseek') {
        // response_format
        let ai_params_ = getaiparams('deepseek')

        ai_params_["response_format"] = {
            "type": "text"
        }
        ai_params_["messages"] = message

        AIresponse = await requestOpenai(ai_params_, 'request_openai')
    }
    else if (ai_choice == 'claude') {

        let ai_params_ = getaiparams('claude')

        // let messages = [
        //     { role: "user", content: p }
        // ]
        ai_params_["messages"] = messages

        AIresponse = await requestOpenai(ai_params_, 'request_openai')
    }
    return AIresponse
})

const savepost = (async (postData) => {
    const url = '/wp-json/myseoai/v1/create-post';
    let result = await sendpost(postData, url)
    return result
})


const MAX_HISTORY = 20; // 保留最近 20 轮对话（40 条 message + system 1 条）

function trimChatHistory(messages) {
    const systemMessage = messages[0]; // 保留 system 设定
    const history = messages.slice(-MAX_HISTORY * 2); // 获取最近 20 轮（每轮2条消息）
    if (history[0]['role'] == systemMessage['role']) {
        return history
    } else {
        return [systemMessage, ...history]; // 确保 system 消息始终在最前面}
    }
}


// free image 搜索图片from unsplash
async function searchImages() {

    let ACCESS_KEY = 'xvwN462F-JewCPkhZGJDBXQcymPybvRgLVj7Um5AAys'
    let perpagecount = 30

    const query = document.getElementById("searchimginput").value.trim();
    if (!query) {
        alert("Please enter a search term.");
        return;
    }

    const url = `https://api.unsplash.com/search/photos?query=${query}&per_page=${perpagecount}&client_id=${ACCESS_KEY}`;

    try {
        const response = await fetch(url);
        if (!response.ok) throw new Error('Network response was not ok');

        const data = await response.json();
        // console.debug(data.results)
        displayImages(data.results);
        return data.results
    } catch (error) {
        console.error("Error fetching images:", error);
    }
}

// 显示图片
function displayImages(images) {
    const imgContainer = document.getElementById("image-container");
    imgContainer.innerHTML = "";

    if (images.length === 0) {
        imgContainer.innerHTML = "<p>No images found.</p>";
        return;
    }

    images.forEach(img => {
        let allimgs = JSON.stringify(img.urls)
        imgContainer.innerHTML += `
                    <div style="display:inline-block; margin:10px;">
                        <img src="${img.urls.small}" alt="${img.alt_description}" data="${allimgs}" style="width:200px; height:auto; border-radius:10px;">
                        <p><strong>${img.user.name}</strong></p>
                    </div>
                `;
    });
}

const AIassistantquickpromptpartfunction = ((containerID, offset) => {
    let db = new PromptDatabase();
    layer.open({
        title: 'Info',
        type: 1,
        content: quickpromptpartstring,
        // offset: 'b',
        // anim: 'slideUp', // 从下往上
        // area: ['100%', '320px'],
        // offset: 'l',
        // anim: 'slideRight', // 从左往右
        offset: offset ?? 'r',
        anim: 'slideLeft', // 从右往左
        area: ['50%', '100%'],
        maxmin: true,
        shade: 0.1,
        shadeClose: true,
        success: function (layero, index) {
            // layer.full(index); // 最大化
            let selectElement = [];
            selectElement.push(document.getElementById('yuqiSelect'));
            selectElement.push(document.getElementById('languageSelect'));
            selectElement.push(document.getElementById('LexicalChoices'));
            selectElement.push(document.getElementById('WritingVoice'));
            selectElement.push(document.getElementById('WritingPacing'));
            selectElement.push(document.getElementById('TargetReaders'));
            selectElement.push(document.getElementById('WritingCohesionandCoherence'));
            selectElement.push(document.getElementById('WritingArgumentation'));
            selectElement.push(document.getElementById('WritingGrammarandSyntax'));
            selectElement.push(document.getElementById('KeywordsSelect'));
            selectElement.push(document.getElementById('SEOKeywordsSelect'));
            selectElement.push(document.getElementById('marketresearch'));
            selectElement.push(document.getElementById('TrendSelect'));
            selectElement.push(document.getElementById('DescriptionSelect'));
            selectElement.push(document.getElementById('TitleSelect'));
            selectElement.push(document.getElementById('returnformat'));
            selectElement.push(document.getElementById('contentsnippet'));
            selectElement.push(document.getElementById('writingstructures'));
            selectElement.push(document.getElementById('typeofreview'));
            selectElement.push(document.getElementById('typesoftone'));
            selectElement.push(document.getElementById('mindmaps'));
            selectElement.push(document.getElementById('outline'));
            selectElement.push(document.getElementById('commonarticle'));
            selectElement.push(document.getElementById('topics'));
            selectElement.push(document.getElementById('Typesofdescriptions'));
            selectElement.push(document.getElementById('emotions'));
            selectElement.push(document.getElementById('typesofterminology'));
            selectElement.push(document.getElementById('Intent'));
            selectElement.push(document.getElementById('role'));
            selectElement.push(document.getElementById('country'));
            selectElement.push(document.getElementById('websitewritestyle'));
            selectElement.push(document.getElementById('rewritearticle'));
            selectElement.push(document.getElementById('modifiedcontent'));
            // selectElement.push(document.getElementById('seosnippets'));
            selectElement.push(document.getElementById('copywriter'));
            selectElement.push(document.getElementById('slogan'));
            selectElement.push(document.getElementById('pressrelease'));
            selectElement.push(document.getElementById('WritingStructurePrompts'));
            selectElement.push(document.getElementById('WritingGeneratecontentprompts'));
            selectElement.push(document.getElementById('WritingSEOPrompts'));
            selectElement.push(document.getElementById('WritingStyleAdjustmentsPrompts'));
            selectElement.push(document.getElementById('WritingGeneralContentOptimizationPrompts'));
            selectElement.push(document.getElementById('WritingContentExpansionPrompts'));
            selectElement.push(document.getElementById('WritingAudienceSpecificCustomizationPrompts'));
            selectElement.push(document.getElementById('WritingGrammarSpellingCorrectionPrompts'));
            selectElement.push(document.getElementById('WritingProfessionalfieldcontentPrompts'));
            selectElement.push(document.getElementById('contentcreation'));
            selectElement.push(document.getElementById('business'));
            selectElement.push(document.getElementById('marketing'));
            selectElement.push(document.getElementById('writer'));
            selectElement.push(document.getElementById('imagegenerator'));
            selectElement.push(document.getElementById('humourous'));
            // selectElement.push(document.getElementById('thinking'));
            selectElement.push(document.getElementById('emotions'));
            selectElement.push(document.getElementById('experiences'));
            selectElement.push(document.getElementById('story'));
            selectElement.push(document.getElementById('novels'));
            selectElement.push(document.getElementById('pressreleases'));
            selectElement.push(document.getElementById('blogpost'));
            selectElement.push(document.getElementById('poetry'));
            selectElement.push(document.getElementById('Englishproficiencylevels'));
            selectElement.push(document.getElementById('English'));
            selectElement.push(document.getElementById('QAWritingStructure'));
            selectElement.push(document.getElementById('reviews'));
            selectElement.push(document.getElementById('news'));
            selectElement.push(document.getElementById('argumentativeessays'));
            selectElement.push(document.getElementById('narrativeessays'));
            selectElement.push(document.getElementById('expositoryessay'));
            selectElement.push(document.getElementById('biographies'));
            selectElement.push(document.getElementById('humanize'));
            selectElement.push(document.getElementById('dialogue'));
            selectElement.push(document.getElementById('letter'));
            selectElement.push(document.getElementById('videoscript'));
            selectElement.push(document.getElementById('productdetailpages'));
            selectElement.push(document.getElementById('screenplay'));
            selectElement.push(document.getElementById('gamescripts'));
            selectElement.push(document.getElementById('Viewpoints'));
            selectElement.push(document.getElementById('MainSEOArticleTypes'));
            selectElement.push(document.getElementById('ProductArticle'));
            selectElement.push(document.getElementById('LegalArticle'));
            selectElement.push(document.getElementById('BookTableofContents'));
            selectElement.push(document.getElementById('BrandArticle'));
            selectElement.push(document.getElementById('Outlinelite'));
            selectElement.push(document.getElementById('SEOusefulprompt'));
            selectElement.push(document.getElementById('wikis'));
            selectElement.forEach(ele => {
                removeDuplicateOptions(ele);
                const value = ele.getAttribute("data-");
                if (ele.getElementsByTagName('optgroup').length == 0) {
                    orderaz(ele.id)
                }
            });

            //确保在页面中正确加载了 layui 的 JS 和 CSS，并且初始化了 form 组件
            layui.use('form', function () {
                var form = layui.form;
                var table = layui.table;
                // 渲染表单
                // form.render('select');
                form.render(layero.find('.layui-form select'));
                form.on('select', function (data) {
                    var elem = data.elem; // 获取当前的 select 元素
                    let title = elem.getAttribute("data-");
                    let id = elem.id;
                    var selectedValue = data.value; // 获取选中的值

                    if (selectedValue !== "copyalllist") {
                        addcomponet({
                            'title': title,
                            'content': selectedValue
                        }, containerID)
                    } else {
                        const select = document.getElementById(id);
                        const options = Array.from(select.options)
                            .map(option => option.value)
                            .filter(value => !["novalue", "copyalllist"].includes(value)); // 过滤掉指定的值

                        const result = options.join(",");
                        // 复制到剪贴板
                        navigator.clipboard.writeText(result).then(() => {
                            alert('all list copied')
                        }).catch(err => {
                            alert('copy failed')
                        });
                    }
                });

                db.getAllPromptParts().then((res) => {

                    loadatatotablecustompromptpart(table, res)
                })

                db.getPromptPartsByCategory('your_1').then((res) => {

                    generatorcustom(res, 'your_1', layero)

                })
                db.getPromptPartsByCategory('your_2').then((res) => {

                    generatorcustom(res, 'your_2', layero)
                })
            });

        }
    });
})

// 动态生成选项
function populateOptionsFromArrayAss(res, target) {
    // 清空现有选项
    // target.innerHTML = '<option value="">Select an Option</option>';

    let data = []
    res.forEach((ele, key) => {
        data.push({
            value: ele['name'],
            text: ele['name']
        })
    });

    // 遍历数组并创建选项
    data.forEach(item => {
        const option = document.createElement('option');
        option.value = item.value;
        option.textContent = item.text;
        target.appendChild(option);
    });

    orderaz(target.id)
}

function setFocusAndHighlightAss(inputid) {
    const inputElement = document.getElementById(inputid);
    // 设置焦点
    inputElement.focus();
    // 添加红色泛红效果
    inputElement.classList.add('highlight');
    // 可选：在 1.5 秒后移除红色背景效果（为了模拟过渡效果）
    setTimeout(() => {
        inputElement.classList.remove('highlight');
    }, 11500);
}

//正则提取table字符串
function extractTable(str) {
    const tableMatch = str.match(/<table[^>]*>[\s\S]*?<\/table>/i);
    if (tableMatch) {
        console.log('提取到的 Table:', tableMatch[0]);
        return tableMatch[0]
    } else {
        return ''
    }
}


//正则提取json字符串
function extractJson(str) {
    const match = str.match(/{[\s\S]*}/);
    if (match) {
        try {
            return cleanJsonProblemChars(match[0]);
        } catch (e) {
            console.error("提取成功但解析失败:", e.message);
            return null;
        }
    } else {
        console.warn("未匹配到 JSON 内容");
        return null;
    }
}
// 替换常见导致 JSON 错误的字符
function cleanJsonProblemChars(jsonStr) {
    return jsonStr.replace(/[\u201C\u201D\u2018\u2019\u300C\u300D\uFF02\uFF07\u0000-\u001F]/g, '');
}
//忽略json key值大小写
function normalizeKeys(obj) {
    const newObj = {};
    for (let key in obj) {
        newObj[key.toLowerCase()] = obj[key];
    }
    return newObj;
}

function ensureString(input) {
    // 如果是对象或数组，就转为字符串
    if (typeof input === 'object' && input !== null) {
        return JSON.stringify(input, null, 2); // 可选格式化
    }
    return input; // 原本就是字符串或其他
}

function geturl() {
    const protocol = window.location.protocol;  // 'https:' or 'http:'
    const host = window.location.hostname;      // 'example.com'
    const port = window.location.port;          // '8080' or ''
    const fullHost = port ? `${host}:${port}` : host;

    return fullHost
}

function settingHistorychat(historychat_id, prompts, airesponse) {
    //把历史谈话内容储存在容器id为historychat_id，prompts为最新的提示语，airesponse为最新的回答
    let historychat = document.getElementById(historychat_id).innerText == '' ? '[]' : document.getElementById(historychat_id).innerText
    historychat = JSON.parse(historychat)
    let p = {
        "role": "user",
        "content": prompts
    }
    let result = {
        "role": "assistant",
        "content": airesponse
    }
    historychat.push(p)
    historychat.push(result)
    document.getElementById(historychat_id).innerText = JSON.stringify(historychat)
}

function getCurrentFormattedDate(hour = 0) {
    const now = new Date();

    // 增加小时数（可为负数）
    now.setHours(now.getHours() + hour);

    const pad = (n) => n.toString().padStart(2, '0');

    const year = now.getFullYear();
    const month = pad(now.getMonth() + 1);
    const day = pad(now.getDate());
    const hours = pad(now.getHours());
    const minutes = pad(now.getMinutes());
    const seconds = pad(now.getSeconds());

    return `${year}-${month}-${day} ${hours}:${minutes}:${seconds}`;
}

function processOpengraph(opengraph) {
    const postLink = wp.data.select('core/editor').getPermalink();

    opengraph = opengraph.replace(
        /"url":\s*"([^"]+)"/,
        `"url": "${postLink}"`
    );

    return opengraph
}

function dbsetting_aia(searchpromptcate_, db) {
    if (searchpromptcate_ == 12) {
        return
    }

    let searchpromptcatekate = Math.floor(Date.now() / 1000)

    if (searchpromptcatekate - searchpromptcate_ > 5000) {
        db.prompts = db.table('prots');
    }
}

async function getFeaturedImageURL(postId) {
    if (!postId) {
        console.warn('未提供postId');
        return null;
    }

    try {
        const res = await fetch(`/wp-json/wp/v2/posts/${postId}?_embed`, {
            headers: {
                'Content-Type': 'application/json',
                'X-WP-Nonce': wpApiSettings.nonce // 必须添加 nonce 验证,登陆验证
            },
        });
        if (!res.ok) {
            console.error(`请求失败: HTTP ${res.status}`);
            return null;
        }

        const post = await res.json();
        const featuredImage = post._embedded?.['wp:featuredmedia']?.[0]?.source_url || null;

        if (!featuredImage) {
            console.warn('没有找到特色图');
        }

        return featuredImage;
    } catch (err) {
        console.error('请求出错:', err);
        return null;
    }
}

const chatgptModels = [
    "gpt-4.1",
    "gpt-4.1-mini",
    "gpt-4.1-nano",
    "gpt-4.1-nano-2025-04-14",
    "gpt-4.1-mini-2025-04-14",
    "gpt-4.1-2025-04-14",
    "o3",
    "o1-mini",
    "o1-mini-2024-09-12",
    "o1-preview",
    "o1-preview-2024-09-12",
    "o3-2025-04-16",
    "gpt-4o",
    "gpt-4o-mini",
    "gpt-4o-audio-preview",
    "gpt-4o-search-preview",
    "gpt-4o-search-preview-2025-03-11",
    "gpt-4o-mini-search-preview-2025-03-11",
    "gpt-4o-mini-search-preview",
    "gpt-4o-mini-audio-preview-2024-12-17",
    "gpt-4o-mini-audio-preview",
    "gpt-4o-mini-2024-07-18",
    "gpt-4o-audio-preview-2024-12-17",
    "gpt-4o-audio-preview-2024-10-01",
    "gpt-4o-2024-11-20",
    "gpt-4o-2024-08-06",
    "gpt-4o-2024-05-13",
    "gpt-4.5-preview-2025-02-27",
    "gpt-4.5-preview",
    "gpt-4-turbo-preview",
    "gpt-4-turbo-2024-04-09",
    "gpt-4-turbo",
    "gpt-4-1106-preview",
    "gpt-4-0613",
    "gpt-4-0125-preview",
    "gpt-4",
    "gpt-3.5-turbo-16k",
    "gpt-3.5-turbo-1106",
    "gpt-3.5-turbo-0125",
    "gpt-3.5-turbo",
    "chatgpt-4o-latest"
];





