<?php //内容创作中心 
?>

<div class="layui-col-md3">
    <div class="layui-tab">
        <ul class="layui-tab-title">
            <li class="layui-this">Prompts</li>
            <li>Favorite</li>
            <li>Recently</li>
        </ul>
        <div class="layui-tab-content">
            <div class="layui-tab-item layui-show">
                <div class="layui-card" style="padding: 0 8px;">
                    <div class="layui-card-header">
                        <h3>Using Prompts</h3>
                    </div>
                    <div class="layui-card-body">
                        <h4>Fliter</h4><br>
                        <div class="layui-input-group">
                            <input id="searchpromptinput1" type="text" placeholder="by name" class="layui-input">
                            <div lay-on="searchprompt1" class="layui-input-split layui-input-suffix" style="cursor: pointer;">
                                <i class="layui-icon layui-icon-search"></i>
                            </div>
                            <div lay-on="restsearch1" class="layui-input-split layui-input-suffix" style="cursor: pointer;">
                                <i class="layui-icon layui-icon-refresh"></i>
                            </div>
                        </div>
                        <div class="layui-input-group">
                            <input id="searchpromptinputag1" type="text" placeholder="by tag" class="layui-input">
                            <div lay-on="searchpromptag1" class="layui-input-split layui-input-suffix" style="cursor: pointer;">
                                <i class="layui-icon layui-icon-search"></i>
                            </div>
                            <div lay-on="restsearch1" class="layui-input-split layui-input-suffix" style="cursor: pointer;">
                                <i class="layui-icon layui-icon-refresh"></i>
                            </div>
                        </div>
                        <div class="layui-input-group">
                            <input id="searchpromptinputcate1" type="text" placeholder="by category" class="layui-input">
                            <div lay-on="searchpromptcate1" class="layui-input-split layui-input-suffix" style="cursor: pointer;">
                                <i class="layui-icon layui-icon-search"></i>
                            </div>
                            <div lay-on="restsearch1" class="layui-input-split layui-input-suffix" style="cursor: pointer;">
                                <i class="layui-icon layui-icon-refresh"></i>
                            </div>
                        </div>
                        <div class="layui-col-md12">
                            <div class="select-c">
                                <h4>Tag:</h4>
                                <select id="tagSelect-2" lay-search="">

                                </select>
                            </div>
                            <div class="select-c">
                                <h4>Category:</h4>
                                <select id="cateSelect-2" lay-search="">

                                </select>
                            </div>
                            <div class="select-c">
                                <button lay-on="Reloaduseprompts" type="button" class="layui-btn layui-btn-sm layui-btn-normal">
                                    <i class="layui-icon layui-icon-refresh-3"></i> Reload
                                </button>

                            </div>
                        </div>
                        <hr class="ws-space-8">
                        <table lay-filter="tabletoolbar1" class="layui-hide" id="ID-table-prompt-data-using"></table>
                    </div>
                </div>
            </div>
            <div class="layui-tab-item">
                <div class="layui-panel">
                    <ul id="favoriteprompt">
                    </ul>
                    <button lay-on="clearfavorite" class="layui-btn layui-bg-cyan layui-btn-sm">
                        Clear
                        <span class="layui-badge-dot layui-bg-orange"></span>
                    </button>
                </div>
            </div>
            <div class="layui-tab-item">
                <div class="layui-panel">
                    <ul id="recentprompt">
                    </ul>
                    <button lay-on="clearrecent" class="layui-btn layui-bg-cyan layui-btn-sm">
                        Clear
                        <span class="layui-badge-dot layui-bg-orange"></span>
                    </button>
                </div>
            </div>
        </div>
    </div>

</div>
<div class="layui-col-md6">

    <div class="layui-tab">
        <ul class="layui-tab-title">
            <li class="layui-this">topic generator</li>
            <!-- <li>aichat</li> -->
            <li>cron-task</li>
            <!-- <li>标签4</li>
            <li>标签5</li> -->
        </ul>
        <div class="layui-tab-content">
            <div class="layui-tab-item layui-show">
                <div class="layui-col-md6 layui-panel height-1">
                    <div id="topicsearchbar" class="layui-inline" style="padding: 6px;">
                        <button type="button" class="layui-btn layui-btn-sm layui-btn-normal common-margin" lay-on="topicpromptsubmit">Submit</button>
                        <button style="margin-left: 0px;" title="add empty prompt part" type="button" class="layui-btn layui-btn-sm layui-btn-normal common-margin" lay-on="addemptytopicprompt">
                            <i class="layui-icon layui-icon-add-circle"></i>
                        </button>
                        <select class="common-margin" id="tag-select-research-prompt" lay-search="">
                            <option value="">Select tag</option>
                        </select>
                        <select id="select-research-prompt" lay-search="">
                            <option value="">Select topic</option>
                        </select>
                    </div>
                    <!-- <div class="layui-panel" id="showp"></div> -->
                    <div id="topicinput" class="layui-form-item" style="text-align: left;">
                    </div>
                    <div class="layui-form-item" style="display:flex;text-align: center;">
                    </div>

                </div>
                <div class="layui-col-md6">
                    <div style="padding:5px" class="layui-panel topicplace" id="topicplace"></div>
                </div>
            </div>
            <!-- <div class="layui-tab-item">
                <?php
                // $static_file = MY_PLUGIN_PATH . 'html/part/aichat.php';
                // if (file_exists($static_file)) {
                //     include $static_file; //include加载才支持php内嵌
                // } else {
                //     echo '<h1>Error</h1>';
                //     echo '<p>Page not found</p>';
                // }
                ?>
            </div> -->
            <div class="layui-tab-item">
                <?php
                $static_file = MY_PLUGIN_PATH . 'html/part/cron-task.php';
                if (file_exists($static_file)) {
                    include $static_file; //include加载才支持php内嵌
                } else {
                    echo '<h1>Error</h1>';
                    echo '<p>Page not found</p>';
                }
                ?>
            </div>
            <div class="layui-tab-item">内容-4</div>
            <div class="layui-tab-item">内容-5</div>
        </div>
    </div>
</div>

<div class="layui-col-md3">

    <div class="layui-tab" lay-filter="test-hash">
        <ul class="layui-tab-title">
            <li class="layui-this" lay-id="11">Current Prompt</li>
            <li title="" class="" lay-id="12">Posts Save Setting</li>
        </ul>
        <div class="layui-tab-content">
            <div class="layui-tab-item layui-show">
                <div id="content-1-right" class="layui-panel height-1">
                    <div style="padding: 4px;">
                        <button lay-on="submitcreate" class="layui-btn-xs layui-btn-primary layui-border">Generate</button>
                        <button lay-on="submitcronjob" class="layui-btn-xs layui-btn-primary layui-border">Add to Tasks List</button>
                        <button lay-on="batchcronjob" class="layui-btn-xs layui-btn-primary layui-border">Batch Generate</button>
                        <div style="margin-top: 5px;">
                            <button lay-on="quickpromptpart01" class="layui-btn-xs layui-btn-primary layui-border">Quick Prompt Part</button>
                            <button lay-on="addemptyprompt" class="layui-btn-xs layui-btn-primary layui-border">Add empty Prompt Part</button>
                        </div>
                        <div id="postsettingshow" class="infoshow"></div>
                        <div id="promptresult" class="infoshow"></div>
                        <div id="container-create-content"></div>
                    </div>
                </div>
            </div>
            <div class="layui-tab-item">
                <div id="content-1-right" class="layui-panel height-1">
                    <form class="post-setting layui-form" action="">
                        <div class="layui-form-item">
                            <label class="layui-form-label">Tags</label>
                            <div class="layui-input-block">
                                <input type="text" name="Tags" placeholder="" autocomplete="off" class="layui-input">
                            </div>
                        </div>
                        <div class="layui-form-item">
                            <label class="layui-form-label">Post Category</label>
                            <div class="layui-input-block">
                                <select lay-verify="required" name="category" id="category-select" lay-filter="category">
                                    <option value="">Select Category</option>
                                </select>
                            </div>
                        </div>
                        <div class="layui-form-item">
                            <label class="layui-form-label">Status & Visibility</label>
                            <div class="layui-input-block">
                                <select name="StatusVisibility" lay-filter="Visibility">
                                    <option value=""></option>
                                    <option value="Published">Published</option>
                                    <option value="Draft" selected>Draft</option>
                                    <option value="Pending">Pending</option>
                                    <!-- <option value="3">音乐</option>
                                    <option value="4">旅行</option> -->
                                </select>
                            </div>
                        </div>
                        <div class="layui-form-item">
                            <div class="layui-input-block">
                                <button type="submit" class="layui-btn" lay-submit lay-filter="postsSave">Save</button>
                                <button type="reset" class="layui-btn layui-btn-primary">Clear</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>


</div>
<script>
    var contentTaskRunning = 0
    var topicdata = null
    var createContentPrompt = ''

    var defaultPostsSetting = {
        Tags: '',
        category: '1',
        StatusVisibility: 'Draft'
    }
    setInterval(() => {
        // setTimeout(() => {
        //更新最近使用的prompt
        let recentpromptdom = document.getElementById("recentprompt")
        // if (recentpromptdom.childElementCount == 0) {
        recentpromptdom.innerHTML = '';
        let recentprompthistory = new LocalStorageCache('recent_prompt_history', 20)
        let rph = recentprompthistory.getAll()
        rph.forEach(ele => {
            var newElement = document.createElement('li');
            newElement.classList.add("two-line-text")
            newElement.setAttribute("lay-on", "userecentprompt"); // 添加 属性
            // newElement.textContent = ele.timestamp+ ele.prompt;
            newElement.textContent = ele.name;
            recentpromptdom.appendChild(newElement);
        });


        //更新favorite prompts
        let fpromptdom = document.getElementById("favoriteprompt")
        fpromptdom.innerHTML = '';
        let favoriteprompt = new LocalStorageCache('favorite_prompt', 20);
        let fprompt = favoriteprompt.getAll()
        fprompt.forEach(ele => {
            let newElement = document.createElement('li');
            newElement.classList.add("two-line-text")
            newElement.setAttribute("lay-on", "usefavoriteprompt"); // 添加 属性
            newElement.textContent = ele.name;
            fpromptdom.appendChild(newElement);
        });

        //显示当前有多少计划任务
        const pendingTasks = JSON.parse(localStorage.getItem('pendingTasks')) || [];
        if (pendingTasks.length != 0) {
            // console.log(`There are ${pendingTasks.length} tasks on the schedule`)
            document.getElementById("plantaskstatus").innerHTML = `There are ${pendingTasks.length} tasks on the schedule`
        } else {
            document.getElementById("plantaskstatus").innerHTML = ''
        }

        //显示有无请求创建内容任务正在执行
        if (contentTaskRunning > 0) {
            document.getElementById("taskstatus").innerHTML = "Content is being created. Please do not close or refresh the page."
        } else {
            document.getElementById("taskstatus").innerHTML = ""
            contentTaskRunning = 0
        }

        //限制替换prompt字段keyword被修改，预防替换规则失效
        // let inputs = document.querySelectorAll("input")
        // inputs.forEach(inputElement => {
        //     if (inputElement.value === 'keyword') {
        //         inputElement.readOnly = true;
        //     } else {
        //         inputElement.readOnly = false;
        //     }
        // });
        //显示当前使用的内容prompt
        // document.querySelector('#promptresult').innerHTML = `${createContentPrompt}`

    }, 3000);

    document.addEventListener('DOMContentLoaded', function() {
        layui.use(['element'], function() {
            const element = layui.element; // 初始化元素模块
            element.init('#layui-container');
        });

        const db2 = new PromptDatabase();
        layui.use(['table', 'form'], async function() {
            var table = layui.table;
            var util = layui.util;
            var form = layui.form;
            var upload = layui.upload;

            //渲染posts目录
            const categoryselect = (() => {
                const select = document.getElementById('category-select');
                // 清空旧选项（保留“请选择分类”）
                select.length = 1;
                // 动态添加分类选项
                contentAISEOAdmin.categories.forEach(cat => {
                    const option = document.createElement('option');
                    option.value = cat.id;
                    option.text = cat.name;
                    select.appendChild(option);
                });

                // 通知 LayUI 重新渲染 select（非常关键）
                form.render('select');
            })

            const showpostsetting = (() => {
                let cachep = JSON.stringify(defaultPostsSetting)
                let postsetting = localStorage.getItem('postsSave') ?? cachep
                postsetting = JSON.parse(postsetting)
                document.querySelector('#postsettingshow').innerHTML = `<div class="layui-bg-green">
                 Now Posts Save Setting <br>tag: <strong>${postsetting.Tags}</strong>, category: <strong>${postsetting.category}, status: <strong>${postsetting.StatusVisibility}</strong></div>`
            })

            categoryselect();
            showpostsetting();

            // POSTS SAVE SETTING
            form.on('submit(postsSave)', function(data) {
                var field = data.field; // 获取表单字段值

                document.querySelector('#postsettingshow').innerHTML = `<div class="layui-bg-green">
                 Now Posts Save Setting <br>tag: <strong>${field.Tags}</strong>, category: <strong>${field.category}, status: <strong>${field.StatusVisibility}</strong></div>`

                localStorage.setItem("postsSave", JSON.stringify(field))
                layer.alert(JSON.stringify(field), {
                    title: 'Saved'
                });

                return false; // 阻止默认 form 跳转
            });

            const allprompt = (async () => {
                var data = []
                let list = await db2.getAllPrompts()
                loadatatotable(table, list)
            })

            allprompt();


            db2.promptag.then(response => {

                    let dataSource = []
                    dataSource.push({
                        value: 'all',
                        text: 'all'
                    })
                    response.forEach((ele, key) => {

                        dataSource.push({
                            value: ele,
                            text: ele
                        })
                    });
                    // 获取目标 select 元素
                    let selectElement = document.getElementById('tagSelect-2');
                    // 调用函数填充选项
                    populateOptionsFromArray(dataSource, selectElement, 'tagSelect');
                    // 监听 select 的 change 事件
                    selectElement.addEventListener("change", async (event) => {
                        const selectedValue = event.target.value;

                        if (selectedValue === "all") {
                            allprompt()
                        } else {
                            let list = await db2.getAllPromptByTag(selectedValue)
                            loadatatotable(table, list)
                        }
                    });
                })
                .catch(error => {
                    console.error(error);
                })

            db2.promptcate.then(response => {
                    let dataSource = []
                    dataSource.push({
                        value: 'all',
                        text: 'all'
                    })
                    response.forEach((ele, key) => {
                        dataSource.push({
                            value: ele,
                            text: ele
                        })
                    });
                    // 获取目标 select 元素
                    let selectElement = document.getElementById('cateSelect-2');
                    // 调用函数填充选项
                    populateOptionsFromArray(dataSource, selectElement, 'cateSelect-2');
                    // 监听 select 的 change 事件
                    selectElement.addEventListener("change", async (event) => {
                        const selectedValue = event.target.value;
                        if (selectedValue === "all") {
                            allprompt()

                        } else {
                            db2.getTagsByCategory(selectedValue).then((res) => {

                                let dataSource = []

                                res.forEach((ele, key) => {
                                    dataSource.push({
                                        value: ele,
                                        text: ele
                                    })
                                });
                                dataSource.push({
                                    value: 'all',
                                    text: 'all'
                                })
                                // 获取目标 select 元素
                                let selectElement = document.getElementById('tagSelect-2');
                                // 调用函数填充选项
                                populateOptionsFromArray(dataSource, selectElement, 'tagSelect-2');

                                db2.getAllPromptByTag(dataSource[0]['value']).then((res) => {

                                    loadatatotable(table, res)
                                })
                                // 
                            })
                            // let list = await db2.getAllPromptByCategory(selectedValue)
                            // loadatatotable(table, list)
                        }
                    });
                })
                .catch(error => {
                    console.error(error);
                })


            const ShowTagsByCate = ((cate) => {
                db2.getTagsByCategory(cate).then((res) => {
                    let dataSource = []
                    res.forEach((ele, key) => {
                        dataSource.push({
                            value: ele,
                            text: ele
                        })
                    });
                    // 获取目标 select 元素
                    let selectElement = document.getElementById('tag-select-research-prompt');
                    // 调用函数填充选项
                    populateOptionsFromArray(dataSource, selectElement);

                    selectElement.addEventListener("change", async (event) => {
                        var tagname = event.target.value;
                        getTagPrompt(tagname)
                    })
                })
            })

            const getTagPrompt = ((tag) => {
                db2.getAllPromptByTag(tag).then(response => {
                        let dataSource = []
                        response.forEach((ele, key) => {
                            dataSource.push({
                                value: ele.name,
                                text: ele.name
                            })
                        });
                        // 获取目标 select 元素
                        let selectElement = document.getElementById('select-research-prompt');
                        selectElement.innerHTML = ''
                        // 调用函数填充选项
                        populateOptionsFromArray(dataSource, selectElement);
                        // console.log(selectElement)
                        // 监听 select 的 change 事件
                        const getpromptbyname = ((topicename) => {
                            {
                                db2.getPromptByName(topicename).then(r => {
                                    if (r) {
                                        let prompt = JSON.parse(r.prompt)
                                        const list = document.getElementById("topicinput");
                                        while (list.hasChildNodes()) {
                                            list.removeChild(list.firstChild);
                                        }
                                        // prompt = sortJsonArray(prompt)
                                        prompt = moveToTop(prompt, 'title', r.others)
                                        // prompt.reverse()
                                        prompt.forEach(ele => {
                                            addcomponet(ele, 'topicinput')
                                        });
                                    }
                                })
                            }
                        })
                        selectElement.addEventListener("change", async (event) => {
                            var topicename = event.target.value; // 获得被选中的值
                            getpromptbyname(topicename)

                        });
                        getpromptbyname(dataSource[0]['value'])
                    })
                    .catch(error => {
                        console.error(error);
                    })
            })

            ShowTagsByCate('topics')

            util.on('lay-on', {

                Reloaduseprompts: async function(othis) {
                    allprompt()
                },
                searchprompt1: async function(othis) {
                    let data = []
                    let searchpromptinput = document.querySelector("#searchpromptinput1").value
                    let list = await db2.searchPrompt(searchpromptinput)
                    loadatatotable(table, list)
                },
                searchpromptag1: async function(othis) {
                    let data = []
                    let searchpromptinput = document.querySelector("#searchpromptinputag1").value
                    let list = await db2.searchPromptag(searchpromptinput)
                    loadatatotable(table, list)
                },
                searchpromptcate1: async function(othis) {
                    let data = []
                    let searchpromptinput = document.querySelector("#searchpromptinputcate1").value
                    let list = await db2.searchPromptcate(searchpromptinput)
                    loadatatotable(table, list)
                },
                restsearch1: async function(othis) {
                    allprompt()
                },
                quickpromptpart01: async function(othis) {
                    quickpromptpartfunction('container-create-content', 'l')
                },
                submitcreate: async function() {
                    createContentPrompt = ''
                    let createContentInput = getAllValueInput('container-create-content')
                    createContentPrompt = promptGenerator(createContentInput)

                    if (createContentPrompt) {
                        let cachep = JSON.stringify(defaultPostsSetting)
                        let postsetting = localStorage.getItem('postsSave') ?? cachep
                        postsetting = JSON.parse(postsetting)
                        // save = postsetting
                        prompt = createContentPrompt
                        // let airespon = await mergePromptSend(prompt, save)
                        let airespon_ = await mergePromptSend(prompt, save = postsetting, returncounts = 1, jsonformat = '11')
                        //记录到任务列表当作
                        airespon = airespon_['respond']
                        const db = new PromptDatabase();
                        let postid = airespon['post_id']
                        let title = airespon['article_title']
                        let bywho = contentAISEOAdmin.usr
                        const jobId = await db.addJobLog({
                            product_by_who: bywho,
                            post_id: postid,
                            post_title: title,
                            post_time: new Date().toISOString()
                        });

                    } else {
                        alert('no prompt input')
                        return
                    }

                },
                batchcronjob: function(othis) {
                    layer.open({
                        type: 1, // page 层类型
                        area: ['500px', '300px'],
                        title: 'Batch Generator',
                        shade: 0, // 遮罩透明度
                        maxmin: true, // 允许全屏最小化
                        anim: 0, // 0-6 的动画形式，-1 不开启
                        content: `<div style="padding:32px">
  <label for="avatar">Choose a csv prompts file:</label>
<input type="file" id="promptscsv" name="promptscsv" />
<div>Important: Must be csv file format and UTF-8 charset!</div>
<a style="color: green;" href="https://mtool.icu/example.csv">Download the example file, edit it by microsoft office tool</a>
<div id="output"></div>
</div>`
                    });
                    document.getElementById('promptscsv').addEventListener('change', function(event) {
                        const file = event.target.files[0]; // 获取用户上传的文件
                        if (!file) {
                            alert('Please select a file!');
                            return;
                        }
                        const reader = new FileReader();
                        reader.onload = function(e) {
                            const csvContent = e.target.result; // 获取文件内容

                            const jsonData = convertCsvToJson(csvContent); // 转换成 JSON 数据

                            // let openai_params_ = getaiparams('chatgpt')

                            jsonData.forEach(ele => {

                                let p = promptGenerator(ele)
                                addContentTask(p, othis)
                            });

                            // 输出 JSON 数据（例如：显示到页面）
                            document.getElementById('output').innerText = JSON.stringify(jsonData, null, 2);
                        };

                        reader.onerror = function() {
                            alert('File read failed!');
                        };

                        reader.readAsText(file); // 以文本形式读取文件内容
                    });
                },
                submitcronjob: function(othis) {
                    let createContentInput = getAllValueInput('container-create-content')
                    createContentPrompt = promptGenerator(createContentInput)

                    addContentTask(createContentPrompt, othis)
                },
                addemptyprompt: function(othis) {
                    addcomponet({
                        'title': 'label',
                        'content': 'content'
                    }, 'container-create-content')
                },
                addemptytopicprompt: function(othis) {
                    addcomponet({
                        'title': 'label',
                        'content': 'content'
                    }, 'topicinput')
                },
                topicpromptsubmit: async function(othis) {
                    let topicinput = getAllValueInput('topicinput')
                    let topicprompt = promptGenerator(topicinput)

                    let airesponse = null
                    let result = await mergePromptSend(topicprompt)
                    airesponse = result['dataresult']

                    if (topicdata != null) {
                        // topicdata = topicdata + "<br>" + airesponse
                        let hr = `<blockquote class="layui-elem-quote layui-quote-nm">Line</blockquote>`
                        topicdata = airesponse + "\n\n" + hr + topicdata
                    } else {
                        topicdata = airesponse
                    }
                    mdToHtml_(topicdata, "topicplace")
                },
                usefavoriteprompt: async function() {
                    db2.getPromptByName(this.textContent).then((res) => {
                        let containerID = 'container-create-content'
                        promptDomGenerator(res.prompt, containerID)
                    })
                },
                clearrecent: function() {
                    alert('clearrecent')
                    const myCache = new LocalStorageCache('recent_prompt_history', 10);
                    myCache.clear();
                },
                clearfavorite: function() {
                    alert('clearfavorite')
                    const myCache = new LocalStorageCache('favorite_prompt', 10);
                    myCache.clear();
                },
                userecentprompt: function() {
                    db2.getPromptByName(this.textContent).then((res) => {

                        let containerID = 'container-create-content'
                        promptDomGenerator(res.prompt, containerID)
                    })
                }
            });

            // 动态生成选项
            function populateOptionsFromArray(data, target, t) {
                // 清空现有选项
                if (t == "cateSelect-2") {
                    target.innerHTML = '';
                } else if (t == 'tagSelect-2') {
                    target.innerHTML = '';
                }
                // 遍历数组并创建选项
                data.forEach(item => {
                    const option = document.createElement('option');
                    option.value = item.value;
                    option.textContent = item.text;
                    target.appendChild(option);
                });
                // 重新渲染 select
                form.render('select');
            }

        });

    });

    function loadatatotable(table, list) {
        var tdata = []
        list.forEach((ele, key) => {
            let m = {
                "id": key,
                "name": ele['name'],
                "prompt": ele['prompt'],
                "tag": ele['tag'],
                "category": ele['category'],
                "user": ele['user'],
                "others": ele['others'],
            }
            let aitoolsvalue_ = localStorage.getItem('aiminitools') ?? "quickSEM;WritingContent;SEO;"
            aitoolsvalue_ = aitoolsvalue_ + `;format;snippet`
            let index = aitoolsvalue_.indexOf(ele['tag']);
            if (index == -1) {
                tdata.unshift(m)
            }
        });

        // 已知数据渲染
        var inst = table.render({
            elem: '#ID-table-prompt-data-using',
            cols: [
                [ //标题栏
                    {
                        title: 'Action',
                        width: 80,
                        toolbar: '#table-operations-1'
                    },
                    {
                        field: 'name',
                        title: 'name',
                        width: 360
                    },
                    {
                        field: 'prompt',
                        title: 'prompt',
                        width: 100
                    },
                    {
                        field: 'tag',
                        title: 'tag',
                        width: 100
                    },
                    {
                        field: 'category',
                        title: 'category',
                        width: 100
                    },
                    {
                        field: 'others',
                        title: 'others',
                        width: 100,

                    },

                ]
            ],
            data: tdata,
            //skin: 'line', // 表格风格
            // even: true,
            page: true, // 是否显示分页
            // limits: [5, 10, 15],
            // limit: 5 // 每页默认显示的数量
        });
        // 监听工具条事件
        table.on('tool(tabletoolbar1)', function(obj) {
            var data = obj.data; // 当前行的数据
            var event = obj.event; // lay-event 的值
            if (event === 'ccreator') {
                let containerID = 'container-create-content'
                mlog(data.prompt, 'data.prompt')
                promptDomGenerator(data.prompt, containerID, data.others)

                //加入最近使用缓存列表
                const recentprompthistory = new LocalStorageCache('recent_prompt_history', 20);
                recentprompthistory.add({
                    name: data.name,
                    timestamp: new Date().toLocaleString()
                });
                console.log(recentprompthistory.getAll());

            } else if (event === 'exportprompt') {
                alert('export prompt template')
                let prompts = JSON.parse(data.prompt)
                console.log(prompts)
                // 使用转换函数
                const csvContent = convertJsonToCsv(prompts);
                // 下载 CSV 文件
                downloadCsv(csvContent, `${data.name}.csv`);
            }
        });
    }


    //输出表格,html
    const mdToHtml_ = ((mdData, id) => {
        let htmlContent = mdToHtml(mdData)
        document.getElementById(id).innerHTML = htmlContent;
        let table = document.getElementById(id).querySelector("table")
        if (table) {
            table.classList.add("layui-table")
        }
    })
</script>

<script type="text/html" id="table-operations-1">
    <div class="layui-clear-space">
        <a title="Use_Prompt" class="layui-btn layui-btn-xs" lay-event="ccreator" onclick="changeColor(this)">U</a>
        <a title="Export Prompt Template" class="layui-btn layui-btn-danger layui-btn-xs" lay-event="exportprompt">E</a>
        <!-- <a class="layui-btn layui-btn-xs" lay-event="ccreator">Use_Prompt</a>
        <a class="layui-btn layui-btn-danger layui-btn-xs" lay-event="exportprompt">Export</a> -->
    </div>
</script>


<script src="<?php echo CONTENT_AI_SEO_URL . 'assets/layui.js' ?>" id="layui_js-js"></script>

<script>
    document.addEventListener("DOMContentLoaded", () => {
        let selectedElement = null; // 用于保存当前点击的元素
        document.addEventListener("click", (event) => {
            // 获取当前点击的元素
            selectedElement = event.target;
            let isContained = ((id, element) => {
                return element.closest(id) !== null;
            })

            if (selectedElement && isContained("#topicplace", selectedElement) === true) {
                const textToCopy = selectedElement.textContent;
                // 使用 Clipboard API 复制
                navigator.clipboard.writeText(textToCopy).then(() => {
                    atip("coyied", selectedElement)

                }).catch((err) => {
                    atip("coyied failed! ");
                    console.log(err, "copy error")
                });
            }
        });
    })
</script>


<style>
    .infoshow {
        margin: 10px 5px;
    }

    .layui-bg-green {
        background-color: #2f4056 !important;
        padding: 4px;
    }

    #topicinput button {
        /* display: none; */
        margin-top: 5px;
    }

    #topicinput button[lay-on="dispalytop"] {
        display: none;
    }

    #topicinput button[lay-on="zoomineditinput"] {
        display: none;
    }

    #container-create-content button {
        /* display: none; */
    }

    #container-create-content select {
        width: 160px;
    }

    .taskstatus {
        text-align: center;
        padding: 4px 0;
        color: red;
    }


    .two-line-text {
        display: -webkit-box;
        -webkit-line-clamp: 2;
        -webkit-box-orient: vertical;
        overflow: hidden;
        text-overflow: ellipsis;
        text-decoration: underline;
        margin: 6px;
        /* border: 3px solid #2f4056; */
        cursor: pointer;
        list-style: decimal;
    }

    #showp {
        padding: 10px;
    }

    #topicplace {
        min-height: 600px;
    }

    .height-1 {
        min-height: 610px;
    }

    @media (max-width: 1290px) {
        #content-1-right button {
            display: block;
            margin-bottom: 4px;
        }
    }

    #select-research-prompt {
        display: block;
        margin-top: 5px;
    }

    #topicinput {
        padding: 8px;
    }

    .common-margin {
        margin-bottom: 4px !important;
    }

    #container-create-content .layui-card button:last-of-type {
        /* display: none !important; */
    }

    #container-create-content button[lay-on="dispalytop"] {
        display: none !important;
    }

    #topicsearchbar select {
        width: 160px;
    }

    #tagSelect-2 {
        max-width: 10rem !important;
    }

    .topicplace {
        max-height: 800px;
        overflow-y: scroll;
    }
</style>