<?php //功能：job logs
?>
<script src="<?php echo CONTENT_AI_SEO_URL . 'assets/layui.js' ?>" id="layui_js-js"></script>

<div class="layui-tab">
    <ul class="layui-tab-title">
        <li class="layui-this">Posts Generator Logs</li>
        <!-- <li>标签2</li>
        <li>标签3</li>
        <li>标签4</li>
        <li>标签5</li> -->
    </ul>
    <div class="layui-tab-content">
        <div class="layui-tab-item layui-show">
            <hr class="ws-space-8">
            <button id="updatelogs" class="layui-btn layui-btn-danger">Update Logs</button>
            <table lay-filter="IDtablePostsGeneratorLogs" class="layui-hide" id="ID-table-Posts-Generator-Logs"></table>

        </div>
        <!-- <div class="layui-tab-item">内容-2</div>
        <div class="layui-tab-item">内容-3</div>
        <div class="layui-tab-item">内容-4</div>
        <div class="layui-tab-item">内容-5</div> -->
    </div>
</div>

<script>
    document.addEventListener('DOMContentLoaded', function() {
        layui.use(['table', 'form'], async function() {
            var table = layui.table;
            var $ = layui.$;

            var dbjl = new PromptDatabase();
            var jobLogs = await dbjl.getAllJobLogs();
            loadatatotablepostslogs(table, jobLogs)

            $('#updatelogs').on('click',async function() {
                 jobLogs = await dbjl.getAllJobLogs();
                loadatatotablepostslogs(table, jobLogs)
            })

        })
    })


    function loadatatotablepostslogs(table, list) {
        var tdata = []
        list.forEach((ele, key) => {
            if (ele['post_id']) {
                let m = {
                    "post_id": ele['post_id'],
                    "post_title": ele['post_title'],
                    "product_by_who": ele['product_by_who'],
                    "post_time": ele['post_time'],
                }
                tdata.unshift(m)
            }
        });

        // 已知数据渲染
        var inst = table.render({
            elem: '#ID-table-Posts-Generator-Logs',
            cols: [
                [ //标题栏
                    // {
                    //     title: 'Action',
                    //     width: 80,
                    //     toolbar: '#table-operations-1'
                    // },
                    {
                        field: 'post_id',
                        title: 'post_id',

                    },
                    {
                        field: 'post_title',
                        title: 'post_title',
                        minWidth: 200,
                        templet: function(d) {
                            // 假设你希望链接到某个文章页面
                            const fullUrl = geturl();
                            
                            let posturl = `/wp-admin/post.php?post=${d.post_id}&action=edit`
                            return `<a href="${posturl}" target="_blank">${d.post_title}</a>`;
                        }

                    },
                    {
                        field: 'product_by_who',
                        title: 'product_by_who',
                    },
                    {
                        field: 'post_time',
                        title: 'post_time',
                    }

                ]
            ],
            data: tdata,
            //skin: 'line', // 表格风格
            // even: true,
            page: true, // 是否显示分页
            // limits: [5, 10, 15],
            // limit: 5 // 每页默认显示的数量
        });
    }
</script>