<?php //以书目录一键批量生成关联内聚专题内容
// 生成大纲，编辑大纲，查看编辑大纲生成的初步数据（如文章标题，生成文章prompt选择），执行任务
?>

<script src="<?php echo CONTENT_AI_SEO_URL . 'assets/layui.js' ?>" id="layui_js-js"></script>

<!-- //json 编辑器依赖 -->
<link rel="stylesheet" href="<?php echo CONTENT_AI_SEO_URL . 'assets/css/codemirror.min.css' ?>">
<script src="<?php echo CONTENT_AI_SEO_URL . 'assets/otherjs/codemirror.min.js' ?>" id="codemirror_min_js"></script>
<script src="<?php echo CONTENT_AI_SEO_URL . 'assets/otherjs/javascript.min.js' ?>" id="javascript_min_js"></script>

<!-- <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.12/codemirror.min.css">
<script id="codemirror-js" src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.12/codemirror.min.js"></script>
<script id="javascript-min-js" src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.12/mode/javascript/javascript.min.js"></script> -->




<div id="rapidg" class="layui-tab layui-tab-color" lay-filter="BaseOnBookTopicOutline-handle" lay-allowclose="true">
    <H3 class="function-intro">Function: Base on generated book outlines or article outlines to batch generate articles</H3>
    <ul class="layui-tab-title">
        <li class="layui-this" lay-allowclose="false">Base On Book Topic Outline</li>
    </ul>
    <div class="layui-tab-content">
        <div class="layui-tab-item layui-show">
            <button id="generateOutline" lay-on="generateOutline" class="layui-btn layui-btn-warm">Generate</button>
            <button lay-on="regenerateOutline" class="layui-btn layui-btn-warm">Regenerate</button>
            <!-- <button lay-on="submitcronjob" class="layui-btn layui-btn-primary layui-border">Add to Tasks List</button>
            <button lay-on="batchcronjob" class="layui-btn layui-btn-primary layui-border">Batch Generate</button> -->
            <select id="SelectGeneratorCategory" lay-search="">
                <option value="">Select Generator Category</option>
            </select>
            <select id="Selectoutlineprompt" lay-search="">
                <option value="">Select outline prompt</option>
            </select>
            <span style="color: red;">Note: In the BulkJobs category, prompts can be customized within the TopicOutline and TopicOutlineA tags.</span>
            <!-- <button lay-on="applyGenerateOutline" class="layui-btn layui-btn-sm layui-btn-warm">Apply</button> -->
            <div id="container-prompt-outline"></div>
            <div class="historychat-rg" id="rg-history"></div>
            <div class="historychat-rg" id="rg-history-article-outline-revise"></div>

        </div>
    </div>
</div>


<script>
    var outtable;
    layui.use(['table'], function() {
        var editor = null
        var element = layui.element;
        var util = layui.util;
        outtable = layui.table;
        var table = layui.table;
        var form = layui.form;
        var util = layui.util;
        var $ = layui.$;
        const db3 = new PromptDatabase();
        var outlines = ['TopicOutline']
        var outlinetype = "TopicOutline"
        var booktoc = null
        var subsectionTitles = []
        var rgSetting = ['']
        var allArticlePromps = ""
        var tdata = []
        // var allArticleOutlineprompts = ""

        const beginnergenerator = ((promptname, containerID) => {
            db3.getPromptByName(promptname).then((res) => {
                let prompt = JSON.parse(res['prompt'])
                promptDomGenerator(res['prompt'], containerID, res['others'])
            })
        })

        const formatJSON = (() => {
            let textarea = document.getElementById("jsonEditor");
            try {
                let jsonObj = JSON.parse(editor.getValue());
                editor.setValue(JSON.stringify(jsonObj, null, 4)); // 重新格式化

            } catch (error) {}
        })

        const mtabchange = ((layid, title, content) => {
            if (document.querySelector(`[lay-id=\"${layid}\"]`)) {
                element.tabDelete('BaseOnBookTopicOutline-handle', layid);
            }
            element.tabAdd('BaseOnBookTopicOutline-handle', {
                title: title,
                content: content,
                id: layid, // 实际使用一般是规定好的id，这里以毫秒数模拟
                change: true // 是否添加完毕后即自动切换
            })
            element.tabChange('BaseOnBookTopicOutline-handle', layid);
        })

        const validateJSON = (() => {
            try {

                let textarea = editor.getValue();
                return JSON.parse(textarea);
            } catch (error) {
                return ['error', error]
            }
        })

        const outlineprompts = ((outlineprompt) => {
            db3.getAllPromptByTag(outlineprompt).then(response => {

                    let dataSource = []
                    response.forEach((ele, key) => {
                        dataSource.push({
                            value: ele['name']
                        })
                    });
                    // 获取目标 select 元素
                    let selectElement = document.getElementById('Selectoutlineprompt');
                    // 调用函数填充选项
                    populateOptionsFromArray1(dataSource, selectElement);
                    // 监听 select 的 change 事件
                    selectElement.addEventListener("change", async (event) => {
                        let selectedValue = event.target.value;
                        let containerID = 'container-prompt-outline'
                        beginnergenerator(selectedValue, containerID)
                    });
                })
                .catch(error => {
                    console.error(error);
                })
        })

        const jobstart = (() => {

            let containerID = 'container-prompt-outline'
            let promptname = 'Base on book catalogue'
            beginnergenerator(promptname, containerID)

            let dataSource = []
            outlines.forEach((ele, key) => {
                dataSource.push({
                    value: ele
                })
            });
            // 获取目标 select 元素
            let selectElement = document.getElementById('SelectGeneratorCategory');
            populateOptionsFromArray1(dataSource, selectElement);
            selectElement.addEventListener("change", async (event) => {
                let selectedValue = event.target.value;
                outlinetype = selectedValue
                outlineprompts(selectedValue)
            })
        })

        jobstart()

        // 修改article structure单元格内容并刷新
        function modifyCell(itemid, contentstructure) {
            var newData = tdata.map(item => {
                if (item.id === itemid) {
                    item.articlestructure = contentstructure; // 修改单元格内容
                }
                return item;
            });

            // 刷新表格
            table.reload('ID-table-prompt-setting', {
                data: newData
            });
        }


        util.on('lay-on', {
            generateOutline: async function(othis) {
                let createContentInput = getAllValueInput('container-prompt-outline')
                let prompt = promptGenerator(createContentInput)

                // outline_rg = localStorage.getItem('outline_rg')

                let result = await mergePromptBookTocSendContinue(prompt, more = '000', jsonformat = '11', jsonSchema = JSON.stringify(jsonSchema1))
                outline_rg = result['dataresult']
                localStorage.setItem('outline_rg', outline_rg)
                let historychat_id = "rg-history"
                let prompts = prompt
                let airesponse = outline_rg
                settingHistorychat(historychat_id, prompts, airesponse)

                booktoc = JSON.parse(outline_rg)


                let layid = '2'
                let content = `<button lay-on="generateOutlineSetting" class="layui-btn layui-btn-warm">Go on Generate</button><button lay-on="formatJSON" class="layui-btn layui-btn-warm">Format JSON</button><button lay-on="revisedOutline" id="revisedOutline" class="layui-btn layui-btn-warm">Revised Outline</button><textarea id="jsonEditor">${outline_rg}</textarea>`
                let title = '2.Edit Topic Outline'

                mtabchange(layid, title, content)

                editor = CodeMirror.fromTextArea(document.getElementById("jsonEditor"), {
                    mode: "application/json",
                    theme: "default",
                    lineNumbers: true,
                    matchBrackets: true,
                    autoCloseBrackets: true,

                });
                editor.setSize("100%", "100%");
                // 强制刷新 CodeMirror，解决初始化时不显示内容的问题
                setTimeout(function() {
                    editor.refresh();
                }, 100);
                formatJSON()

            },
            revisedOutline: async function(othis) {
                layer.open({
                    title: "Revised Outline",
                    type: 1,
                    offset: 'l',
                    anim: 'slideRight', // 从右往左
                    content: `<div id="container102"><select id="Selectreviseoutlineprompt" lay-search="">
                            <option value="">Select revise outline prompt</option>
                            </select><button id="applyrop" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Apply</button><br><span style="color: red;">Note: In the BulkJobs category, prompts can be customized within the ReviseOutline tags.</span></div><div id="container102"><button id="revisedOutlineconfirm" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Revise</button><button lay-on="quickpromptpartrapid11" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Prompt part</button><button lay-on="quickpromptemptyrapid11" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Empty Part</button><div id="revisedOutlinecontainer"></div></div>`,
                    area: ['480px', '100%'], // 初始宽高
                    maxmin: true,
                    shade: 0.1,
                    // shadeClose: true,
                    success: function(layero, index) {
                        let reviseoutlineprompt = 'ReviseOutline'
                        db3.getAllPromptByTag(reviseoutlineprompt).then(response => {

                                let dataSource = []
                                response.forEach((ele, key) => {
                                    dataSource.push({
                                        value: ele['name']
                                    })
                                });
                                // 获取目标 select 元素
                                let selectElement = document.getElementById('Selectreviseoutlineprompt');
                                // 调用函数填充选项
                                populateOptionsFromArray1(dataSource, selectElement);
                            })
                            .catch(error => {
                                console.error(error);
                            })

                        $('#applyrop').on('click', function() {
                            let reviseprompt = document.getElementById('Selectreviseoutlineprompt').value
                            db3.getPromptByName(reviseprompt).then((res) => {

                                promptDomGenerator(res['prompt'], 'revisedOutlinecontainer')
                            })
                        })

                        $('#revisedOutlineconfirm').on('click', async function() {
                            let createContentInput = getAllValueInput('revisedOutlinecontainer')
                            let outlineprompt = promptGenerator(createContentInput)
                            let historychat_id = "rg-history"

                            let result = await mergePromptBookTocSendContinue(prompt = outlineprompt, more = historychat_id, jsonformat = '11', jsonSchema = JSON.stringify(jsonSchema1))
                            outline_rg = result['dataresult']
                            settingHistorychat(historychat_id, outlineprompt, outline_rg)
                            editor.setValue(outline_rg)

                            alert('done')
                            // layer.close(index)
                        })
                    }
                });
            },
            regenerateOutline: async function(othis) {
                document.getElementById("generateOutline").click()
            },
            generateOutlineSetting: async function(othis) {
                // if (document.querySelector("[lay-id=\"3\"]")) {
                //     element.tabDelete('BaseOnBookTopicOutline-handle', '3');
                // }
                let outlinejson = validateJSON()
                if (outlinejson[0] == "error") {
                    alert(`outline json format error,${outlinejson[1]},please check`)
                    return
                }

                let noteforcustomized = `<span style="color:red;">Note: In the BulkJobs category, the prompts can be customized within the ArticleGeneratorWithOutline tag.</span>`
                let layid = '3'
                let content = `<button lay-on="SettingNext" class="layui-btn layui-btn-warm">Go on Generate</button><div id="generatorSetting"></div>${noteforcustomized}`
                let title = '3.Setting'
                mtabchange(layid, title, content)

                if (outlinetype == "TopicOutline") {
                    subsectionTitles = extractSubsectionTitles(outlinejson)

                } else if (outlinetype == "TopicOutlineA") {
                    subsectionTitles = extractArrays(outlinejson)

                }

                let settingarr = []
                let promptsOption = await db3.getAllPromptByTag('ArticleGeneratorWithOutline')
                let promptnames = ""
                promptsOption.forEach(ele => {
                    promptnames = promptnames + ele.name + ','
                });
                let articleOutlinepromptsOption = await db3.getAllPromptByTag('OutlineStuctureForOutlineGeneratorBJ')
                let articleOutlinepromptnames = ""
                articleOutlinepromptsOption.forEach(ele => {
                    articleOutlinepromptnames = articleOutlinepromptnames + ele.name + ','
                });

                // 
                const categoriesChoice = contentAISEOAdmin.categories.map(item => `${item.id}-${item.name}`).join(',');

                settingarr.push({
                    'title': 'articles category(required)',
                    'content': `#${categoriesChoice}#`
                })
                // settingarr.push({
                //     'title': 'articles tag(required)',
                //     'content': ''
                // })
                settingarr.push({
                    'title': 'all articles generating prompt',
                    'content': `#${promptnames}#`
                })
                settingarr.push({
                    'title': 'all articles content structures generating prompt',
                    'content': `#${articleOutlinepromptnames}#`
                })

                let containerID = 'generatorSetting'
                settingarr = JSON.stringify(settingarr)
                promptDomGenerator(settingarr, containerID)

            },
            SettingNext: function(othis) {
                let layid = '4'
                let content = `<button lay-on="Generateallarticles" class="layui-btn layui-btn-warm">Generate all articles</button><button id="SettingAllprompt" lay-on="SettingAllprompt" class="layui-btn layui-btn-warm">All articles generating prompt setting</button><button title="Optional" id="contentStructuresGenerator" lay-on="contentStructuresGenerator" class="layui-btn layui-btn-warm">Article Structures Generator</button> <label><input id="dialogrg" type="checkbox" name="dialog"> Continuous dialog, contextualized</label>
                <br><button lay-on="GeneratePillarTopicarticle" class="rt layui-btn layui-bg-purple">Generate Pillar Topic article</button><div id="allarticleprompts"></div><table lay-filter="pstabletoolbar" class="layui-hide" id="ID-table-prompt-setting"></table><div class="historychat-rg" id="rg-articles-history"></div><div class="historychat-rg" id="rg-articles-outline-history"></div><button id="deleteBtn" class="layui-btn layui-btn-danger">Bulk Delete</button>`
                let title = '4.Prompt Setting'
                mtabchange(layid, title, content)

                rgSetting = getAllValueInput('generatorSetting')
                //转化成字典
                rgSetting = rgSetting.reduce((acc, item) => {
                    acc[item.title] = item.content;
                    return acc;
                }, {});


                subsectionTitles.forEach((ele, key) => {
                    let m = {
                        "id": key,
                        "name": ele,
                        "status": 'ready',
                        "prompt": rgSetting['all articles generating prompt'],
                        "promptcontent": "",
                        "articlestructure": "",
                    }
                    // tdata.unshift(m)
                    tdata.push(m)

                });
                var inst = table.render({
                    elem: '#ID-table-prompt-setting',
                    cols: [
                        [{
                                type: 'checkbox'
                            }, // 启用多选框
                            {
                                title: 'Action',
                                width: 280,
                                toolbar: '#table-operations-ps'
                            },
                            {
                                field: 'id',
                                title: 'id',
                                width: 30
                            },
                            {
                                field: 'name',
                                title: 'name',
                                width: 330
                            },
                            {
                                field: 'status',
                                title: 'status',
                                width: 80
                            },
                            {
                                field: 'prompt',
                                title: 'prompt',
                                width: 200
                            },
                            {
                                field: 'promptcontent',
                                title: 'promptcontent',
                                width: 200
                            },
                            {
                                field: 'articlestructure',
                                title: 'article structure',
                                width: 200
                            }
                        ]
                    ],
                    data: tdata,
                    page: true, // 是否显示分页
                    limit: 50 // 每页默认显示的数量
                });

                table.on('tool(pstabletoolbar)', function(obj) {
                    var data = obj.data; // 当前行的数据
                    var event = obj.event; // lay-event 的值
                    let noteforcustomized = `<span style="color:red;">Note: In the BulkJobs category, the prompts can be customized within the ArticleGeneratorWithOutline tag.</span>`
                    if (event === 'edit') {
                        layer.open({
                            type: 1, // page 层类型
                            area: ['500px', '500px'],
                            title: 'Info',
                            shade: 0, // 遮罩透明度
                            maxmin: true, // 允许全屏最小化
                            anim: 0, // 0-6 的动画形式，-1 不开启
                            content: '<div id="choosepromptlayer" style="padding: 32px;"><h3>Selecting a new template:</h3></div>'
                        });
                        db3.getTagsByName('ArticleGeneratorWithOutline').then((res) => {
                            res.forEach(ele => {
                                db3.getAllPromptByTag(ele).then((res1) => {
                                    $('#choosepromptlayer').append(`<blockquote class="layui-elem-quote layui-text">Tag: ${ele} </blockquote>`)
                                    var btnGroupContainer = $(`<div class="layui-btn-container"></div>`);
                                    res1.forEach(ele1 => {
                                        var btn = $('<button type="button" class="layui-btn layui-btn-sm"></button>').text(ele1['name']);
                                        btn.on('click', function() {
                                            atip('use prompt template :' + ele1['name'], btn)

                                            layer.open({
                                                title: "Setting",
                                                type: 1,
                                                offset: 'l',
                                                anim: 'slideRight', // 从右往左
                                                content: `<div id="container102"><button id="settingSinglepromptconfirm" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Confirm</button><button lay-on="quickpromptpartrapid2" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Prompt part</button><button lay-on="quickpromptemptyrapid2" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Empty Part</button><div id="settingSinglepromptcontainer"></div></div>`,
                                                area: ['480px', '100%'], // 初始宽高
                                                maxmin: true,
                                                shade: 0,
                                                // shadeClose: true,
                                                success: function(layero, index) {
                                                    db3.getPromptByName(ele1['name']).then((res) => {

                                                        promptDomGenerator(res['prompt'], 'settingSinglepromptcontainer')
                                                    })
                                                    $("#settingSinglepromptconfirm").on('click', function() {
                                                        let createContentInput = getAllValueInput('settingSinglepromptcontainer')
                                                        let singleArticlePrompt = promptGenerator(createContentInput)

                                                        obj.update({
                                                            prompt: ele1['name'],
                                                            promptcontent: singleArticlePrompt
                                                        });
                                                        layer.close(index)

                                                    })
                                                }
                                            });
                                        });
                                        // btn.on('mouseenter', function() {
                                        //     let prompt = JSON.parse(ele1['prompt'])
                                        //     prompt = promptGenerator(prompt)
                                        //     layer.tips(prompt, btn, {
                                        //         tips: [1, '#00FF00'], // 提示框位置：[位置, 颜色]
                                        //         time: 8000 // 提示框自动关闭时间，单位是毫秒
                                        //     });
                                        // });
                                        // btn.on('mouseleave', function() {
                                        //     layer.closeAll('tips'); // 关闭所有tips
                                        // });
                                        btnGroupContainer.append(btn);
                                    });
                                    $('#choosepromptlayer').append(btnGroupContainer);
                                })

                            });
                        })
                    } else if (event == 'editoutline') {
                        //清除历史对话记录
                        document.getElementById("rg-history-article-outline-revise").innerText = ''

                        var oldValue = data.articlestructure
                        // 打开弹窗
                        layer.open({
                            type: 1, // 页面层
                            title: data.name,
                            area: ['800px', '500px'], // 宽高
                            content: `<div id="container102"><select id="Selectreviseoutlinepromptarticle" lay-search="">
                            <option value="">Select revise outline prompt</option>
                            </select><button id="applyropa" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Apply</button><br><span style="color: red;">Note: In the BulkJobs category, prompts can be customized within the ReviseOutline tags.</span></div>
                            <div id="container102"><button id="revisedOutlineconfirmarticle" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Revise</button><button lay-on="quickpromptpartrapid12" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Prompt part</button><button lay-on="quickpromptemptyrapid12" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Empty Part</button><div id="revisedOutlinearticlecontainer"></div></div>
                            <textarea id="popupTextarea" class="layui-textarea" style="width:100%; height:80%;">${oldValue}</textarea>`,
                            shade: 0,
                            btn: ['Save', 'Cancel'],
                            yes: function(index) {
                                // 获取弹窗内的 textarea 内容
                                var newValue = document.getElementById('popupTextarea').value;

                                data['articlestructure'] = newValue
                                obj.update(data, true);

                                // 关闭弹窗
                                layer.close(index);
                            },
                            success: function(layero, index) {
                                let reviseoutlinepromptTag = 'ReviseOutline'
                                db3.getAllPromptByTag(reviseoutlinepromptTag).then(response => {
                                        let dataSource = []
                                        response.forEach((ele, key) => {
                                            dataSource.push({
                                                value: ele['name']
                                            })
                                        });
                                        // 获取目标 select 元素
                                        let selectElement = document.getElementById('Selectreviseoutlinepromptarticle');
                                        // 调用函数填充选项
                                        populateOptionsFromArray1(dataSource, selectElement);
                                    })
                                    .catch(error => {
                                        console.error(error);
                                    })

                                $('#applyropa').on('click', function() {
                                    let reviseprompt = document.getElementById('Selectreviseoutlinepromptarticle').value
                                    db3.getPromptByName(reviseprompt).then((res) => {

                                        promptDomGenerator(res['prompt'], 'revisedOutlinearticlecontainer')
                                    })
                                })

                                $('#revisedOutlineconfirmarticle').on('click', async function() {
                                    let latestOutline = document.getElementById('popupTextarea').value
                                    let createContentInput = getAllValueInput('revisedOutlinearticlecontainer')
                                    let outlineprompt = promptGenerator(createContentInput)
                                    if (outlineprompt == '' || latestOutline == '') {
                                        alert('please set prompt or outline first')
                                        setFocusAndHighlight('Selectreviseoutlinepromptarticle')
                                        return
                                    }
                                    let finalprompt = `${outlineprompt}Outline:${latestOutline};<br>Return Format:Json;<br>`
                                    let historychat_id = "rg-history-article-outline-revise"
                                    // let outline_rg_article_result = `outline_rg_article_result_${Date()}`
                                    let outline_rg_article_result = null
                                    let result = await mergePromptSendContinue(prompt = finalprompt, more = 'rg-history-article-outline-revise', jsonformat = '11', save = '00')
                                    outline_rg_article_result = result['dataresult']
                                    settingHistorychat(historychat_id, finalprompt, outline_rg_article_result)
                                    document.getElementById("popupTextarea").value = outline_rg_article_result;
                                   
                                })
                            }

                        });
                    }
                });

                $('#deleteBtn').on('click', function() {
                    // 获取所有选中的行
                    var checkStatus = table.checkStatus('ID-table-prompt-setting');
                    var data = checkStatus.data; // 获取选中的行数据

                    if (data.length === 0) {
                        layer.msg('Please select the data to be deleted');
                        return;
                    }

                    // 删除选中的数据
                    layer.confirm('Sure you want to delete the selected data?', {
                        icon: 3,
                        title: 'Tips'
                    }, function(index) {
                        // 模拟删除操作：从 tableData 中移除选中的数据
                        tdata = tdata.filter(item => !data.some(d => d.name === item.name));

                        // 刷新表格数据
                        table.reload('ID-table-prompt-setting', {
                            data: tdata
                        });

                        layer.msg('delete successful');
                        layer.close(index);
                    });
                });


            },
            GeneratePillarTopicarticle: async function(othis) {
                alert('GeneratePillarTopicarticle')

                layer.open({
                    type: 1, // 页面层
                    title: 'Generating Pillar Topic Article',
                    area: ['800px', '500px'], // 宽高
                    content: `<div id="container102"><select id="SelectArticlePrompt" lay-search="">
                            <option value="">Select prompt</option>
                            </select><button id="applyAP" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Apply</button><br><span style="color: red;">Note: In the BulkJobs category, prompts can be customized within the 'ArticlePillarGeneratorWithOutline' tags.</span></div>
                            <div id="container102"><button id="ArticleStartGenerating" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Start</button><button lay-on="quickpromptpartrapid12" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Prompt part</button><button lay-on="quickpromptemptyrapid12" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Empty Part</button><div id="pillarArticleContainer"></div></div>
                            <textarea id="popupTextarea01" class="layui-textarea" style="width:100%; height:80%;">${outline_rg}</textarea>`,
                    shade: 0,
                    btn: ['Save', 'Cancel'],
                    yes: function(index) {
                        // 获取弹窗内的 textarea 内容
                        // var newValue = document.getElementById('popupTextarea01').value;

                        // 关闭弹窗
                        layer.close(index);
                    },
                    success: function(layero, index) {
                        let articlepromptTag = 'ArticlePillarGeneratorWithOutline'
                        db3.getAllPromptByTag(articlepromptTag).then(response => {
                                let dataSource = []
                                response.forEach((ele, key) => {
                                    dataSource.push({
                                        value: ele['name']
                                    })
                                });
                                // 获取目标 select 元素
                                let selectElement = document.getElementById('SelectArticlePrompt');
                                // 调用函数填充选项
                                populateOptionsFromArray1(dataSource, selectElement);
                            })
                            .catch(error => {
                                console.error(error);
                            })

                        $('#applyAP').on('click', function() {
                            let articleprompt = document.getElementById('SelectArticlePrompt').value
                            db3.getPromptByName(articleprompt).then((res) => {
                                promptDomGenerator(res['prompt'], 'pillarArticleContainer')
                            })
                        })

                        $('#ArticleStartGenerating').on('click', async function() {
                            let cate_id = rgSetting['articles category(required)'].split('-')
                            let savePostsSetting = {
                                Tags: booktoc['title'],
                                category: cate_id[0],
                                StatusVisibility: 'Draft'
                            }

                            savePostsSetting['posttime'] = getCurrentFormattedDate(hour = -3)

                            let latestOutline = document.getElementById('popupTextarea01').value
                            let createContentInput = getAllValueInput('pillarArticleContainer')
                            let articleprompt = promptGenerator(createContentInput)
                            if (articleprompt == '' || latestOutline == '') {
                                alert('please set prompt or outline first')
                                setFocusAndHighlight('SelectArticlePrompt')
                                return
                            }
                            let finalprompt = `${articleprompt}Outline:${latestOutline};<br>`
                            // let historychat_id = "rg-history-article-outline-revise"
                            let outline_rg_article_result = null
                            let result = await mergePromptSend(finalprompt, save = savePostsSetting, returncounts = 1, jsonformat = '11')
                            outline_rg_article_result = result['dataresult']

                            //保存生成文章记录
                            let recordgenerating = result['respond']
                            //记录到任务列表当作
                            let db = new PromptDatabase();
                            let postid = recordgenerating['post_id']
                            let title = recordgenerating['article_title']
                            let bywho = contentAISEOAdmin.usr

                            const jobId = await db.addJobLog({
                                product_by_who: bywho,
                                post_id: postid,
                                post_title: title,
                                post_time: new Date().toISOString()
                            });
                         
                        })
                    }

                });

            },
            Generateallarticles: async function(othis) {
                var tableData = table.cache['ID-table-prompt-setting']; // 'myTable' 是 table 的 id
                let cate_id = rgSetting['articles category(required)'].split('-')
                let savePostsSetting = {
                    Tags: booktoc['title'],
                    category: cate_id[0],
                    StatusVisibility: 'Draft'
                }
               

                const dialogcontinue = document.querySelector('input[name="dialog"]').checked;
               

                for (const ele of tableData) {

                    savePostsSetting['posttime'] = getCurrentFormattedDate(hour = parseInt(ele['id']))


                    let prompt = ''
                    if (ele['promptcontent'] == "") {
                        prompt = allArticlePromps
                    } else {
                        prompt = ele['promptcontent']
                    }

                    if (prompt == "") {
                        alert('Please set prompt first')
                        setFocusAndHighlight('SettingAllprompt')
                        return
                    }

                    if (ele['articlestructure'] != '') {
                        articleStructures = `Article Structure:${ele['articlestructure']}<br>`
                    } else {
                        articleStructures = ''
                    }
                    if (dialogcontinue == true) {

                        let finalprompt
                        let result
                        if (ele['id'] == 0) {
                            finalprompt = `${prompt}Book Toc:${outline_rg}<br>Article Title:${ele['name']}<br>${articleStructures}`
                        } else {
                            finalprompt = `Requirement:Base on The Book Toc,Continue writing an article;<br>Article Title:${ele['name']}<br>${articleStructures}`
                        }
                        try {
                            let result_ = await mergePromptSendContinue(prompt = finalprompt, more = 'rg-articles-history', jsonformat = '11', save = savePostsSetting)
                            result = result_['dataresult']

                            //保存生成文章记录
                            let recordgenerating = result_['respond']
                            //记录到任务列表当作
                            let db = new PromptDatabase();
                            let postid = recordgenerating['post_id']
                            let title = recordgenerating['article_title']
                            let bywho = contentAISEOAdmin.usr

                            const jobId = await db.addJobLog({
                                product_by_who: bywho,
                                post_id: postid,
                                post_title: title,
                                post_time: new Date().toISOString()
                            });


                            settingHistorychat(historychat_id = 'rg-articles-history', prompts = finalprompt, airesponse = result)

                            modifybulkTableCell(tdata = tableData, itemid = ele['id'], finishstatus = 'complete', tableid = 'ID-table-prompt-setting')
                        } catch (error) {
                            modifybulkTableCell(tdata = tableData, itemid = ele['id'], finishstatus = 'error', tableid = 'ID-table-prompt-setting')

                        }
                    } else {
                        let finalprompt = `${prompt}Book Toc:${outline_rg}<br>Article Title:${ele['name']}<br>${articleStructures}`

                        let errorprocess = {
                            'type': 'rg',
                            'id': ele['id']
                        }

                        addContentTask(finalprompt, showtip_target = othis, save_var = savePostsSetting, errorprocess = errorprocess)
                    }
                }



            },
            formatJSON: function(othis) {
                formatJSON()
            },
            quickpromptpartrapid1: function(othis) {
                quickpromptpartfunction('settingallpromptcontainer', 'r')
            },
            quickpromptemptyrapid1: function(othis) {

                addcomponet({
                    'title': 'label',
                    'content': 'content'
                }, 'settingallpromptcontainer')
            },
            quickpromptpartrapid2: function(othis) {
                quickpromptpartfunction('settingSinglepromptcontainer', 'r')
            },
            quickpromptemptyrapid2: function(othis) {

                addcomponet({
                    'title': 'label',
                    'content': 'content'
                }, 'settingSinglepromptcontainer')
            },
            quickpromptpartrapid11: function(othis) {
                quickpromptpartfunction('revisedOutlinecontainer', 'r')
            },
            quickpromptpartrapid12: function(othis) {
                quickpromptpartfunction('revisedOutlinearticlecontainer', 'r')
            },
            quickpromptemptyrapid11: function(othis) {
                addcomponet({
                    'title': 'label',
                    'content': 'content'
                }, 'revisedOutlinecontainer')
            },
            quickpromptemptyrapid12: function(othis) {
                addcomponet({
                    'title': 'label',
                    'content': 'content'
                }, 'revisedOutlinearticlecontainer')
            },

            quickpromptpart3: function(othis) {
                quickpromptpartfunction('settingalloutlinepromptcontainer', 'r')
            },
            emptyprompt3: function(othis) {
                addcomponet({
                    'title': 'label',
                    'content': 'content'
                }, 'settingalloutlinepromptcontainer')
            },

            SettingAllprompt: function(othis) {
                layer.open({
                    title: "Setting",
                    type: 1,
                    offset: 'l',
                    anim: 'slideRight', // 从右往左
                    content: `<div id="container102"><button id="settingallpromptconfirm" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Confirm</button><button lay-on="quickpromptpartrapid1" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Prompt part</button><button lay-on="quickpromptemptyrapid1" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Empty Part</button><div id="settingallpromptcontainer"></div></div>`,
                    area: ['480px', '100%'], // 初始宽高
                    maxmin: true,
                    shade: 0.1,
                    // shadeClose: true,
                    success: function(layero, index) {
                        db3.getPromptByName(rgSetting['all articles generating prompt']).then((res) => {
                            promptDomGenerator(res['prompt'], 'settingallpromptcontainer')
                        })
                        $('#settingallpromptconfirm').on('click', function() {
                            let createContentInput = getAllValueInput('settingallpromptcontainer')
                            allArticlePromps = promptGenerator(createContentInput)
                            document.querySelector("#allarticleprompts").innerHTML = `<h3>All Articles Prompt</h3>${allArticlePromps}`

                            layer.close(index)
                        })
                    }
                });
            },
            contentStructuresGenerator: function(othis) {
                // alert('g structures')
                layer.open({
                    title: "Struture Prompt Setting",
                    type: 1,
                    offset: 'l',
                    anim: 'slideRight', // 从右往左
                    content: `<div id="container102"><button id="settingalloutlinepromptconfirm" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Start</button><button lay-on="quickpromptpart3" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Prompt part</button><button lay-on="emptyprompt3" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Empty Part</button><div id="settingalloutlinepromptcontainer"></div></div>`,
                    area: ['480px', '100%'], // 初始宽高
                    maxmin: true,
                    shade: 0.1,
                    // shadeClose: true,
                    success: function(layero, index) {
                        db3.getPromptByName(rgSetting['all articles content structures generating prompt']).then((res) => {
                            promptDomGenerator(res['prompt'], 'settingalloutlinepromptcontainer')
                        })

                        $('#settingalloutlinepromptconfirm').on('click', async function() {

                            layer.msg('Start generating article outline')
                            let createContentInput = getAllValueInput('settingalloutlinepromptcontainer')
                            let allArticleOutlinePrompts = promptGenerator(createContentInput)
                            // document.querySelector("#allarticleprompts").innerHTML = `<h3>All Articles Prompt</h3>${allArticlePromps}`
                            // layer.close(index)

                            var tableData = table.cache['ID-table-prompt-setting']; // 'myTable' 是 table 的 id


                            for (const ele of tableData) {

                                let finalprompt
                                let result
                                if (ele['id'] == 0) {
                                    finalprompt = `Book Toc:${outline_rg}<br>Subsection Article Title:${ele['name']}<br>${allArticleOutlinePrompts}`
                                } else {
                                    finalprompt = `Requirement:Base on The Book Toc,Continue writing an Outline for the Article Title;<br>Article Title:${ele['name']};<br>`
                                }
                                try {
                                    let result_ = await mergePromptSendContinue(prompt = finalprompt, more = 'rg-articles-outline-history', jsonformat = '11', save = '00')
                                    result = result_['dataresult']
                                    // result = `{[it's outline result_${ele['name']}_${ele['id']}]}`
                                    settingHistorychat(historychat_id = 'rg-articles-outline-history', prompts = finalprompt, airesponse = result)
                                    modifyCell(itemid = ele['id'], contentstructure = result)
                                } catch (error) {
                                    mlog(error, 'error when generating outline')
                                }
                            }

                            alert('Done')
                        })
                    }
                });
            },
        })
    });

    var jsonSchema1 = {
        "$schema": "http://json-schema.org/draft-07/schema#",
        "type": "object",
        "properties": {
            "title": {
                "type": "string",
                "description": "The title of the book."
            },
            "chapters": {
                "type": "array",
                "description": "List of chapters in the book.",
                "items": {
                    "type": "object",
                    "properties": {
                        "title": {
                            "type": "string",
                            "description": "Title of the chapter."
                        },
                        "sections": {
                            "type": "array",
                            "description": "Sections within the chapter.",
                            "items": {
                                "type": "object",
                                "properties": {
                                    "title": {
                                        "type": "string",
                                        "description": "Title of the section."
                                    },
                                    "subsections": {
                                        "type": "array",
                                        "description": "Subsections within the section.",
                                        "items": {
                                            "type": "object",
                                            "properties": {
                                                "title": {
                                                    "type": "string",
                                                    "description": "Title of the subsection."
                                                }
                                            },
                                            "required": ["title"]
                                        }
                                    }
                                },
                                "required": ["title", "subsections"]
                            }
                        }
                    },
                    "required": ["title", "sections"]
                }
            }
        },
        "required": ["title", "chapters"]
    }


    var outline_rg = null //专题大纲

    // var outline_rg = {
    //     "title": "鼠标维修指南",
    //     "chapters": [{
    //             "title": "第一篇：鼠标基础知识",
    //             "sections": [{
    //                     "title": "第1章 鼠标的基本构造",
    //                     "subsections": [{
    //                             "title": "1.1 机械鼠标与光电鼠标的区别"
    //                         },
    //                         {
    //                             "title": "1.2 鼠标的内部组成"
    //                         },
    //                         {
    //                             "title": "1.3 鼠标传感器技术解析"
    //                         }
    //                     ]
    //                 },
    //                 {
    //                     "title": "第2章 鼠标的工作原理",
    //                     "subsections": [{
    //                             "title": "2.1 鼠标信号传输方式"
    //                         },
    //                         {
    //                             "title": "2.2 有线与无线鼠标的工作机制"
    //                         },
    //                         {
    //                             "title": "2.3 DPI与鼠标灵敏度调节"
    //                         }
    //                     ]
    //                 }
    //             ]
    //         },
    //         {
    //             "title": "第二篇：鼠标常见故障与维修",
    //             "sections": [{
    //                     "title": "第3章 鼠标按键故障",
    //                     "subsections": [{
    //                             "title": "3.1 鼠标按键失灵的原因及解决方法"
    //                         },
    //                         {
    //                             "title": "3.2 双击问题的诊断与维修"
    //                         },
    //                         {
    //                             "title": "3.3 微动开关的更换步骤"
    //                         }
    //                     ]
    //                 },
    //                 {
    //                     "title": "第4章 鼠标滚轮问题",
    //                     "subsections": [{
    //                             "title": "4.1 滚轮失灵或卡顿的处理"
    //                         },
    //                         {
    //                             "title": "4.2 滚轮编码器的更换"
    //                         },
    //                         {
    //                             "title": "4.3 如何清洁与维护滚轮"
    //                         }
    //                     ]
    //                 },
    //                 {
    //                     "title": "第5章 连接与信号故障",
    //                     "subsections": [{
    //                             "title": "5.1 鼠标无法连接的排查方法"
    //                         },
    //                         {
    //                             "title": "5.2 无线鼠标信号丢失的解决方案"
    //                         },
    //                         {
    //                             "title": "5.3 USB接口与驱动问题修复"
    //                         }
    //                     ]
    //                 }
    //             ]
    //         },
    //         {
    //             "title": "第三篇：高级鼠标维修技巧",
    //             "sections": [{
    //                     "title": "第6章 鼠标电路板维修",
    //                     "subsections": [{
    //                             "title": "6.1 鼠标PCB板的基本知识"
    //                         },
    //                         {
    //                             "title": "6.2 识别与修复鼠标电路短路"
    //                         },
    //                         {
    //                             "title": "6.3 更换损坏的电容与电阻"
    //                         }
    //                     ]
    //                 },
    //                 {
    //                     "title": "第7章 传感器与固件问题",
    //                     "subsections": [{
    //                             "title": "7.1 传感器损坏的检测方法"
    //                         },
    //                         {
    //                             "title": "7.2 如何升级或刷写鼠标固件"
    //                         },
    //                         {
    //                             "title": "7.3 传感器更换指南"
    //                         }
    //                     ]
    //                 }
    //             ]
    //         },
    //         {
    //             "title": "第四篇：鼠标优化与保养",
    //             "sections": [{
    //                     "title": "第8章 鼠标定期维护",
    //                     "subsections": [{
    //                             "title": "8.1 鼠标清洁的正确方法"
    //                         },
    //                         {
    //                             "title": "8.2 如何更换鼠标脚贴"
    //                         },
    //                         {
    //                             "title": "8.3 鼠标线缆的保护与修复"
    //                         }
    //                     ]
    //                 },
    //                 {
    //                     "title": "第9章 鼠标使用优化",
    //                     "subsections": [{
    //                             "title": "9.1 调整鼠标参数以提高使用体验"
    //                         },
    //                         {
    //                             "title": "9.2 游戏鼠标的专业优化设置"
    //                         },
    //                         {
    //                             "title": "9.3 鼠标宏与自定义按键编程"
    //                         }
    //                     ]
    //                 }
    //             ]
    //         }
    //     ]
    // }

    function populateOptionsFromArray1(res, target) {
        target.innerHTML = '<option value="">Select outline prompt</option>';

        let data = []
        res.forEach((ele, key) => {
            data.push({
                value: ele['value'],
                text: ele['value']
            })
        });

        // 遍历数组并创建选项
        data.forEach(item => {
            const option = document.createElement('option');
            option.value = item.value;
            option.textContent = item.text;
            target.appendChild(option);
        });

        orderaz(target.id)
    }
</script>

<script type="text/html" id="table-operations-rg">
    <div class="layui-clear-space">
        <!-- <a class="layui-btn layui-btn-xs" lay-event="editTitle">Edit_Title</a> -->
        <a class="layui-btn layui-btn-danger layui-btn-xs" lay-event="deletedraf">Delete</a>
        <a class="layui-btn layui-btn-danger layui-btn-xs" lay-event="chooseprompt">Choose_Prompt</a>
    </div>
</script>

<script type="text/html" id="table-operations-ps">
    <div class="layui-clear-space">
        <a title="Individually set prompts" class="layui-btn layui-btn-xs" lay-event="edit" onclick="changeColor(this)">EditPromptTemplate</a>
        <a title="edit outline" class="layui-btn layui-btn-xs" lay-event="editoutline" onclick="changeColor(this)">EditOutline</a>
    </div>
</script>

<style>
    #choosepromptlayer h3 {
        margin-bottom: 10px;
    }

    .layui-table-body {
        overflow: hidden;
    }

    @media (min-width: 550px) {
        .layui-form-item .layui-inline {
            text-align: left !important;
            width: 600px;
        }
    }

    @media (max-width: 549px) {
        .layui-form-item .layui-inline {
            text-align: left !important;
            width: 400px;
        }

        .layui-form-item .layui-input-inline {

            width: 100px !important;

        }
    }

    .layui-tab-color {
        background-color: white;

    }

    .layui-tab-color .layui-tab-content {

        margin: 10px;
    }

    #jsonEditor {
        margin-top: 10px;
        width: 100%;
        height: 600px;
        font-family: monospace;
    }

    #container-prompt-outline button[lay-on="dispalytop"] {
        display: none !important;
    }

    #rapidg input {
        text-transform: capitalize;
    }

    #generatorSetting .layui-card-body button {
        display: none;
    }

    .layui-tab-close {
        display: none !important;
    }

    #settingallpromptcontainer button.dispalytopcss {
        display: none;
    }

    #settingSinglepromptcontainer button.dispalytopcss {
        display: none;
    }

    #revisedOutlinecontainer button.dispalytopcss {
        display: none;
    }

    #revisedOutlinearticlecontainer button.dispalytopcss {
        display: none;
    }

    #container102 {
        padding: 22px;
    }

    #allarticleprompts {
        padding: 12px;
    }

    #settingalloutlinepromptcontainer button.dispalytopcss {
        display: none;
    }

    .rt {
        margin-top: 10px;
    }
</style>