<?php //功能：autoseo
?>
<script src="<?php echo CONTENT_AI_SEO_URL . 'assets/layui.js' ?>" id="layui_js-js"></script>

<div class="layui-btn-container">
  <button class="layui-btn layui-btn-sm" lay-on="getCheckForGenerateData">Generate SEO data for selected rows</button>
  <button class="layui-btn layui-btn-sm" lay-on="loadNewArticle">Load new articles</button>
  <!-- <button class="layui-btn layui-btn-sm" lay-event="getData">获取当前页数据</button>
  <button class="layui-btn layui-btn-sm" id="dropdownButton"> -->
  <!-- 下拉按钮
  <i class="layui-icon layui-icon-down layui-font-12"></i> -->
  <!-- </button> -->

</div>
<span id="jobsnote" class="layui-badge layui-bg-cyan"></span>
<select title="prompt for generating" id="autoseopromptselect"></select><button lay-on="promptsetting" id="promptsetting" type="button" class="layui-btn layui-btn-sm layui-btn-normal">prompt setting</button>
<div id="autoseopromptcontainer"></div>
<table class="layui-hide" id="ID-table-articles" lay-filter="lytablearticles"></table>

<script>
  function populateOptionsFromArrayAuto(res, target) {
    target.innerHTML = '<option value="">Select prompt</option>';

    let data = []
    res.forEach((ele, key) => {
      data.push({
        value: ele['value'],
        text: ele['value']
      })
    });

    // 遍历数组并创建选项
    data.forEach(item => {
      const option = document.createElement('option');
      option.value = item.value;
      option.textContent = item.text;
      target.appendChild(option);
    });

    orderaz(target.id)
  }

  layui.use(['table'], function() {
    var table = layui.table;
    var form = layui.form;
    var util = layui.util;
    var tabledata;
    var finalbulkprompt = ''
    let db = new PromptDatabase();

    var autoseopromptselect = document.getElementById('autoseopromptselect');
    let tag = 'SEOGenerateTDK'
    db.getAllPromptByTag(tag).then(res => {
      // console.log(res)
      // 调用函数填充选项
      populateOptionsFromArrayAuto(res, autoseopromptselect);
      autoseopromptselect.addEventListener("change", async (event) => {})
    })

    util.on('lay-on', {
      getCheckForGenerateData: async function(othis) {
        // alert(autoseopromptselect.value)
        if (finalbulkprompt == '') {
          alert('promptsetting is empty')
          setFocusAndHighlight("promptsetting")
          return
        }
        atip("checkdatas", othis);
        var mInterval = localStorage.getItem('Interval_Time_Of_Generate') ?? 8000
        var checkStatus = table.checkStatus('ID-table-articles'); // 获取选中状态
        console.log('选中的数据：', checkStatus.data);
        var joblength = checkStatus.data.length
        // console.log('选中的数据：', checkStatus.data[0]);
        let openai_params_ = getaiparams('chatgpt')
        checkStatus.data.forEach((value, key) => {
          delay(mInterval * key)
            .then(() => {
              console.log('秒后执行', mInterval * key);
              // 在这里执行你的逻辑
              openai_params_.prompt = finalbulkprompt

              const postData = {
                irequire: "content_seo_auto_generator",
                // data: JSON.stringify(checkStatus.data)
                data: value["post_id"],
                aiparams: openai_params_
              };
              const url = '/wp-json/myseoai/v1/route';
              let r = sendpost(postData, url)
             
              joblength = joblength - 1;
              if (joblength == 0) {
                delay(5000)
                  .then(() => {
                    getjson_content_ai_seo_get_all_data()
                  })
              }
              document.querySelector("#jobsnote").innerHTML = `${joblength} remaining tasks`


            });
        });
      },
      loadNewArticle: async function() {
        // alert('load new article')
        const postData = {
          irequire: "content_ai_seo_get_all_data",
          subrequire: "load_new_article",
        };
        const url = '/wp-json/myseoai/v1/route';
        let r = await sendpost(postData, url)
        let dataresult = JSON.parse(r['dataresult'])

        tablerender(dataresult)
      },
      promptsetting: async function() {
        let DOM = `<div id="" style="padding: 32px;"><button id="autoseosubmitprompt" class="layui-btn-sm layui-bg-cyan">Submit</button><div id="autoSEOcontainerID" style="padding: 2px;"></div></div>`
        let promptsetting = layer.open({
          type: 1, // page 层类型
          area: ['100%', '100%'],
          title: 'Prompt Setting',
          shade: 0, // 遮罩透明度
          shadeClose: false, // 点击遮罩区域，关闭弹层
          maxmin: true, // 允许全屏最小化
          anim: 0, // 0-6 的动画形式，-1 不开启
          content: DOM,
          btn: ['Close'],
          yes: function(index, layero) {
            // 关闭弹出层时清除 index
            layer.close(index);
            // SEOImageSettingLayerindex = null;
          },
          // 监听弹出层关闭事件，不管是点击背景，点击关闭按钮，还是通过 API 关闭
          end: function() {
            layer.close(index);
          },
          success: async function(layero, index) {
            const promptname = autoseopromptselect.value;
            db.getPromptByName(promptname).then((res) => {
              let containerID = 'autoSEOcontainerID'
              promptDomGenerator(res['prompt'], containerID, res['others'])
            })
            let button = document.querySelector("#autoseosubmitprompt")
            button.addEventListener('click', () => {
              let createContentInput = getAllValueInput('autoSEOcontainerID')
              let createContentPrompt = promptGenerator(createContentInput)
              document.querySelector("#autoseopromptcontainer").innerHTML = createContentPrompt
              finalbulkprompt = createContentPrompt
              layer.close(index);
            })
          }
        });

      }
    })

    const getjson_content_ai_seo_get_all_data = (async () => {
      const postData = {
        irequire: "content_ai_seo_get_all_data",
      };
      const url = '/wp-json/myseoai/v1/route';
      let r = await sendpost(postData, url)

      let dataresult = JSON.parse(r['dataresult'])

      tablerender(dataresult)
    })

    // 创建渲染实例
    const tablerender = ((tdata) => {
      table.render({
        elem: '#ID-table-articles',
        lineStyle: 'height: 125px;',
        // url: "<?php CONTENT_AI_SEO_URL . 'html/part/testuser.json' ?>", // 此处为静态模拟数据，实际使用时需换成真实接口
        page: true,
        // height: '315px',
        cols: [
          [{
              type: 'checkbox',
              fixed: 'left'
            },
            {
              title: '操作',
              toolbar: '#table-operations-autoseo'
            },
            {
              field: 'id',
              title: 'ID',
            },
            {
              field: 'post_title',
              title: 'post_title',
            },
            {
              field: 'post_id',
              title: 'post_id',
            },
            {
              field: 'is_filled',
              title: 'is_filled',
            },
            {
              field: 'seo_content',
              title: 'seo_content',
            },
            {
              field: 'current_seo_content',
              title: 'current_seo_content',
              templet: function(d) {
                // 如果数据中包含 <br>，则渲染时转换为 HTML
                return d.current_seo_content;
              }
            }
          ]
        ],
        data: tdata,
      });
    })

    getjson_content_ai_seo_get_all_data()

    table.on('tool(lytablearticles)', function(obj) {
      var checkStatus = table.checkStatus('ID-table-demo-data');
      console.log(checkStatus.data); // 当前选中行
      var data = obj.data; // 当前行的数据
      var event = obj.event; // lay-event 的值
      if (event === 'editArticle') {
        // alert('编辑操作，数据为：' + JSON.stringify(data));
        // const fullUrl = geturl();
        let posturl = `/wp-admin/post.php?post=${data['post_id']}&action=edit`
        window.open(posturl, "_blank"); // "_blank" 指定在新标签页中打开

      } else if (event === 'deleteA') {
        layer.confirm('确定删除这条记录吗？', function(index) {
          // db.deletePromptByName(data.name)
          obj.del(); // 删除对应行（前端界面）
          layer.close(index);
        });
      }
    });


    // 监听复选框选中/取消事件
    // table.on('checkbox(lytablearticles)', function(obj) {
    //   var checkStatus = table.checkStatus('ID-table-articles'); // 获取选中状态
    //   console.log('选中的数据：', checkStatus.data);
    //   console.log('是否全选：', checkStatus.isAll);
    // });
  });
</script>

<script type="text/html" id="table-operations-autoseo">
  <div class="layui-clear-space">
    <a class="layui-btn layui-btn-xs" lay-event="editArticle">Edit</a>
    <a class="layui-btn layui-btn-danger layui-btn-xs" lay-event="deleteA">Delete</a>
  </div>
</script>

<style>
  #autoseopromptcontainer {
    padding: 16px;
    background: white;
  }

  #autoSEOcontainerID button {
    display: none;
  }

  #autoseopromptselect {
    margin-bottom: 10px;
  }

  #promptsetting {
    margin-bottom: 10px;
  }
</style>