<?php //一键批量生成小型专题内容
// 生成大纲，编辑大纲，查看编辑大纲生成的初步数据（如文章标题，生成文章prompt选择），执行任务
?>

<script src="<?php echo CONTENT_AI_SEO_URL . 'assets/layui.js' ?>" id="layui_js-js"></script>

<!-- //json 编辑器依赖 -->
<link rel="stylesheet" href="<?php echo CONTENT_AI_SEO_URL . 'assets/css/codemirror.min.css' ?>">
<script src="<?php echo CONTENT_AI_SEO_URL . 'assets/otherjs/codemirror.min.js' ?>" id="codemirror_min_js"></script>
<script src="<?php echo CONTENT_AI_SEO_URL . 'assets/otherjs/javascript.min.js' ?>" id="javascript_min_js"></script>

<!-- <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.12/codemirror.min.css">
<script id="codemirror-js" src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.12/codemirror.min.js"></script>
<script id="javascript-min-js" src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.12/mode/javascript/javascript.min.js"></script>
 -->

<div id="smallrapidg" class="layui-tab layui-tab-color" lay-filter="SmallTopicOutline-handle" lay-allowclose="true">
    <H3 class="function-intro">Function: Base on generated pillar topic to batch generate articles</H3>
    <ul class="layui-tab-title">
        <li class="layui-this" lay-allowclose="false">Topic Outline</li>
    </ul>
    <div class="layui-tab-content">
        <div class="layui-tab-item layui-show">
            <button lay-on="smallgenerateOutline" class="layui-btn layui-btn-warm">Generate</button>
            <button lay-on="smallregenerateOutline" class="layui-btn layui-btn-warm">Regenerate</button>
            <!-- <button lay-on="submitcronjob" class="layui-btn layui-btn-primary layui-border">Add to Tasks List</button>
            <button lay-on="batchcronjob" class="layui-btn layui-btn-primary layui-border">Batch Generate</button> -->
            <select id="smallSelectGeneratorCategory" lay-search="">
                <option value="">Select Generator Category</option>
            </select>
            <select id="smallSelectoutlineprompt" lay-search="">
                <option value="">Select outline prompt</option>
            </select>
            <span style="color: red;">Note: In the BulkJobs category, prompts can be customized within the TopicOutlineForSmall tag.</span>
            <!-- <button lay-on="applyGenerateOutline" class="layui-btn layui-btn-sm layui-btn-warm">Apply</button> -->
            <div id="small-container-prompt-outline"></div>
        </div>

    </div>
</div>


<script>
    layui.use(['table'], function() {
        var smalleditor = null
        var element = layui.element;
        var util = layui.util;
        var table = layui.table;
        var form = layui.form;
        var util = layui.util;
        var $ = layui.$;
        const db4 = new PromptDatabase();
        var smalloutlines = ['TopicOutlineForSmall']
        var smalloutlinetype = "SmallTopicOutline"
        var smallsubsectionTitles = []
        var smalloutlinegeneratorsetting = ['']
        var smallallArticlePromps = ""
        var smallpillarArticlePromp = ""
        var outlinejson = null

        const smallbeginnergenerator = ((promptname, containerID) => {
            db4.getPromptByName(promptname).then((res) => {
                let prompt = JSON.parse(res['prompt'])
                promptDomGenerator(res['prompt'], containerID, res['others'])
            })
        })

        const smallformatJSON = (() => {
            let textarea = document.getElementById("smalljsonEditor");
            try {
                let jsonObj = JSON.parse(smalleditor.getValue());
                smalleditor.setValue(JSON.stringify(jsonObj, null, 4)); // 重新格式化

            } catch (error) {}
        })

        const smallmtabchange = ((layid, title, content) => {
            if (document.querySelector(`[lay-id=\"${layid}\"]`)) {
                element.tabDelete('SmallTopicOutline-handle', layid);
            }
            element.tabAdd('SmallTopicOutline-handle', {
                title: title,
                content: content,
                id: layid, // 实际使用一般是规定好的id，这里以毫秒数模拟
                change: true // 是否添加完毕后即自动切换
            })
            element.tabChange('SmallTopicOutline-handle', layid);
        })

        const smallvalidateJSON = (() => {
            try {
                let textarea = smalleditor.getValue();
                return JSON.parse(textarea);
            } catch (error) {
                return ['error', error]
            }
        })

        const smalloutlineprompts = ((outlineprompt) => {
            db4.getAllPromptByTag(outlineprompt).then(response => {


                    let dataSource = []
                    response.forEach((ele, key) => {
                        dataSource.push({
                            value: ele['name']
                        })
                    });
                    // 获取目标 select 元素
                    let selectElement = document.getElementById('smallSelectoutlineprompt');
                    // 调用函数填充选项
                    populateOptionsFromArray2(dataSource, selectElement);
                    // 监听 select 的 change 事件
                    selectElement.addEventListener("change", async (event) => {
                        let selectedValue = event.target.value;
                        let containerID = 'small-container-prompt-outline'
                        smallbeginnergenerator(selectedValue, containerID)
                    });
                })
                .catch(error => {
                    console.error(error);
                })
        })

        const smalljobstart = (() => {

            let containerID = 'small-container-prompt-outline'
            let promptname = 'basic small topic outline generator'
            smallbeginnergenerator(promptname, containerID)

            let dataSource = []
            smalloutlines.forEach((ele, key) => {
                dataSource.push({
                    value: ele
                })
            });
            // 获取目标 select 元素
            let selectElement = document.getElementById('smallSelectGeneratorCategory');
            populateOptionsFromArray2(dataSource, selectElement);
            selectElement.addEventListener("change", async (event) => {
                let selectedValue = event.target.value;
                smalloutlinetype = selectedValue
                smalloutlineprompts(selectedValue)
            })
        })


        smalljobstart()

        util.on('lay-on', {
            smallgenerateOutline: async function(othis) {
                let createContentInput = getAllValueInput('small-container-prompt-outline')
                let prompt = promptGenerator(createContentInput)

                // smalloutline = localStorage.getItem('smalloutline')
                let result = await mergePromptBookTocSendContinue(prompt, more = '000', jsonformat = '11', jsonSchema = JSON.stringify(jsonSchema2))
                smalloutline = result['dataresult']
                localStorage.setItem('smalloutline', smalloutline)


                let layid = '22'
                let content = `<button lay-on="smallgenerateOutlineSetting" class="layui-btn layui-btn-warm">Go on Generate</button><button lay-on="smallformatJSON" class="layui-btn layui-btn-warm">Format JSON</button>
                <textarea id="smalljsonEditor">${smalloutline}</textarea>`
                let title = '2.Edit Topic Outline'

                smallmtabchange(layid, title, content)

                smalleditor = CodeMirror.fromTextArea(document.getElementById("smalljsonEditor"), {
                    mode: "application/json",
                    theme: "default",
                    lineNumbers: true,
                    matchBrackets: true,
                    autoCloseBrackets: true,

                });
                smalleditor.setSize("100%", "100%");
                // 强制刷新 CodeMirror，解决初始化时不显示内容的问题
                setTimeout(function() {
                    smalleditor.refresh();
                }, 100);
                smallformatJSON()

            },
            smallgenerateOutlineSetting: async function(othis) {
                // if (document.querySelector("[lay-id=\"3\"]")) {
                //     element.tabDelete('SmallTopicOutline-handle', '3');
                // }
                outlinejson = smallvalidateJSON()
                if (outlinejson[0] == "error") {
                    alert(`outline json format error,${outlinejson[1]},please check`)
                    return
                }

                let noteforcustomized1 = `<span style="color:red;">Note: In the "BulkJobs" category, the article prompts can be customized within the "ArticleGeneratorBasic" tag.</span>`
                let noteforcustomized2 = `<br><span style="color:red;">the pillar article prompts can be customized within the "ArticleGeneratorFromOutlineForPillar" tag.</span>`


                let layid = '33'
                let content = `<button lay-on="smallSettingNext" class="layui-btn layui-btn-warm">Go on Generate</button><div id="smallgeneratorSetting"></div>${noteforcustomized1}${noteforcustomized2}`
                let title = '3.Setting'
                smallmtabchange(layid, title, content)

                let settingarr = []
                let promptsOption = await db4.getAllPromptByTag('ArticleGeneratorFromOutlineForPillar')
                let promptnames = ""
                promptsOption.forEach(ele => {
                    promptnames = promptnames + ele.name + ','
                });
                let basicpromptsOption = await db4.getAllPromptByTag('ArticleGeneratorBasic')
                let basicpromptnames = ""
                basicpromptsOption.forEach(ele => {
                    basicpromptnames = basicpromptnames + ele.name + ','
                });

                const categoriesChoice = contentAISEOAdmin.categories.map(item => `${item.id}-${item.name}`).join(',');

                settingarr.push({
                    'title': 'articles category(required)',
                    'content': `#${categoriesChoice}#`
                })
                settingarr.push({
                    'title': 'articles tag(required)',
                    'content': ''
                })
                settingarr.push({
                    'title': 'all relate articles generating prompt',
                    'content': `#${basicpromptnames}#`
                })
                settingarr.push({
                    'title': 'pillar topic generating prompt',
                    'content': `#${promptnames}#`
                })

                let containerID = 'smallgeneratorSetting'
                settingarr = JSON.stringify(settingarr)
                promptDomGenerator(settingarr, containerID)

            },
            smallSettingNext: function(othis) {
                let layid = '44'
                let content = `<button lay-on="smallGenerateallarticles" class="layui-btn layui-btn-warm">Generate All Relate Articles</button><button lay-on="smallpillarprompt" class="layui-btn layui-btn-warm">Pillar articles generating prompt setting</button><button id="smallSettingAllprompt" lay-on="smallSettingAllprompt" class="layui-btn layui-btn-warm">All articles generating prompt setting</button><div id="allarticleprompts"></div><div id="pillararticleprompts"></div>
                <button id="deleteBtn11" class="layui-btn layui-btn-danger">Bulk Delete</button><table lay-filter="smallpstabletoolbar" class="layui-hide" id="ID-table-prompt-setting-small"></table>`
                let title = '4.Prompt Setting'
                smallmtabchange(layid, title, content)

                smalloutlinegeneratorsetting = getAllValueInput('smallgeneratorSetting')
                //转化成字典
                smalloutlinegeneratorsetting = smalloutlinegeneratorsetting.reduce((acc, item) => {
                    acc[item.title] = item.content;
                    return acc;
                }, {});

                smallsubsectionTitles = outlinejson['related_article_titles']

                var tdata = []
                smallsubsectionTitles.forEach((ele, key) => {
                    let m = {
                        'id': key,
                        "name": ele,
                        "status": 'ready',
                        "prompt": smalloutlinegeneratorsetting['all relate articles generating prompt'],
                        "promptcontent": ""
                    }
                    tdata.push(m)

                });
                var inst = table.render({
                    elem: '#ID-table-prompt-setting-small',
                    cols: [
                        [ //标题栏

                            {
                                type: 'checkbox'
                            },
                            {
                                title: 'Action',
                                width: 200,
                                toolbar: '#small-table-operations-ps'
                            },
                            {
                                field: 'id',
                                title: 'id',
                                width: 50
                            },
                            {
                                field: 'name',
                                title: 'name',
                                width: 300
                            },
                            {
                                field: 'status',
                                title: 'status',
                                width: 80
                            },
                            {
                                field: 'prompt',
                                title: 'prompt',
                                width: 120
                            },
                            {
                                field: 'promptcontent',
                                title: 'promptcontent',
                                minwidth: 200
                            },
                        ]
                    ],
                    data: tdata,
                    page: true, // 是否显示分页
                    limit: 30 // 每页默认显示的数量
                });

                table.on('tool(smallpstabletoolbar)', function(obj) {

                    var data = obj.data; // 当前行的数据
                    var event = obj.event; // lay-event 的值
                    if (event === 'smalledit') {

                        layer.open({
                            type: 1, // page 层类型
                            area: ['960px', '400px'],
                            title: 'Info',
                            shade: 0, // 遮罩透明度
                            maxmin: true, // 允许全屏最小化
                            anim: 0, // 0-6 的动画形式，-1 不开启
                            content: '<div id="smallchoosepromptlayer" style="padding: 32px;"><h3>Selecting a new template:</h3></div>'
                        });

                        db4.getTagsByName('ArticleGeneratorBasic').then((res) => {
                            res.forEach(ele => {
                                db4.getAllPromptByTag(ele).then((res1) => {
                                    $('#smallchoosepromptlayer').append(`<blockquote class="layui-elem-quote layui-text">Tag: ${ele} </blockquote>`)
                                    var btnGroupContainer = $(`<div class="layui-btn-container"></div>`);
                                    res1.forEach(ele1 => {
                                        var btn = $('<button type="button" class="layui-btn layui-btn-sm"></button>').text(ele1['name']);
                                        btn.on('click', function() {
                                            atip('use prompt template :' + ele1['name'], btn)
                                            layer.open({
                                                title: "Setting",
                                                type: 1,
                                                offset: 'l',
                                                anim: 'slideRight', // 从右往左
                                                content: `<div id="container102"><button id="smallsettingSinglepromptconfirm" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Confirm</button><button lay-on="quickpromptpartrapid5" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Prompt part</button><button lay-on="quickpromptemptyrapid5" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Empty Part</button><div id="smallsettingSinglepromptcontainer"></div></div>`,
                                                area: ['480px', '100%'], // 初始宽高
                                                maxmin: true,
                                                shade: 0,
                                                // shadeClose: true,
                                                success: function(layero, index) {
                                                    db4.getPromptByName(ele1['name']).then((res) => {

                                                        promptDomGenerator(res['prompt'], 'smallsettingSinglepromptcontainer')
                                                    })
                                                    $("#smallsettingSinglepromptconfirm").on('click', function() {
                                                        let createContentInput = getAllValueInput('smallsettingSinglepromptcontainer')
                                                        let singleArticlePrompt = promptGenerator(createContentInput)

                                                        obj.update({
                                                            prompt: ele1['name'],
                                                            promptcontent: singleArticlePrompt
                                                        });
                                                        layer.close(index)

                                                    })
                                                }
                                            });
                                        });
                                        // btn.on('mouseenter', function() {
                                        //     let prompt = JSON.parse(ele1['prompt'])
                                        //     prompt = promptGenerator(prompt)
                                        //     layer.tips(prompt, btn, {
                                        //         tips: [1, '#00FF00'], // 提示框位置：[位置, 颜色]
                                        //         time: 8000 // 提示框自动关闭时间，单位是毫秒
                                        //     });
                                        // });
                                        // btn.on('mouseleave', function() {
                                        //     layer.closeAll('tips'); // 关闭所有tips
                                        // });
                                        btnGroupContainer.append(btn);
                                    });
                                    $('#smallchoosepromptlayer').append(btnGroupContainer);
                                })

                            });
                        })
                    }
                });

                $('#deleteBtn11').on('click', function() {
                    // 获取所有选中的行
                    var checkStatus = table.checkStatus('ID-table-prompt-setting-small');
                    var data = checkStatus.data; // 获取选中的行数据

                    if (data.length === 0) {
                        layer.msg('Please select the data to be deleted');
                        return;
                    }

                    // 删除选中的数据
                    layer.confirm('Sure you want to delete the selected data?', {
                        icon: 3,
                        title: 'Tips'
                    }, function(index) {
                        // 模拟删除操作：从 tableData 中移除选中的数据
                        tdata = tdata.filter(item => !data.some(d => d.name === item.name));

                        // 刷新表格数据
                        table.reload('ID-table-prompt-setting-small', {
                            data: tdata
                        });

                        layer.msg('delete successful');
                        layer.close(index);
                    });
                });


            },
            smallGenerateallarticles: async function(othis) {
                var tableData = table.cache['ID-table-prompt-setting-small']; // 'myTable' 是 table 的 id
                let cate_id = smalloutlinegeneratorsetting['articles category(required)'].split('-')
                let tag = smalloutlinegeneratorsetting['articles tag(required)']
                let savePostsSetting = {
                    Tags: tag,
                    category: cate_id[0],
                    StatusVisibility: 'Draft'
                }

                for (const ele of tableData) {
                    savePostsSetting['posttime'] = getCurrentFormattedDate(hour = parseInt(ele['id']))

                    let prompt = ''
                    if (ele['promptcontent'] == "") {
                        prompt = smallallArticlePromps
                    } else {
                        prompt = ele['promptcontent']
                    }

                    if (prompt == "") {
                        alert('Please set prompt first')
                        setFocusAndHighlight('smallSettingAllprompt')
                        return
                    }

                    let finalprompt = `Article Title:${ele['name']}<br>${prompt}`

                    let result = null
                    let result_ = await mergePromptSend(prompt = finalprompt, save = savePostsSetting, returncounts = 1, jsonformat = '11')
                    result = result_['dataresult']

                    //保存生成文章记录
                    let recordgenerating = result_['respond']
                    //记录到任务列表当作
                    let db = new PromptDatabase();
                    let postid = recordgenerating['post_id']
                    let title = recordgenerating['article_title']
                    let bywho = contentAISEOAdmin.usr

                    const jobId = await db.addJobLog({
                        product_by_who: bywho,
                        post_id: postid,
                        post_title: title,
                        post_time: new Date().toISOString()
                    });

                    modifybulkTableCell(tdata = tableData, itemid = ele['id'], finishstatus = 'complete', tableid = 'ID-table-prompt-setting-small')

                
                }

            },
            smallformatJSON: function(othis) {
                smallformatJSON()
            },
            quickpromptpartrapid3: function(othis) {
                quickpromptpartfunction('smallsettingallpromptcontainer', 'r')
            },
            quickpromptemptyrapid3: function(othis) {

                addcomponet({
                    'title': 'label',
                    'content': 'content'
                }, 'smallsettingallpromptcontainer')
            },
            quickpromptpartrapid4: function(othis) {
                quickpromptpartfunction('smallpillarpromptcontainer', 'r')
            },
            quickpromptemptyrapid4: function(othis) {

                addcomponet({
                    'title': 'label',
                    'content': 'content'
                }, 'smallpillarpromptcontainer')
            },
            quickpromptpartrapid5: function(othis) {
                quickpromptpartfunction('smallsettingSinglepromptcontainer', 'r')
            },
            quickpromptemptyrapid5: function(othis) {

                addcomponet({
                    'title': 'label',
                    'content': 'content'
                }, 'smallsettingSinglepromptcontainer')
            },
            smallSettingAllprompt: function(othis) {
                layer.open({
                    title: "Setting",
                    type: 1,
                    offset: 'l',
                    anim: 'slideRight', // 从右往左
                    content: `<div id="container102"><button id="smallsettingallpromptconfirm" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Confirm</button><button lay-on="quickpromptpartrapid3" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Prompt part</button><button lay-on="quickpromptemptyrapid3" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Empty Part</button><div id="smallsettingallpromptcontainer"></div></div>`,
                    area: ['480px', '100%'], // 初始宽高
                    maxmin: true,
                    shade: 0.1,
                    // shadeClose: true,
                    success: function(layero, index) {
                        db4.getPromptByName(smalloutlinegeneratorsetting['all relate articles generating prompt']).then((res) => {

                            promptDomGenerator(res['prompt'], 'smallsettingallpromptcontainer')
                        })

                        $('#smallsettingallpromptconfirm').on('click', function() {
                            let createContentInput = getAllValueInput('smallsettingallpromptcontainer')
                            smallallArticlePromps = promptGenerator(createContentInput)
                            document.querySelector("#allarticleprompts").innerHTML = `<h3>All Articles Prompt</h3>${smallallArticlePromps}`

                            layer.close(index)
                        })
                    }
                });
            },
            smallpillarprompt: function(othis) {
                layer.open({
                    title: "Setting",
                    type: 1,
                    offset: 'l',
                    anim: 'slideRight', // 从右往左
                    content: `<div id="container102"><button id="smallpillarpromptconfirm" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Start</button><button lay-on="quickpromptpartrapid4" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Prompt part</button><button lay-on="quickpromptemptyrapid4" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Empty Part</button><div id="smallpillarpromptcontainer"></div></div>`,
                    area: ['480px', '100%'], // 初始宽高
                    maxmin: true,
                    shade: 0.1,
                    // shadeClose: true,
                    success: function(layero, index) {
                        db4.getPromptByName(smalloutlinegeneratorsetting['pillar topic generating prompt']).then((res) => {

                            promptDomGenerator(res['prompt'], 'smallpillarpromptcontainer')
                        })

                        $('#smallpillarpromptconfirm').on('click', async function() {
                            let createContentInput = getAllValueInput('smallpillarpromptcontainer')
                            smallpillarArticlePromp = promptGenerator(createContentInput)

                            let cate_id = smalloutlinegeneratorsetting['articles category(required)'].split('-')
                            let tag = smalloutlinegeneratorsetting['articles tag(required)']
                            let savePostsSetting = {
                                Tags: tag,
                                category: cate_id[0],
                                StatusVisibility: 'Draft'
                            }
                            savePostsSetting['posttime'] = getCurrentFormattedDate(hour = -4)

                            let finalprompt = `${smallpillarArticlePromp}Content Structure:${JSON.stringify(outlinejson)};<br>`
                            let result = await mergePromptSend(prompt = finalprompt, save = savePostsSetting, returncounts = 1, jsonformat = '11')

                            //保存生成文章记录
                            let recordgenerating = result['respond']
                            //记录到任务列表当作
                            let db = new PromptDatabase();
                            let postid = recordgenerating['post_id']
                            let title = recordgenerating['article_title']
                            let bywho = contentAISEOAdmin.usr

                            const jobId = await db.addJobLog({
                                product_by_who: bywho,
                                post_id: postid,
                                post_title: title,
                                post_time: new Date().toISOString()
                            });

                            // document.querySelector("#pillararticleprompts").innerHTML = `<h3>Pillar Articles Prompt</h3>${smallpillarArticlePromp}`
                            alert('Done')
                            // layer.close(index)
                        })
                    }
                });
            }
        })
    });

    var jsonSchema2 = {
        "$schema": "http://json-schema.org/draft-07/schema#",
        "title": "Meta Quest 2 Article Schema",
        "type": "object",
        "properties": {
            "title": {
                "type": "string",
                "description": "Article title"
            },
            "SEO_description": {
                "type": "string",
                "description": "SEO meta description"
            },
            "SEO_relate_keywords": {
                "type": "array",
                "description": "Related SEO keywords",
                "items": {
                    "type": "string"
                }
            },
            "outline": {
                "type": "array",
                "description": "Article outline",
                "items": {
                    "type": "string"
                }
            },
            "related_article_titles": {
                "type": "array",
                "description": "List of related article titles",
                "items": {
                    "type": "string"
                }
            }
        },
        "required": [
            "title",
            "SEO_description",
            "SEO_relate_keywords",
            "outline",
            "related_article_titles"
        ],
        "additionalProperties": false
    }


    var smalloutline = {
        "title": "Meta Quest 2: Best Features, Reviews, and Buying Guide",
        "SEO_description": "Explore the best features, reviews, and buying guide for Meta Quest 2 VR headset. Discover everything about Meta Quest 2, including performance, price, and user feedback.",
        "SEO_relate_keywords": [
            "Meta Quest 2 review",
            "Meta Quest 2 price",
            "Meta Quest 2 features",
            "Meta Quest 2 vs Oculus Quest 2",
            "Meta Quest 2 performance",
            "Meta Quest 2 battery life",
            "Meta Quest 2 compatibility",
            "Meta Quest 2 accessories",
            "Meta Quest 2 vs PS VR",
            "Meta Quest 2 gaming",
            "Meta Quest 2 reviews",
            "Meta Quest 2 setup",
            "Meta Quest 2 buying guide"
        ],
        "outline": [
            "Introduction: What is Meta Quest 2 and why it’s one of the best VR headsets?",
            "Meta Quest 2 Features: Key Highlights You Need to Know",
            "Performance Review: How Does Meta Quest 2 Compare to Other VR Headsets?",
            "Meta Quest 2 vs Oculus Quest 2: What’s the Real Difference?",
            "Meta Quest 2 Battery Life: How Long Can You Play Before Charging?",
            "Meta Quest 2 Compatibility: Which Games and Apps Work Best?",
            "Best Accessories for Meta Quest 2: Enhance Your VR Experience",
            "Meta Quest 2 Setup: A Step-by-Step Guide for Beginners",
            "Meta Quest 2 vs PS VR: Which VR Headset is Best for You?",
            "Meta Quest 2 Price: Is it Worth the Investment?",
            "User Reviews: What Are People Saying About Meta Quest 2?",
            "Conclusion: Should You Buy Meta Quest 2 in 2025?"
        ],
        "related_article_titles": [
            "Meta Quest 2 Review: The Ultimate Virtual Reality Experience",
            "Meta Quest 2 vs Oculus Quest 2: Which VR Headset Should You Choose?",
            "How to Set Up Your Meta Quest 2 VR Headset: A Beginner’s Guide",
            "Best Accessories for Meta Quest 2: Enhance Your VR Gameplay",
            "Meta Quest 2 Battery Life: How Long Does it Really Last?",
            "Meta Quest 2 Price Breakdown: Is It Worth the Money?",
            "Meta Quest 2 vs PS VR: A Comprehensive Comparison for Gamers",
            "Meta Quest 2 Performance: How Fast and Smooth is the Gameplay?",
            "Top Games to Play on Meta Quest 2: Must-Have Titles",
            "Is Meta Quest 2 Compatible with Other VR Apps and Systems?",
            "User Reviews of Meta Quest 2: The Pros and Cons",
            "Meta Quest 2 Setup Guide: Get Started with Your VR Adventure"
        ]
    }


    function populateOptionsFromArray2(res, target) {
        target.innerHTML = '<option value="">Select outline prompt</option>';

        let data = []
        res.forEach((ele, key) => {
            data.push({
                value: ele['value'],
                text: ele['value']
            })
        });

        // 遍历数组并创建选项
        data.forEach(item => {
            const option = document.createElement('option');
            option.value = item.value;
            option.textContent = item.text;
            target.appendChild(option);
        });

        orderaz(target.id)
    }
</script>

<script type="text/html" id="table-operations-rg">
    <div class="layui-clear-space">
        <a class="layui-btn layui-btn-danger layui-btn-xs" lay-event="deletedraf">Delete</a>
        <a class="layui-btn layui-btn-danger layui-btn-xs" lay-event="chooseprompt">Choose_Prompt</a>
    </div>
</script>

<script type="text/html" id="small-table-operations-ps">
    <div class="layui-clear-space">
        <a title="edit" class="layui-btn layui-btn-xs" lay-event="smalledit" ">EditPromptTemplate</a>
    </div>
</script>

<style>
    #smallchoosepromptlayer h3 {
        margin-bottom: 10px;
    }

    .layui-table-body {
        overflow: hidden;
    }

    @media (min-width: 550px) {
        .layui-form-item .layui-inline {
            text-align: left !important;
            width: 600px;
        }
    }

    @media (max-width: 549px) {
        .layui-form-item .layui-inline {
            text-align: left !important;
            width: 400px;
        }

        .layui-form-item .layui-input-inline {

            width: 100px !important;

        }
    }

    .layui-tab-color {
        background-color: white;

    }

    .layui-tab-color .layui-tab-content {

        margin: 10px;
    }

    #smalljsonEditor {
        margin-top: 10px;
        width: 100%;
        height: 600px;
        font-family: monospace;
    }

    #small-container-prompt-outline button[lay-on="dispalytop"] {
        display: none !important;
    }

    #smallrapidg input {
        text-transform: capitalize;
    }

    #smallgeneratorSetting .layui-card-body button {
        display: none;
    }

    .layui-tab-close {
        display: none !important;
    }

    #smallsettingallpromptcontainer button.dispalytopcss {
        display: none;
    }

    #smallsettingSinglepromptcontainer button.dispalytopcss {
        display: none;
    }

    #container102 {
        padding: 22px;
    }

    #allarticleprompts {
        padding: 12px;
    }

    #pillararticleprompts {
        padding: 12px;
    }
</style>