<?php

/** 自定义prompts */
?>


<script>
    function addcomponetprompt(inputvalue) {
        // 定位元素
        const displayTopSpan = document.getElementById('nowdisplaytop');
        // 检查元素是否存在并隐藏
        if (displayTopSpan) {
            displayTopSpan.style.display = 'none';
        }
        const source = document.getElementById('tarea');
        const container = document.getElementById('container');
        const clonedNode = source.cloneNode(true);
        // 给克隆的节点添加一个唯一标识，避免 ID 冲突
        clonedNode.id = `cloned-${generateRandomString(8)}`;
        clonedNode.querySelector("button").setAttribute("container", clonedNode.id);
        // 将克隆的节点追加到容器中
        // container.appendChild(clonedNode);
        container.insertBefore(clonedNode, container.firstChild);
        if (inputvalue) {
            clonedNode.querySelector("input").value = inputvalue['title']
            clonedNode.querySelector("textarea").value = inputvalue['content']
        }
    }

    const quickpromptpartfunction = ((containerID, offset) => {
        let db = new PromptDatabase();
        layer.open({
            title: 'Info',
            type: 1,
            content: `<?php $static_file = MY_PLUGIN_PATH . 'html/part/quick-prompt.php';
                        include $static_file; ?>`,
            // offset: 'b',
            // anim: 'slideUp', // 从下往上
            // area: ['100%', '320px'],
            // offset: 'l',
            // anim: 'slideRight', // 从左往右
            offset: offset ?? 'r',
            anim: 'slideLeft', // 从右往左
            area: ['50%', '100%'],
            maxmin: true,
            shade: 0.1,
            shadeClose: true,
            success: function(layero, index) {
                // layer.full(index); // 最大化
                let searchF3 = document.getElementById("searchF3")
                searchF3.addEventListener('click', function() {
                    // triggerBrowserSearch()
                    alert("Please use Ctrl + F (Windows) or Cmd + F (Mac) to open the search box");
                })

                let selectElement = [];
                selectElement.push(document.getElementById('yuqiSelect'));
                selectElement.push(document.getElementById('languageSelect'));
                selectElement.push(document.getElementById('LexicalChoices'));
                selectElement.push(document.getElementById('WritingVoice'));
                selectElement.push(document.getElementById('WritingPacing'));
                selectElement.push(document.getElementById('TargetReaders'));
                selectElement.push(document.getElementById('WritingCohesionandCoherence'));
                selectElement.push(document.getElementById('WritingArgumentation'));
                selectElement.push(document.getElementById('WritingGrammarandSyntax'));
                selectElement.push(document.getElementById('KeywordsSelect'));
                selectElement.push(document.getElementById('SEOKeywordsSelect'));
                selectElement.push(document.getElementById('marketresearch'));
                selectElement.push(document.getElementById('TrendSelect'));
                selectElement.push(document.getElementById('DescriptionSelect'));
                selectElement.push(document.getElementById('TitleSelect'));
                selectElement.push(document.getElementById('returnformat'));
                selectElement.push(document.getElementById('contentsnippet'));
                selectElement.push(document.getElementById('writingstructures'));
                selectElement.push(document.getElementById('typeofreview'));
                selectElement.push(document.getElementById('typesoftone'));
                selectElement.push(document.getElementById('mindmaps'));
                selectElement.push(document.getElementById('outline'));
                selectElement.push(document.getElementById('commonarticle'));
                selectElement.push(document.getElementById('topics'));
                selectElement.push(document.getElementById('Typesofdescriptions'));
                selectElement.push(document.getElementById('emotions'));
                selectElement.push(document.getElementById('typesofterminology'));
                selectElement.push(document.getElementById('Intent'));
                selectElement.push(document.getElementById('role'));
                selectElement.push(document.getElementById('country'));
                selectElement.push(document.getElementById('websitewritestyle'));
                selectElement.push(document.getElementById('rewritearticle'));
                selectElement.push(document.getElementById('modifiedcontent'));
                // selectElement.push(document.getElementById('seosnippets'));
                selectElement.push(document.getElementById('copywriter'));
                selectElement.push(document.getElementById('slogan'));
                selectElement.push(document.getElementById('pressrelease'));
                selectElement.push(document.getElementById('WritingStructurePrompts'));
                selectElement.push(document.getElementById('WritingGeneratecontentprompts'));
                selectElement.push(document.getElementById('WritingSEOPrompts'));
                selectElement.push(document.getElementById('WritingStyleAdjustmentsPrompts'));
                selectElement.push(document.getElementById('WritingGeneralContentOptimizationPrompts'));
                selectElement.push(document.getElementById('WritingContentExpansionPrompts'));
                selectElement.push(document.getElementById('WritingAudienceSpecificCustomizationPrompts'));
                selectElement.push(document.getElementById('WritingGrammarSpellingCorrectionPrompts'));
                selectElement.push(document.getElementById('WritingProfessionalfieldcontentPrompts'));
                selectElement.push(document.getElementById('contentcreation'));
                selectElement.push(document.getElementById('business'));
                selectElement.push(document.getElementById('marketing'));
                selectElement.push(document.getElementById('writer'));
                selectElement.push(document.getElementById('imagegenerator'));
                selectElement.push(document.getElementById('humourous'));
                // selectElement.push(document.getElementById('thinking'));
                selectElement.push(document.getElementById('emotions'));
                selectElement.push(document.getElementById('experiences'));
                selectElement.push(document.getElementById('story'));
                selectElement.push(document.getElementById('novels'));
                selectElement.push(document.getElementById('pressreleases'));
                selectElement.push(document.getElementById('blogpost'));
                selectElement.push(document.getElementById('poetry'));
                selectElement.push(document.getElementById('Englishproficiencylevels'));
                selectElement.push(document.getElementById('English'));
                selectElement.push(document.getElementById('QAWritingStructure'));
                selectElement.push(document.getElementById('reviews'));
                selectElement.push(document.getElementById('news'));
                selectElement.push(document.getElementById('argumentativeessays'));
                selectElement.push(document.getElementById('narrativeessays'));
                selectElement.push(document.getElementById('expositoryessay'));
                selectElement.push(document.getElementById('biographies'));
                selectElement.push(document.getElementById('humanize'));
                selectElement.push(document.getElementById('dialogue'));
                selectElement.push(document.getElementById('letter'));
                selectElement.push(document.getElementById('videoscript'));
                selectElement.push(document.getElementById('productdetailpages'));
                selectElement.push(document.getElementById('screenplay'));
                selectElement.push(document.getElementById('gamescripts'));
                selectElement.push(document.getElementById('Viewpoints'));
                selectElement.push(document.getElementById('MainSEOArticleTypes'));
                selectElement.push(document.getElementById('ProductArticle'));
                selectElement.push(document.getElementById('LegalArticle'));
                selectElement.push(document.getElementById('BookTableofContents'));
                selectElement.push(document.getElementById('BrandArticle'));
                selectElement.push(document.getElementById('Outlinelite'));
                selectElement.push(document.getElementById('SEOusefulprompt'));
                selectElement.push(document.getElementById('wikis'));
                selectElement.push(document.getElementById('PrettyArticle1'));
                selectElement.push(document.getElementById('PrettyArticle2'));
                selectElement.push(document.getElementById('Contentconversion'));
                selectElement.forEach(ele => {
                    removeDuplicateOptions(ele);
                    const value = ele.getAttribute("data-");
                    if (ele.getElementsByTagName('optgroup').length == 0) {
                        orderaz(ele.id)
                    }
                });

                //确保在页面中正确加载了 layui 的 JS 和 CSS，并且初始化了 form 组件
                layui.use('form', function() {
                    var form = layui.form;
                    var table = layui.table;
                    // 渲染表单
                    // form.render('select');
                    form.render(layero.find('.layui-form select'));
                    form.on('select', function(data) {
                        var elem = data.elem; // 获取当前的 select 元素
                        let title = elem.getAttribute("data-");
                        let id = elem.id;
                        var selectedValue = data.value; // 获取选中的值

                        if (selectedValue !== "copyalllist") {
                            if (containerID != "container") {
                                addcomponet({
                                    'title': title,
                                    'content': selectedValue
                                }, containerID)
                            } else {
                                addcomponetprompt({
                                    'title': title,
                                    'content': selectedValue
                                }, containerID)
                            }
                        } else {
                            const select = document.getElementById(id);
                            const options = Array.from(select.options)
                                .map(option => option.value)
                                .filter(value => !["novalue", "copyalllist"].includes(value)); // 过滤掉指定的值

                            const result = options.join(",");
                            // 复制到剪贴板
                            navigator.clipboard.writeText(result).then(() => {
                                alert('all list copied')
                            }).catch(err => {
                                alert('copy failed')
                            });
                        }
                    });

                    db.getAllPromptParts().then((res) => {

                        loadatatotablecustompromptpart(table, res)
                    })

                    db.getPromptPartsByCategory('your_1').then((res) => {

                        generatorcustom(res, 'your_1', layero)

                    })
                    db.getPromptPartsByCategory('your_2').then((res) => {

                        generatorcustom(res, 'your_2', layero)
                    })
                });

            }
        });
    })

    document.addEventListener('DOMContentLoaded', function() {
        var promptext = ''
        var util = layui.util;
        layui.use(function() {
            util.on('lay-on', {
                test: function(othis) {
                    layer.tips('t', this, {
                        tips: 1
                    });
                    let arr = []
                    let createContentInput = getAllValueInput('container')
                    // promptext = promptGenerator(createContentInput)
                    layer.open({
                        type: 1,
                        offset: 'l',
                        anim: 'slideRight', // 从右往左
                        content: `<?php $static_file = MY_PLUGIN_PATH . 'html/part/test-prompt.php';
                                    include $static_file; ?>`,
                        area: ['320px', '100%'], // 初始宽高
                        maxmin: true,
                        shade: 0.1,
                        // shadeClose: true,
                        success: function(layero, index) {
                            // layer.full(index); // 最大化
                            let testcontainerid = 'test_prompt_text_show'
                            let createContentInput_ = JSON.stringify(createContentInput)
                            promptDomGenerator(createContentInput_, testcontainerid)
                            // document.getElementById("test-prompt-text").innerText = promptext;

                        }
                    });

                },
                taketest: function(othis) {
                    let createContentInput = getAllValueInput('test_prompt_text_show')
                    promptext = promptGenerator(createContentInput)
                    // promptext = promptGeneratorForPostUpload(createContentInput)
                    document.getElementById("test-prompt-text").innerHTML = promptext;

                },
                copytest: function(othis) {
                    let textprompt = document.getElementById("test-prompt-text")
                    navigator.clipboard.writeText(textprompt.innerText).then(() => {
                            layer.tips('copied', this, {
                                tips: 1
                            });
                        })
                        .catch(err => {
                            layer.tips('copy failed', this, {
                                tips: 1
                            });
                        });

                },
                excutest: async function(othis) {

                    let airesponse = null
                    let result = await mergePromptSend(promptext)
                    airesponse = result['dataresult']
                    marked.setOptions({
                        gfm: true, // 启用 GitHub 风格 Markdown
                        breaks: true, // 将单换行视为段落换行
                        headerIds: false, // 禁用标题的 ID
                        mangle: false // 禁用自动转义
                    });

                    markdownContent = airesponse
                    const htmlContent = marked.parse(markdownContent);
                    document.getElementById('view-output').innerHTML = htmlContent;
                    document.getElementById('html-output').textContent = htmlContent;
                    document.getElementById('md-output').textContent = markdownContent;
                }
            })
        })
    })
</script>

<body>
    <h1></h1>
    <div class="layui-panel">
        <div class="taskstatus" id="taskstatus"></div>
        <div class="taskstatus" id="plantaskstatus"></div>
    </div>
    <div class="layui-tab">
        <ul class="layui-tab-title">
            <li>prompts generator</li>
            <li class="layui-this">content center</li>
            <li>AutoSEO</li>
            <li>Topic Contents Auto Robot</li>
            <li>Small Topic Contents rapid Generator </li>
            <li>Jobs Logs</li>
            <li>Setting</li>
            <li lay-on="aichats">AI Chats</li>
            <li lay-on="RefreshPD">Refresh Page Data</li>
        </ul>
        <div class="layui-tab-content">
            <div id="promptcontainer" class="layui-tab-item">
                <div class="layui-bg-gray" style="padding: 16px;">
                    <div class="layui-row layui-col-space15">
                        <div class="layui-col-md3">
                            <div class="layui-card">
                                <div class="layui-card-header">
                                    <h3>Customizing Prompts</h3>
                                </div>
                                <div class="layui-card-body">
                                    <h4>Fliter</h4><br>
                                    <div class="layui-input-group">
                                        <input id="searchpromptinput" type="text" placeholder="by name" class="layui-input">
                                        <div lay-on="searchprompt" class="layui-input-split layui-input-suffix" style="cursor: pointer;">
                                            <i class="layui-icon layui-icon-search"></i>
                                        </div>
                                        <div lay-on="restsearch" class="layui-input-split layui-input-suffix" style="cursor: pointer;">
                                            <i class="layui-icon layui-icon-refresh"></i>
                                        </div>
                                    </div>
                                    <div class="layui-input-group">
                                        <input id="searchpromptinputag" type="text" placeholder="by tag" class="layui-input">
                                        <div lay-on="searchpromptag" class="layui-input-split layui-input-suffix" style="cursor: pointer;">
                                            <i class="layui-icon layui-icon-search"></i>
                                        </div>
                                        <div lay-on="restsearch" class="layui-input-split layui-input-suffix" style="cursor: pointer;">
                                            <i class="layui-icon layui-icon-refresh"></i>
                                        </div>
                                    </div>
                                    <div class="layui-input-group">
                                        <input id="searchpromptinputcate" type="text" placeholder="by category" class="layui-input">
                                        <div lay-on="searchpromptcate" class="layui-input-split layui-input-suffix" style="cursor: pointer;">
                                            <i class="layui-icon layui-icon-search"></i>
                                        </div>
                                        <div lay-on="restsearch" class="layui-input-split layui-input-suffix" style="cursor: pointer;">
                                            <i class="layui-icon layui-icon-refresh"></i>
                                        </div>
                                    </div>
                                    <div class="layui-col-md12">
                                        <div class="select-c">
                                            <h4>Tag:</h4>
                                            <select style="width: 200px;" id="tagSelect" lay-search="">
                                                <!-- <option value="">Select Tag</option> -->
                                            </select>
                                            <button title="delete the entire tag, all prompts of this tag will be deleted " lay-on="deletetag" type="button" class="layui-btn layui-btn-sm layui-btn-primary">
                                                <i class="layui-icon layui-icon-delete"></i>
                                            </button>
                                            <button title="Bulk add a prompt part to the prompts that have same the tag" lay-on="bulkaddpromttosametag" type="button" class="layui-btn layui-btn-sm layui-btn-primary">
                                                <i class="layui-icon layui-icon-add-circle"></i>
                                            </button>
                                        </div>
                                        <div class="select-c">
                                            <h4>Category:</h4>
                                            <select style="width: 200px;" id="cateSelect" lay-search="">
                                                <option value="">Select Category</option>
                                            </select>
                                            <!-- <button lay-on="deletecate" type="button" class="layui-btn layui-btn-sm layui-btn-primary">
                                                <i class="layui-icon layui-icon-delete"></i>
                                            </button> -->
                                        </div>

                                    </div>
                                    <hr class="ws-space-8">

                                    <h4>Add My Template Prompt:</h4>
                                    <!-- <br> -->
                                    <button lay-on="ReloadTag" type="button" class="layui-btn layui-btn-sm layui-btn-normal reloadtc">
                                        Reload Tag
                                    </button>
                                    <!-- <button lay-on="ReloadCategory" type="button" class="layui-btn layui-btn-sm layui-btn-normal reloadtc">
                                        Reload Category
                                    </button> -->
                                    <input id="savetag" type="text" name="" placeholder="tag" class="layui-input" required>

                                    <hr class="ws-space-4">
                                    <input id="savecategory" type="text" name="" placeholder="category" class="layui-input" required>
                                    <hr class="ws-space-8">
                                    <input id="promptname" type="text" name="" placeholder="prompt name" class="layui-input" required>
                                    <hr class="ws-space-8">
                                    <button lay-on="saveprompt" class="layui-btn layui-btn-sm layui-btn-normal">SAVE</button>
                                    <button id="testprompt" lay-on="test" class="layui-btn layui-btn-sm layui-btn-normal">TEST</button>
                                    <button id="exportprompt" title="Export all prompts for backup" lay-on="exportprompt" class="layui-btn layui-btn-sm layui-btn-normal">EXPORT</button>
                                    <button title="Load all prompts from backup" lay-on="loadprompt" class="layui-btn layui-btn-sm layui-btn-normal">LOAD</button>
                                    <button title="bulk import prompts" lay-on="bulkimportprompt" class="layui-btn layui-btn-sm layui-btn-normal">Import</button>
                                    <hr class="ws-space-8">
                                    <div class="layui-card" id="tarea">
                                        <!-- 普通提示语容器模板 -->
                                        <div class="layui-card-body">
                                            <input type="text" name="" placeholder="name" class="layui-input">
                                            <hr class="ws-space-16">
                                            <textarea name="" placeholder="content" class="layui-textarea"></textarea>
                                            <button id="deletecomponent" lay-on="deletecomponent" container="tarea" type="button" class="layui-btn layui-btn-sm layui-btn-primary">
                                                <i class="layui-icon layui-icon-delete"></i>
                                            </button>
                                            <button lay-on="fullscreenedit" type="button" class="layui-btn layui-btn-sm layui-btn-primary">
                                                <i class="layui-icon layui-icon-add-circle"></i>
                                                Zoom Edit
                                            </button>
                                            <button lay-on="dispalytop" type="button" class="layui-btn layui-btn-sm layui-btn-primary dispalytopcss">
                                                <i class="layui-icon layui-icon-diamond"></i>
                                                Displayed at the top
                                            </button>
                                        </div>
                                    </div>
                                    <!-- 生成复杂提示语容器模板 -->
                                    <div class="layui-card" id="tareaxxx">
                                        <div class="layui-card-body">
                                            <input type="text" name="" placeholder="name" class="layui-input">
                                            <hr class="ws-space-16">
                                            <button lay-on="zoomineditinput" container="tarea" type="button" class="layui-btn layui-btn-sm layui-btn-primary">
                                                <i class="layui-icon layui-icon-add-circle"></i>
                                                Zoom In Edit
                                            </button>
                                            <div id="xxxcontainer" class="layui-card-body">
                                            </div>
                                            <button id="deletecomponent" lay-on="deletecomponent" container="tarea" type="button" class="layui-btn layui-btn-sm layui-btn-primary">
                                                <i class="layui-icon layui-icon-delete"></i>
                                            </button>
                                        </div>
                                    </div>
                                    <!-- 生成复杂提示语[]容器模板 -->
                                    <div class="layui-card" id="tareaxxx1">
                                        <div class="layui-card-body">
                                            <input type="text" name="" placeholder="name" class="layui-input">
                                            <hr class="ws-space-16">
                                            <div id="xxxcontainer" class="layui-card-body">
                                            </div>
                                            <button id="deletecomponent" lay-on="deletecomponent" container="tarea" type="button" class="layui-btn layui-btn-sm layui-btn-primary">
                                                <i class="layui-icon layui-icon-delete"></i>
                                            </button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="layui-col-md5">
                            <div style="padding-left: 15px;">
                                <button lay-on="addcomponent" type="button" class="layui-btn layui-btn-sm layui-btn-normal">
                                    <i class="layui-icon layui-icon-add-circle"></i> Add Requirements
                                </button>
                                <button id="tipshelp" lay-on="tipshelp" type="button" class="layui-btn layui-btn-sm layui-btn-normal">
                                    <i class="layui-icon layui-icon-help"></i> Tips&Help
                                </button>
                                <button lay-on="deleteallcomponents" type="button" class="layui-btn layui-btn-sm layui-btn-normal">
                                    <i class="layui-icon layui-icon-delete"></i> Delete All Requirements
                                </button>
                            </div>
                            <div style="padding-left: 15px;margin-top:10px;">
                                <button lay-on="quickpromptpart" type="button" class="layui-btn layui-btn-sm layui-btn-normal">
                                    <i class="layui-icon layui-icon-add-1"></i>
                                    Quick Prompt Part
                                </button>
                            </div>
                            <div style="padding-left: 15px;margin-top:10px;">
                                <span id="nowdisplaytop"></span>
                            </div>
                            <div id="container"></div>
                        </div>
                        <div class="layui-col-md4">
                            <div id="promptsrightbar" class="layui-card">
                                <div class="layui-card-header">Prompts</div>
                                <div class="layui-card-header" style="height: 64px;">
                                    <button title="Upload Prompts and Update For Your Server" lay-on="UploadPrompts" type="button" class="layui-btn layui-btn-sm layui-btn-normal">
                                        <i class="layui-icon layui-icon-upload-circle"></i> Upload For Your Server
                                    </button>
                                    <button title="Download Prompts, Sync From Your Server" lay-on="SyncPrompts" type="button" class="layui-btn layui-btn-sm layui-btn-normal">
                                        <i class="layui-icon layui-icon-download-circle"></i> Sync From Your Server
                                    </button>
                                    <button id="SyncPromptsFromContentaiseo" lay-on="SyncPromptsFromContentaiseo" type="button" class="layui-btn layui-btn-sm layui-btn-normal">
                                        <i class="layui-icon layui-icon-download-circle"></i> Sync From Content_ai_seo
                                    </button>
                                </div>
                                <div class="layui-card-body">
                                    <table lay-filter="tabletoolbar" class="layui-hide" id="ID-table-prompt-data"></table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="layui-tab-item layui-show">
                <?php
                $static_file = MY_PLUGIN_PATH . 'html/part/content-1.php';
                if (file_exists($static_file)) {
                    include $static_file; //include加载才支持php内嵌
                } else {
                    echo '<h1>Error</h1>';
                    echo '<p>Page not found</p>';
                }
                ?>
            </div>
            <div class="layui-tab-item">
                <?php
                $static_file = MY_PLUGIN_PATH . 'html/part/autoseo.php';
                if (file_exists($static_file)) {
                    include $static_file; //include加载才支持php内嵌
                } else {
                    echo '<h1>Error</h1>';
                    echo '<p>Page not found</p>';
                }
                ?>
            </div>
            <div class="layui-tab-item">
                <?php
                $static_file = MY_PLUGIN_PATH . 'html/part/rapid-generation.php';
                if (file_exists($static_file)) {
                    include $static_file; //include加载才支持php内嵌
                } else {
                    echo '<h1>Error</h1>';
                    echo '<p>Page not found</p>';
                }
                ?>
            </div>
            <div class="layui-tab-item">
                <?php
                $static_file = MY_PLUGIN_PATH . 'html/part/rapid-topic-generation.php';
                if (file_exists($static_file)) {
                    include $static_file; //include加载才支持php内嵌
                } else {
                    echo '<h1>Error</h1>';
                    echo '<p>Page not found</p>';
                }
                ?>
            </div>
            <div class="layui-tab-item">
                <?php
                $static_file = MY_PLUGIN_PATH . 'html/part/jobs_logs.php';
                if (file_exists($static_file)) {
                    include $static_file; //include加载才支持php内嵌
                } else {
                    echo '<h1>Error</h1>';
                    echo '<p>Page not found</p>';
                }
                ?>
            </div>
            <div class="layui-tab-item">
                <?php
                $static_file = MY_PLUGIN_PATH . 'html/part/setting.php';
                if (file_exists($static_file)) {
                    include $static_file; //include加载才支持php内嵌
                } else {
                    echo '<h1>Error</h1>';
                    echo '<p>Page not found</p>';
                }
                ?>
            </div>
            <!-- <div class="layui-tab-item">内容-5</div> -->
        </div>
    </div>

</body>
<script type="module">
    var editTag = ''
    var admin_mode = 1; //管理员模式为1，否则为0
    var user = `<?php $current_user = wp_get_current_user();
                echo $current_user->display_name; ?>`;
    window.globalvar = {
        user: user,
    }
    const db = new PromptDatabase();
    window.addEventListener("DOMContentLoaded", function() {
        layui.use(['table', 'form'], function() {
            var table = layui.table;
            var util = layui.util;
            var form = layui.form;
            var $ = layui.$;


            var updateable = (async () => {
                var data = []
                let list = await db.getAllPrompts()
                loadatatotable(table, list)
            })
            var updateableByTag = (async (tag) => {
                var data = []
                let list = await db.getAllPromptByTag(tag)
                loadatatotable(table, list)
            })

            updateable();

            util.on('lay-on', {
                tipshelp: async function(othis) {
                    layer.open({
                        title: 'TIPS',
                        type: 1,
                        area: ['420px', '240px'], // 宽高
                        content: '<div style="padding: 11px;">1,Try using [ ] to customize long text prompts, such as : <br>Make 5 distinct CTA messages and buttons for [Your product].Create a[social media] campaign planfor launching an[your product],aimed at[Your target audience].<br>2,Try using ## to customize select text prompts, such as : Create #USA, UK, HK# article titles </div>'
                    });
                },
                searchprompt: async function(othis) {
                    let data = []
                    let searchpromptinput = document.querySelector("#searchpromptinput").value
                    let list = await db.searchPrompt(searchpromptinput)
                    loadatatotable(table, list)
                },
                searchpromptag: async function(othis) {
                    let data = []
                    let searchpromptinput = document.querySelector("#searchpromptinputag").value
                    let list = await db.searchPromptag(searchpromptinput)
                    loadatatotable(table, list)
                },
                searchpromptcate: async function(othis) {
                    let data = []
                    let searchpromptinput = document.querySelector("#searchpromptinputcate").value
                    let list = await db.searchPromptcate(searchpromptinput)
                    loadatatotable(table, list)
                },
                restsearch: async function() {
                    updateable()
                },
                SyncPromptsFromContentaiseo: async function(othis) {

                    document.getElementById("exportprompt").click()
                    atip('sync', othis)

                    SyncPromptsFromContentaiseo(db)

                    // const postData = {
                    //     irequire: "prompt_table",
                    //     subr: "syncaiseo"
                    // };
                    // const url = '/wp-json/myseoai/v1/route';
                    // let r = await sendpost(postData, url)
                    // if (r['respond'] == '200') {

                    //     let prompts = r['dataresult']['data']
                    //     mlog(prompts, 'all prompts from office')
                    //     return
                    //     prompts.forEach(ele => {
                    //         db.addPrompt(ele)
                    //     });
                    // } else {
                    //     atip('download prompts error', othis)
                    // }
                },
                SyncPrompts: async function(othis) {
                    atip('sync', othis)
                    const postData = {
                        irequire: "prompt_table",
                        subr: "all"
                    };
                    const url = '/wp-json/myseoai/v1/route';
                    let r = await sendpost(postData, url)
                    if (r['respond'] == '200') {
                        r['dataresult'].forEach(ele => {
                            let e = {
                                name: ele['name'],
                                prompt: ele['prompt'],
                                category: ele['category'],
                                tag: ele['tag'],
                                user: ele['user'],
                                others: ele['others']
                            }
                            db.addPrompt(e)
                        });
                    }
                    updateable()

                },
                UploadPrompts: async function(othis) {
                    atip('upload', othis)
                    let allprompts = await db.getAllPrompts()

                    const postData = {
                        irequire: "updat_local_prompt_table",
                        allprompts: allprompts
                    };
                    const url = '/wp-json/myseoai/v1/route';
                    let r = await sendpost(postData, url)

                    if (isset(r)) {
                        alert(r['dataresult'])
                    }

                },
                quickpromptpart: function() {

                    quickpromptpartfunction('container')

                },
                addcomponent: function() {
                    addcomponetprompt({
                        'title': '',
                        'content': ''
                    }, "container")
                },
                deleteallcomponents: function(othis) {
                    const list = document.getElementById("container");
                    while (list.hasChildNodes()) {
                        list.removeChild(list.firstChild);
                    }
                },
                deletecomponent: function(othis) {
                    let id = othis[0].getAttribute("container");
                    document.getElementById(id).remove()
                },
                fullscreenedit: function(othis) {
                    var oldValue = othis[0].parentNode.querySelector("textarea").value;
                    // 获取原始 textarea 的值

                    // 打开弹窗
                    layer.open({
                        type: 1, // 页面层
                        title: 'edit',
                        area: ['500px', '500px'], // 宽高
                        content: '<textarea id="popupTextarea" class="layui-textarea" style="width:100%; height:80%;">' + oldValue + '</textarea>',
                        shade: 0,
                        btn: ['Save', 'Cancel'],
                        yes: function(index) {
                            // 获取弹窗内的 textarea 内容
                            var newValue = document.getElementById('popupTextarea').value;

                            // 将新值赋回原 textarea
                            othis[0].parentNode.querySelector("textarea").value = newValue;

                            // 关闭弹窗
                            layer.close(index);
                        }
                    });
                },
                dispalytop: function(othis) {
                    let title = othis[0].parentNode.querySelector("input").value
                    document.querySelector("#nowdisplaytop").innerHTML = `Display at the top: ${title}`
                    document.querySelector("#nowdisplaytop").style.display = 'block';
                    window.displaytop = title;
                    atip('done', othis)
                    layer.confirm('Save Prompt？', {
                        btn: ['Save', 'No'] //按钮
                    }, function() {
                        layer.msg('done', {
                            icon: 1
                        });
                        // 定位按钮
                        const saveButton = document.querySelector('button[lay-on="saveprompt"]');

                        // 检查按钮是否存在并点击
                        if (saveButton) {
                            saveButton.click();
                        } else {
                            console.log("Save button not found!");
                        }

                    }, function() {

                    });
                },
                exportprompt: function(othis) {
                    alert('export')
                    db.getAllPrompts().then((res) => {

                        exportjson(res, 'prompts.json')
                    })
                },
                loadprompt: function(othis) {


                    layer.open({
                        type: 1, // page 层类型
                        area: ['500px', '600px'],
                        title: 'Load Prompts From Backup',
                        shade: 0, // 遮罩透明度
                        maxmin: true, // 允许全屏最小化
                        anim: 0, // 0-6 的动画形式，-1 不开启
                        content: '<div id="LoadpromptContainer" style="padding: 32px;"><button id="submitForLoadPrompt" class="layui-btn-sm layui-bg-cyan">Submit</button><br><input type="file" id="fileInput" /></div>',
                        success: function(layero, index) {
                            document.getElementById('fileInput').addEventListener('change', function(event) {
                                const file = event.target.files[0]; // 获取用户选择的文件
                                if (file) {
                                    const reader = new FileReader();
                                    reader.onload = function(e) {
                                        try {
                                            const jsonData = JSON.parse(e.target.result);
                                            console.log(jsonData); // 输出读取的 JSON 数据
                                            const button = document.getElementById("submitForLoadPrompt")
                                            button.addEventListener('click', () => {

                                                document.getElementById("exportprompt").click()

                                                let prompts = jsonData
                                                prompts.forEach(ele => {
                                                    db.addPrompt(ele)
                                                });
                                                atip('Done', button)
                                            })
                                        } catch (error) {
                                            console.error('文件解析错误:', error);
                                        }
                                    };
                                    reader.readAsText(file); // 读取文件内容
                                }
                            });

                        }
                    });
                },
                bulkimportprompt: function(othis) {

                    // <button lay-on="submitprompt" class="layui-btn-sm layui-bg-cyan">Submit</button>
                    // <button lay-on="quickprompt" class="layui-btn-sm layui-bg-cyan">Quick Prompt Part</button>
                    // <button lay-on="addprompt" class="layui-btn-sm layui-bg-cyan">Add Part</button>
                    // <button lay-on="deleteall" class="layui-btn-sm layui-bg-cyan">Delete All Part</button>
                    // <div id="containerID" style="padding: 2px;"></div>

                    let layerdom = `<div id="applyprompt" style="padding: 32px;">
                                    <h2>Upload a CSV file of prompts</h2>
                                    <div><a style="color: green;" href="https://mtool.icu/csv_prompt_upload_bulk.csv">Download demo csv file</a></div>
                                    <input type="file" id="csvFile" accept=".csv">
                                    <button id="handleFileBulkImportPromptsButton" onclick="handleFileBulkImportPrompts()">Submit</button>
                                    <input type="text" id="tagInput" placeholder="Enter Tag">
                                    <input type="text" id="categoryInput" placeholder="Enter Category">
                                    <h3>Job Status：</h3>
                                    <pre id="output"></pre>
                                    </div>`

                    layer.open({
                        type: 1, // page 层类型
                        area: ['500px', '600px'],
                        title: 'Bulk Import Prompts',
                        shade: 0, // 遮罩透明度
                        maxmin: true, // 允许全屏最小化
                        anim: 0, // 0-6 的动画形式，-1 不开启
                        content: layerdom,
                        success: function(layero, index) {

                        }
                    });
                },
                RefreshPD: function(othis) {
                    location.reload(true);
                },
                ReloadCategory: function(othis) {

                },
                ReloadTag: async function(othis) {
                    let tag = document.querySelector('#savetag').value
                    let list = await db.getAllPromptByTag(tag)
                    loadatatotable(table, list)
                },
                deletetag: function(othis) {

                    let select = document.getElementById('tagSelect').value;

                    let index = layer.confirm(`delete ${select}`, {
                        btn: ['Yes', 'No'] //按钮
                    }, function() {
                        db.deleteByTag(select).then((res) => {
                            atip("Doned", othis)
                            layer.close(index);
                        })
                    }, function() {
                        atip("Nothing deleted")
                        layer.close(index);
                    });
                },
                bulkaddpromttosametag: function(othis) {
                    layer.open({
                        type: 1, // page 层类型
                        area: ['500px', '300px'],
                        title: 'Bulk add a prompt part to the prompt that have same the tag',
                        shade: 0, // 遮罩透明度
                        shadeClose: false, // 点击遮罩区域，关闭弹层
                        maxmin: true, // 允许全屏最小化
                        anim: 0, // 0-6 的动画形式，-1 不开启
                        content: ` <div class="layui-card" id="bulkaddpromttosametagcard">
                                        <div id="taskbulkaddpromttosametag" class=""></div>
                                        <div class="layui-card-body">
                                            <input id="bulkaddpromttosametagcardinput" type="text" name="" placeholder="name" class="layui-input">
                                            <hr class="ws-space-16">
                                            <textarea id="bulkaddpromttosametagcardtextarea" name="" placeholder="content" class="layui-textarea"></textarea>
                                            <button id="btusubmitbulkaddpromttosametag" lay-on="submitbulkaddpromttosametag" type="button" class="layui-btn layui-btn-sm layui-btn-primary">
                                                Submit
                                            </button>
                                            <button lay-on="cancelbulkaddpromttosametag" type="button" class="layui-btn layui-btn-sm layui-btn-primary">
                                                Cancel
                                            </button>
                                        </div>
                                    </div>`
                    });
                },
                submitbulkaddpromttosametag: function(othis) {
                    document.querySelector('#btusubmitbulkaddpromttosametag').disabled = true;

                    let tg = document.querySelector("#tagSelect").value
                    let newlabel = document.querySelector("#bulkaddpromttosametagcardinput").value
                    let newcontent = document.querySelector("#bulkaddpromttosametagcardtextarea").value

                    db.getAllPromptByTag(tg).then((res) => {

                        let updateremainder = res.length
                        if (updateremainder == 0) {
                            alert("please select a tag")
                            return
                        }
                        res.forEach((ele, index) => {

                            let prompt = JSON.parse(ele['prompt'])
                            prompt.push({
                                'title': newlabel,
                                'content': newcontent
                            })
                            prompt = JSON.stringify(prompt)
                            let promptdata = {
                                name: ele['name'],
                                prompt: prompt,
                                category: ele['category'],
                                tag: ele['tag'],
                                user: ele['user'],
                                others: ele['others']
                            }

                            setTimeout(() => {
                                updateremainder = updateremainder - 1
                                db.addPrompt(promptdata).then(response => {
                                    layer.tips(`${response},remainder:${updateremainder}`, this, {
                                        tips: 1
                                    });
                                    // updateable();
                                    updateableByTag(tg)
                                    if (updateremainder == 0) {
                                        document.querySelector("#taskbulkaddpromttosametag").innerHTML = "Task is completed! You can start another task now."
                                        document.querySelector('#btusubmitbulkaddpromttosametag').disabled = false;
                                    }
                                });
                            }, index * 3000);
                        });
                    })

                },
                cancelbulkaddpromttosametag: function(othis) {
                    document.querySelector(".layui-layer-close").click()
                },
                deletecate: function(othis) {

                    let select = document.getElementById('cateSelect').value;
                    let index = layer.confirm(`delete ${select}`, {
                        btn: ['Yes', 'No'] //按钮
                    }, function() {
                        db.deleteByCategory(select).then((res) => {
                            atip("Doned", othis)
                            layer.close(index);
                        })

                    }, function() {
                        atip("Nothing deleted")
                        layer.close(index);
                    });
                },
                saveprompt: async function(othis) {
                    var arr = []
                    let list = document.getElementById("container");
                    list = list.querySelectorAll(".layui-card");
                    list.forEach(ele => {
                        let title = ele.querySelector("input").value;
                        let content = ele.querySelector("textarea").value;
                        arr.push({
                            'title': title,
                            'content': content
                        })
                    });
                    var arr = JSON.stringify(arr);
                    const tagValue = document.getElementById('savetag').value;
                    const categoryValue = document.getElementById('savecategory').value;
                    const promptName = document.getElementById('promptname').value;
                    let others = 'none'
                    if (window.displaytop != undefined) {
                        // const others = `displaytop:${window.displaytop};`
                        others = window.displaytop
                    }
                    if (categoryValue == '' || tagValue == '' || promptName == '') {
                        alert('category, tage, prompt name cannot be empty ! ')
                        return;
                    }
                    let pn = await db.getPromptByName(promptName)
                    if (user == 'moring2023' && pn != undefined && admin_mode == 0) {
                        alert(`Can't change the official prompt, please change the prompt name.`)
                        return
                    }

                    let promptdata = {
                        name: promptName,
                        prompt: arr,
                        category: categoryValue,
                        tag: tagValue,
                        user: user,
                        others: others
                    }

                    db.addPrompt(promptdata).then(response => {
                        layer.tips(response, this, {
                            tips: 1
                        });
                        // updateable();
                        updateableByTag(editTag)

                    });

                    const postData = {
                        irequire: "prompt_table",
                        data: JSON.stringify(promptdata),
                        subr: "addupdate"
                    };
                    const url = '/wp-json/myseoai/v1/route';
                    let r = sendpost(postData, url)

                }
            });
            db.promptag.then(response => {

                    let dataSource = []
                    dataSource.push({
                        value: 'all',
                        text: 'all'
                    })
                    response.forEach((ele, key) => {

                        dataSource.push({
                            value: ele,
                            text: ele
                        })
                    });
                    // 获取目标 select 元素
                    let selectElement = document.getElementById('tagSelect');
                    // 调用函数填充选项
                    populateOptionsFromArray(dataSource, selectElement, 'tagSelect');
                    // 监听 select 的 change 事件
                    selectElement.addEventListener("change", async (event) => {
                        const selectedValue = event.target.value;

                        if (selectedValue === "all") {
                            updateable();
                        } else {
                            var data = []
                            let list = await db.getAllPromptByTag(selectedValue)
                            loadatatotable(table, list)
                        }
                    });
                })
                .catch(error => {
                    console.error(error); // 如果失败则输出: Failed to fetch data.
                })

            db.promptcate.then(response => {
                    let dataSource = []
                    dataSource.push({
                        value: 'all',
                        text: 'all'
                    })
                    response.forEach((ele, key) => {
                        dataSource.push({
                            value: ele,
                            text: ele
                        })
                    });
                    // 获取目标 select 元素
                    let selectElement = document.getElementById('cateSelect');
                    // 调用函数填充选项
                    populateOptionsFromArray(dataSource, selectElement, 'cateSelect');
                    // 监听 select 的 change 事件
                    selectElement.addEventListener("change", async (event) => {
                        const selectedValue = event.target.value;
                        if (selectedValue === "all") {
                            // alert("all")
                            document.getElementById("updatebutton").click()
                        } else {
                            db.getTagsByCategory(selectedValue).then((res) => {

                                let dataSource = []

                                res.forEach((ele, key) => {
                                    dataSource.push({
                                        value: ele,
                                        text: ele
                                    })
                                });
                                dataSource.push({
                                    value: 'all',
                                    text: 'all'
                                })
                                // 获取目标 select 元素
                                let selectElement = document.getElementById('tagSelect');
                                // 调用函数填充选项
                                populateOptionsFromArray(dataSource, selectElement, 'tagSelect');

                                db.getAllPromptByTag(dataSource[0]['value']).then((res) => {

                                    loadatatotable(table, res)
                                })
                                // 
                            })
                            // var data = []
                            // let list = await db.getAllPromptByCategory(selectedValue)
                            // loadatatotable(table, list)
                        }
                    });
                })
                .catch(error => {
                    console.error(error); // 如果失败则输出: Failed to fetch data.
                })

            // 动态生成选项
            function populateOptionsFromArray(data, target, t) {

                if (t == "cateSelect") {
                    target.innerHTML = '<option value="">Select Category</option>';
                } else if (t == 'tagSelect') {
                    target.innerHTML = '';
                }

                // 遍历数组并创建选项
                data.forEach(item => {
                    const option = document.createElement('option');
                    option.value = item.value;
                    option.textContent = item.text;
                    target.appendChild(option);
                });

                // 重新渲染 select
                form.render('select');
            }



        });
    });

    function loadatatotable(table, list) {
        var tdata = []
        list.forEach((ele, key) => {
            let m = {
                "id": key,
                "name": ele['name'],
                "prompt": ele['prompt'],
                "tag": ele['tag'],
                "category": ele['category'],
                "user": ele['user'],
                "others": ele['others']
            }
            tdata.unshift(m)

        });

        // 已知数据渲染
        var inst = table.render({
            elem: '#ID-table-prompt-data',
            cols: [
                [ //标题栏
                    {
                        title: 'Action',
                        width: 100,
                        toolbar: '#table-operations'
                    },
                    // {
                    //     field: 'id',
                    //     title: 'ID',
                    //     width: 60,
                    //     sort: true
                    // },
                    {
                        field: 'name',
                        title: 'name',
                        width: 180
                    },
                    {
                        field: 'prompt',
                        title: 'prompt',
                        minWidth: 120
                    },
                    {
                        field: 'tag',
                        title: 'tag',
                        width: 80
                    },
                    {
                        field: 'category',
                        title: 'category',
                        width: 100
                    },
                    {
                        field: 'user',
                        title: 'user',
                        width: 80,

                    },
                    {
                        field: 'others',
                        title: 'others',
                        width: 50,

                    },

                ]
            ],
            data: tdata,
            //skin: 'line', // 表格风格
            // even: true,
            page: true, // 是否显示分页
            // limits: [5, 10, 15],
            limit: 20 // 每页默认显示的数量
        });
        // 监听工具条事件
        table.on('tool(tabletoolbar)', function(obj) {
            var data = obj.data; // 当前行的数据
            var event = obj.event; // lay-event 的值
            if (event === 'edit') {
                // alert('编辑操作，数据为：' + JSON.stringify(data));
                editTag = data.tag
                const list = document.getElementById("container");
                while (list.hasChildNodes()) {
                    list.removeChild(list.firstChild);
                }
                let arrdata = JSON.parse(data.prompt)

                // arrdata = sortJsonArray(arrdata)

                arrdata = moveToTop(arrdata, 'title', data.others)
                // arrdata.reverse()
                arrdata.forEach(ele => {
                    addcomponetprompt(ele)
                });
                document.getElementById('savetag').value = data.tag;
                document.getElementById('savecategory').value = data.category;
                document.getElementById('promptname').value = data.name;

            } else if (event === 'delete') {
                layer.confirm('Confirm?', function(index) {

                    const postData = {
                        irequire: "prompt_table",
                        data: data.name,
                        subr: "delete"
                    };
                    const url = '/wp-json/myseoai/v1/route';
                    let r = sendpost(postData, url)
                    // if (r['respond'] == '200') {
                    db.deletePromptByName(data.name)
                    obj.del(); // 删除对应行（前端界面）
                    layer.close(index);
                    // }
                });
            } else if (event === "favorite") {
                const myCache = new LocalStorageCache('favorite_prompt', 20); // 缓存数组最大长度为 10
                // // 添加数据
                let r = myCache.add({
                    name: data.name
                });
                if (r == true) {
                    alert('Favorited', obj)
                } else {
                    alert('Already favorited', obj)
                }
            }
        });
    }
</script>
<?php xaicontentseo(); ?>
<script type="text/html" id="table-operations">
    <div class="layui-clear-space">
        <a title="copy/edit" class="layui-btn layui-btn-xs" lay-event="edit" onclick="changeColor(this)">C/E</a>
        <a title="delete" class="layui-btn layui-btn-danger layui-btn-xs" lay-event="delete" onclick="changeColor(this)">D</a>
        <a title="favorite" class="layui-btn layui-bg-orange layui-btn-xs" lay-event="favorite" onclick="changeColor(this)">F</a>
        <!-- <a class="layui-btn layui-btn-xs" lay-event="edit" onclick="changeColor(this)">Copy/Edit</a>
        <a class="layui-btn layui-btn-danger layui-btn-xs" lay-event="delete" onclick="changeColor(this)">Delete</a>
        <a class="layui-btn layui-bg-orange layui-btn-xs" lay-event="favorite" onclick="changeColor(this)">Favorite</a> -->
    </div>
</script>
<script type="text/html" id="table-operations-custom-promptpart">
    <div class="layui-clear-space">
        <a title="edit or copy prompt part" class="layui-btn layui-btn-xs" lay-event="editpromptpart">E/C</a>
        <a title="delete prompt part" class="layui-btn layui-btn-danger layui-btn-xs" lay-event="deletepromptpart">D</a>

    </div>
</script>
<script>
    function changeColor(element) {
        // 移除所有按钮的 'active' 样式
        var buttons = document.querySelectorAll('.layui-btn');
        buttons.forEach(function(btn) {
            btn.classList.remove('active');
        });

        // 给被点击的按钮添加 'active' 样式
        element.classList.add('active');
    }

    // Example usage

    //检测缓存数据库dexie prompts表是否加载了数据
    document.addEventListener('DOMContentLoaded', () => {
        let db = new PromptDatabase();
        db.checkPromptCount().then(result => {
            console.log('Prompt count result:', result); // Logs 0 if less than 10, otherwise the actual count
            if (result == 0) {
                layer.msg('loading the AI prompts,please wait!')
                SyncPromptsFromContentaiseo(db)
            }
        });
    });
</script>

<style>
    #tarea {
        display: none;
    }

    .layui-textarea {
        min-height: 72px;
    }

    .select-c {
        display: block;
        padding: 4px 0px;
    }

    .layui-btn.active {
        background-color: #ff5722;
        /* 点击后的背景色 */
        color: #fff;
        /* 点击后的文字颜色 */
    }

    .layui-card-header {
        padding: 10px 0px;
    }

    .layui-card-body {
        padding: 10px 0px;
    }

    #promptsrightbar .layui-card-header {
        padding: 0 15px;
    }

    #promptsrightbar .layui-btn {
        margin-left: 0;
    }

    @media (max-width: 1340px) {
        #promptcontainer .layui-btn-sm {
            font-size: 8px;
            height: 20px;
            line-height: 20px;
            padding: 0 4px;

        }
    }

    @media (max-width: 1024px) {
        #promptcontainer .layui-btn-sm {
            font-size: 7px;
            height: 17px;
            line-height: 17px;
            padding: 0 3px;


        }
    }

    @media (max-width: 412px) {
        #promptcontainer .layui-btn-sm {
            font-size: 6px;

        }
    }

    .reloadtc {
        margin: 10px 0;
    }
</style>

</html>